/*******************************************************************************
*
* File:         S20_demo.c
* Description:  ϵͳļ
* Version:      V0.1
* Date:         2020-02-22
* Author:       Tempest
 *******************************************************************************/

#include "ap_demo.h"
#include "ArmCM0.h"
#include "tau_device_datatype.h"
#include "tau_log.h"
#include "tau_operations.h"
#include "tau_common.h"
#include "tau_delay.h"
#include "hal_dsi_rx_ctrl.h"
#include "hal_dsi_tx_ctrl.h"
#include "hal_swire.h"
#include "hal_timer.h"
#include "hal_system.h"
#include "hal_gpio.h"
#include "hal_pwm.h"
#include "app_tp_st_touch.h"
#include "test_cfg_global.h"

#include "app_tp_transfer.h"
#ifdef LOG_TAG
    #undef LOG_TAG
#endif
#define LOG_TAG "S21U_demo"

/*****************************************/

//S8 MIPIϢ
/* ֱ */
#define INPUT_WIDTH  1080 //1440
#define INPUT_HEIGHT 2400 //3200
/*  MIPI lane rate,video modeҪȷãcmd mode */
#define INPUT_MIPI_LANE_RATE      1400000000 //1525000000 //1400000000//1200000000  //898000000
/* ͼʽ */
#define INPUT_COLOR_MODE DSI_RGB888
/* ݸʽ(DSI_DATA_CMD_MODE , DSI_DATA_VIDEO_MODE) */
#define INPUT_DATA_MODE DSI_DATA_CMD_MODE
/* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
#define INPUT_MIPI_LANE_NUM DSI_LANE_4
/* Ϊvideo mode ʱݸʽ */
#define INPUT_VIDEO_MODEL DSI_NONBURST_EVENT
/* ͨ(0-3) */
#define INPUT_VC DSI_VC_0
/* ֡(60/90/120/144Hz) */
#define INPUT_FRAME_RATE DSI_FRAME_RATE_60HZ
/* ǷDSCѹ */
#define INPUT_COMPRESS true

#if AMOLED_NT37701_CSOT667
	/* ֱ */
	#define OUTPUT_WIDTH   1200
	#define OUTPUT_HEIGHT  2652
	/* ͨ(0-3) */
	#define OUTPUT_VC DSI_VC_0
	/* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
	#define OUTPUT_LANE_NUMBER DSI_LANE_4
	/* Ϊvideo mode ݸʽ */
	#define OUTPUT_VIDEO_MODEL DSI_NONBURST_PULSE
#if 0
    /*  VSA */
    #define OUTPUT_VSA  2//32//2
    /*  VBP */
    #define OUTPUT_VBP  84//128//64
    /*  VBP */
    #define OUTPUT_VFP  62	 
    /*  VSA */
    #define OUTPUT_HSA  4
    /*  HBP */
    #define OUTPUT_HBP  16
    /*  HFP */
    #define OUTPUT_HFP  18
    /* ʼģʽ */
    #define _CMD_TYPE            DSI_CMD_TX_LP      //0-HS,1-LP;
#else
	#define OUTPUT_VSA  8 //4
	/*  VBP */
	#define OUTPUT_VBP  8
	/*  VBP */
	#define OUTPUT_VFP  56//72
	/*  VSA */
	#define OUTPUT_HSA  8//8
	/*  HBP */
	#define OUTPUT_HBP  20//12//92
	/*  HFP */
	#define OUTPUT_HFP  80//120//100
	/* ʼģʽ */
	#define _CMD_TYPE            DSI_CMD_TX_LP      //0-HS,1-LP;
	//֡
	#define OUTPUT_FRAME_RATE  58
#endif

#endif


#define SWIRE_TIMER           TIMER_NUM1
#define TE_TIMER              TIMER_NUM2
#define ENABLE_TP_WAKE_UP     true
#define SWIRE_MAX_NUM        24
#define SYNC_LINE            2000 

#if ENABLE_TP_WAKE_UP
	static bool g_need_enter_sleep_mode = false;
	#define POWER_IO_A IO_PAD_TD_LEDPWM     /* ӦIOҪ */
	#define POWER_IO_B IO_PAD_TD_SPIM_MISO  /* ӦIOҪ */
#endif
//#define DISPLAY_ONLY
#define CUS_SCLD_FILTER true
#define NEW_ACK_CMD_FUNC true

/******************************************************/
static hal_dsi_rx_ctrl_handle_t *g_rx_ctrl_handle = NULL;
static hal_dsi_tx_ctrl_handle_t *g_tx_ctrl_handle = NULL;
//S20  SWIRE=50->ELVSS=-1.7V
#define SWIRE_DEFAULT_NUM       50
 
#define ADD_TP_CALIBRATION      1
#define AUTO_CAL_TP             0
#define RUN_TEST                0

#define AVDD_SWIRE             ( IO_PIN_A5 )
#define AP_SWIRE               ( IO_PIN_A6 )


#if ADD_TP_CALIBRATION
static volatile bool g_calibration_flag = false;
#endif	

#ifdef RUN_TEST
static uint8_t g_run_test_cnt = 0;   //leo
#endif

#if AUTO_CAL_TP
static uint16_t g_cal_cnt = 300;    //3sʱTPУ׼
#endif

static uint8_t swire_num = SWIRE_DEFAULT_NUM;
static uint8_t swire_num_bak = SWIRE_DEFAULT_NUM;

/* Ĭfalse,ʼ־λ,ʹTP1.8V,AC ʼҪTP1.8Vе */
static volatile bool start_display_on = true;
static bool g_exit_sleep_mode = false;


/* ʼɱ־λ */
static bool panel_display_done = false;
//static bool g_panel_init_done = false;
static volatile bool g_resolution_change = false;
static void swire_init(void);
void Gpio_swire_output(uint8_t flag, uint8_t num);

#ifdef USE_FOR_SUMSUNG_S21U
extern uint8_t Flag_blacklight_EN;
extern uint8_t tp_sleep_in;
extern uint8_t tp_sleep_count;
uint8_t phone_start_flag = 0;
uint16_t phone_DisplayOFF_count=0;
uint8_t phone_DisplayOFF_flag=0;
#endif

bool s_restart_flag = false;


bool s_pps_updata_allpixeloff_flag = false;
uint32_t BaseTime = 0;

extern bool s_screen_init_complate;
uint32_t s_heartbeat = 0;

uint32_t curFrame = 0;

#if ENABLE_TP_WAKE_UP
static void ap_reset_cb(void *data)
{
	/* лԴ */
	//    hal_gpio_set_output_data_ex(POWER_IO_B, IO_LVL_HIGH, POWER_IO_A, IO_LVL_LOW);
	hal_gpio_set_output_data(POWER_IO_A, IO_LVL_LOW);
	/* VCC */
	TAU_LOGD("system reset!");
	hal_system_set_pvd(true);
	hal_system_set_vcc(true);
	NVIC_SystemReset();
}
#endif


#if CUS_SCLD_FILTER

/// ȽϺ

/* 720 * 1600 */
uint32_t rx_filter_1080_h_4_96[32][2] =
{
    0xB029EC0A, 0x0000000F,
    0x904DF003, 0x0000000F,
    0x6871F9FB, 0x0000000F,
    0x4899FBF4, 0x0000000F,
    0x28C1FDED, 0x0000000F,
    0x08EDFBE7, 0x0000000F,
    0xE119FDE0, 0x0000000E,
    0xC145F9DB, 0x0000000E,
    0xA175F3D6, 0x0000000E,
    0x81A9EBD1, 0x0000000E,
    0x69D9E1CD, 0x0000000E,
    0x520DD5C9, 0x0000000E,
    0x3A3DC7C7, 0x0000000E,
    0x2A71B7C4, 0x0000000E,
    0x1A9DA7C3, 0x0000000E,
    0x12CD93C2, 0x0000000E,
    0x12F97DC2, 0x0000000E,
    0x132567C2, 0x0000000E,
    0x1B4D4FC3, 0x0000000E,
    0x236D39C5, 0x0000000E,
    0x3B8D1FC7, 0x0000000E,
    0x4BA907CA, 0x0000000E,
    0x6BC0EDCD, 0x0000000E,
    0x8BD4D5D0, 0x0000000E,
    0xB3E4BBD4, 0x0000000E,
    0xDBF0A3D8, 0x0000000E,
    0x03F88DDC, 0x0000000F,
    0x3BF477E1, 0x0000000F,
    0x6BF861E5, 0x0000000F,
    0xA3F44DE9, 0x0000000F,
    0xDBF039ED, 0x0000000F,
    0x1BE027F2, 0x00000000
};


uint32_t rx_filter_2400_v_4_96[32][2] =
{
    0xB029EC0A, 0x0000000F,
    0x904DF003, 0x0000000F,
    0x6871F9FB, 0x0000000F,
    0x4899FBF4, 0x0000000F,
    0x28C1FDED, 0x0000000F,
    0x08EDFBE7, 0x0000000F,
    0xE119FDE0, 0x0000000E,
    0xC145F9DB, 0x0000000E,
    0xA175F3D6, 0x0000000E,
    0x81A9EBD1, 0x0000000E,
    0x69D9E1CD, 0x0000000E,
    0x520DD5C9, 0x0000000E,
    0x3A3DC7C7, 0x0000000E,
    0x2A71B7C4, 0x0000000E,
    0x1A9DA7C3, 0x0000000E,
    0x12CD93C2, 0x0000000E,
    0x12F97DC2, 0x0000000E,
    0x132567C2, 0x0000000E,
    0x1B4D4FC3, 0x0000000E,
    0x236D39C5, 0x0000000E,
    0x3B8D1FC7, 0x0000000E,
    0x4BA907CA, 0x0000000E,
    0x6BC0EDCD, 0x0000000E,
    0x8BD4D5D0, 0x0000000E,
    0xB3E4BBD4, 0x0000000E,
    0xDBF0A3D8, 0x0000000E,
    0x03F88DDC, 0x0000000F,
    0x3BF477E1, 0x0000000F,
    0x6BF861E5, 0x0000000F,
    0xA3F44DE9, 0x0000000F,
    0xDBF039ED, 0x0000000F,
    0x1BE027F2, 0x00000000
};

/* 1080 * 2400 */
uint32_t rx_filter_1080_h_4_86[32][2] =
{
    0x0889B622, 0x0000000F,
    0xF0A9BA1B, 0x0000000E,
    0xD8C9BC15, 0x0000000E,
    0xC8EDBC0E, 0x0000000E,
    0xB10DBE08, 0x0000000E,
    0xA131BE01, 0x0000000E,
    0x9155BDFB, 0x0000000E,
    0x817DB9F5, 0x0000000E,
    0x79A1B3F0, 0x0000000E,
    0x69C5B1EA, 0x0000000E,
    0x69EDA5E6, 0x0000000E,
    0x62119FE1, 0x0000000E,
    0x623595DD, 0x0000000E,
    0x6A5989D9, 0x0000000E,
    0x727D7BD6, 0x0000000E,
    0x7A9D6FD3, 0x0000000E,
    0x8ABD5FD1, 0x0000000E,
    0x9ADD4FCF, 0x0000000E,
    0xB2F53FCE, 0x0000000E,
    0xCB112DCD, 0x0000000E,
    0xEB291BCC, 0x0000000E,
    0x0B3D09CC, 0x0000000F,
    0x3348F7CD, 0x0000000F,
    0x5360E3CD, 0x0000000F,
    0x8364D1CF, 0x0000000F,
    0xAB70BFD0, 0x0000000F,
    0xDB78ABD2, 0x0000000F,
    0x0B7C99D4, 0x00000000,
    0x437C87D6, 0x00000000,
    0x737877D9, 0x00000000,
    0xAB7865DB, 0x00000000,
    0xDB7455DE, 0x00000000
};


uint32_t rx_filter_2400_v_4_69[32][2] =
{
    0xE8FD4A3F, 0x0000000E,
    0xE9114A3A, 0x0000000E,
    0xF1214A35, 0x0000000E,
    0xF9354830, 0x0000000E,
    0x0149462B, 0x0000000F,
    0x095D4227, 0x0000000F,
    0x116D4222, 0x0000000F,
    0x21813C1E, 0x0000000F,
    0x31953819, 0x0000000F,
    0x41A53415, 0x0000000F,
    0x51B92E11, 0x0000000F,
    0x61C92C0C, 0x0000000F,
    0x79D92409, 0x0000000F,
    0x89E92005, 0x0000000F,
    0xA1F91A01, 0x0000000F,
    0xBA0913FE, 0x0000000F,
    0xD2190DFA, 0x0000000F,
    0xF22505F7, 0x0000000F,
    0x0A34FDF4, 0x00000000,
    0x2A40F5F1, 0x00000000,
    0x4A48EDEF, 0x00000000,
    0x6258E5EC, 0x00000000,
    0x8A5CDDEA, 0x00000000,
    0xAA68D3E8, 0x00000000,
    0xCA70CBE6, 0x00000000,
    0xF278C1E4, 0x00000000,
    0x1284B7E2, 0x00000001,
    0x3A84AFE1, 0x00000001,
    0x5A8CA5E0, 0x00000001,
    0x82909BDF, 0x00000001,
    0xAA9491DE, 0x00000001,
    0xD29489DD, 0x00000001
};

/* 1440 * 3200 */
uint32_t rx_filter_1440_h_4_72[32][2] =
{
    0xD0ED603B, 0x0000000E,
    0xD1055E36, 0x0000000E,
    0xD1195E31, 0x0000000E,
    0xD9315A2C, 0x0000000E,
    0xD9455C26, 0x0000000E,
    0xE15D5821, 0x0000000E,
    0xE971561C, 0x0000000E,
    0xF1855218, 0x0000000E,
    0x019D4C13, 0x0000000F,
    0x09B14A0E, 0x0000000F,
    0x19C5440A, 0x0000000F,
    0x29D93E06, 0x0000000F,
    0x39ED3A01, 0x0000000F,
    0x520131FE, 0x0000000F,
    0x6A112BFA, 0x0000000F,
    0x822523F6, 0x0000000F,
    0x9A351BF3, 0x0000000F,
    0xB24513F0, 0x0000000F,
    0xD25509ED, 0x0000000F,
    0xF26101EA, 0x0000000F,
    0x0A74F7E7, 0x00000000,
    0x327CEDE5, 0x00000000,
    0x5288E3E3, 0x00000000,
    0x7294D9E1, 0x00000000,
    0x9A98CFE0, 0x00000000,
    0xC2A4C3DE, 0x00000000,
    0xE2ACB9DD, 0x00000000,
    0x0AB0AFDC, 0x00000001,
    0x32B8A3DB, 0x00000001,
    0x62B499DB, 0x00000001,
    0x8ABC8DDA, 0x00000001,
    0xB2BC83DA, 0x00000001
};


uint32_t rx_filter_3200_v_4_59[32][2] =
{
    0x69190E46, 0x0000000F,
    0x71250E42, 0x0000000F,
    0x81310A3F, 0x0000000F,
    0x913D083B, 0x0000000F,
    0xA1490637, 0x0000000F,
    0xB1510434, 0x0000000F,
    0xC15D0230, 0x0000000F,
    0xD168FE2D, 0x0000000F,
    0xE170FE29, 0x0000000F,
    0xF17CFA26, 0x0000000F,
    0x0988F423, 0x00000000,
    0x1990F220, 0x00000000,
    0x3198EE1D, 0x00000000,
    0x41A4EC19, 0x00000000,
    0x59ACE816, 0x00000000,
    0x71B4E413, 0x00000000,
    0x89BCDE11, 0x00000000,
    0x99C8DA0E, 0x00000000,
    0xB1D0D60B, 0x00000000,
    0xC9D8D208, 0x00000000,
    0xE9DCCC06, 0x00000000,
    0x01E4C803, 0x00000001,
    0x19E8C401, 0x00000001,
    0x31F4BFFE, 0x00000001,
    0x49FCB9FC, 0x00000001,
    0x69FCB5FA, 0x00000001,
    0x8204AFF8, 0x00000001,
    0xA208A9F6, 0x00000001,
    0xBA0CA5F4, 0x00000001,
    0xDA109FF2, 0x00000001,
    0xFA1499F0, 0x00000001,
    0x121C93EE, 0x00000002
};


#endif
static bool ap_dcs_read(uint8_t data_type, uint8_t dcs_cmd, uint8_t param)
{
//	static uint8_t read_7F_count = 0;
//	static uint8_t read_A1_count =0;
    uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);
    ////TAU_LOGD("rv[%x] [%d] !!\n", dcs_cmd, return_size);   //debug

    if(dcs_cmd == 0xDA)
    {
        phone_DisplayOFF_flag = 1;
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0x91);
    }
    else if(dcs_cmd == 0xDB)
    {
        phone_DisplayOFF_flag = 1;
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0x26);
    }
    else if(dcs_cmd == 0xDC)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0xE8);
    }
    else if(dcs_cmd == 0x04)    //leo 20221126
    {
        if(return_size == 3)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         3, 0x91, 0x26, 0xE8);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0xA1)
    {
        if(return_size == 4)    //leo 20221126
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         4,  0x0B, 0xEA, 0x0C, 0x92);
        }
        else if(return_size == 7)   //leo 20221126
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         7, 0xA5, 0x0C, 0x02, 0x09, 0x18, 0x12, 0x8E);
        }
        else if(return_size == 20)   //leo 20221126
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         20,
                                         0x30, 0x01, 0x01, 0xCA, 0x41, 0x33, 0x58, 0x56, 0x38, 0x53, 0x31, 0x34, 0x33, 0x34, 0x4A, 0x42,
                                         0x49, 0x30, 0x36, 0x38);
        }
        else if(return_size == 10)
        {
            static uint8_t read_A1_count = 0;

            if(read_A1_count == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10, 0x0B, 0xEA, 0x0C, 0x8C, 0xA6, 0x16, 0x10, 0x1D, 0x26, 0x10);
                read_A1_count = 1;
            }
            else if(read_A1_count == 1)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10, 0x30, 0x01, 0x01, 0xCB, 0x41, 0x33, 0x58, 0x56, 0x38, 0x53);
                read_A1_count = 2;
            }
            else if(read_A1_count == 2)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10, 0x31, 0x34, 0x44, 0x4D, 0x4B, 0x42, 0x41, 0x30, 0x37, 0x34);
                read_A1_count = 0;
            }
        }
        else if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x1, 0x3D);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0xD6)
    {
//		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
//									 DSI_ACK_DT_DSC_LONG_RESPONSE,
//									 DSI_VC_0,
//									 5, 0x79,0x4D,0xB4,0x38,0xAA);
        //leo 20221126
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_LONG_RESPONSE,
                                     DSI_VC_0,
                                     5, 0x8B, 0x8E, 0xB0, 0xE8, 0x14);

    }
    else if(dcs_cmd == 0xC2)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0x16);
    }
    else if(dcs_cmd == 0x0F)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0xC0);
    }
    else if(dcs_cmd == 0xEE)
    {
        if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x1, 0x00);
        }
        else if(return_size == 2)    //leo ? ,ҪԭװץݣG998д
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x2, 0xC2, 0x01);
        }
        else
        {
            TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0x05)
    {
        if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x1, 0x80);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0xF4)
    {
        if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x1, 0x22);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0xC8)
    {
        if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x1, 0x00);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0x6E)    //leo 20221126
    {
        static uint8_t read_6e_10 = 0;
        static uint8_t read_6e_24 = 0;
        static uint8_t read_6e_38 = 0;
        static uint8_t read_6e_52 = 0;
        static uint8_t read_6e_66 = 0;
        static uint8_t read_6e_70 = 0;

        uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);

        if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         1, 0x80);
        }

        else if(return_size == 10)
        {
            if(read_6e_10 == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10,
                                             0x00, 0x00, 0x43, 0x43, 0x43, 0x00, 0x00, 0x51, 0x58, 0x43);
                read_6e_10 = 1;
            }
            else
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10,
                                             0x01, 0x11, 0x17, 0x17, 0x17, 0x00, 0x00, 0x6C, 0x76, 0x58);
            }
        }
        else if(return_size == 24)
        {
            if(read_6e_24 == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             24,
                                             0x00, 0x00, 0x43, 0x43, 0x43, 0x00, 0x00, 0x51, 0x58, 0x43, 0x00, 0x00, 0x58, 0x5F, 0x4A, 0x00,
                                             0x00, 0x6A, 0x71, 0x5C, 0x00, 0x00, 0x8E, 0x95);
                read_6e_24 = 1;
            }
            else
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             24,
                                             0x01, 0x11, 0x17, 0x17, 0x17, 0x00, 0x00, 0x6C, 0x76, 0x58, 0x00, 0x00, 0x73, 0x7D, 0x5F, 0x00,
                                             0x00, 0x84, 0x8E, 0x71, 0x00, 0x00, 0xA8, 0xB2);
            }
        }
        else if(return_size == 38)
        {
            if(read_6e_38 == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             38,
                                             0x00, 0x00, 0x43, 0x43, 0x43, 0x00, 0x00, 0x51, 0x58, 0x43, 0x00, 0x00, 0x58, 0x5F, 0x4A, 0x00,
                                             0x00, 0x6A, 0x71, 0x5C, 0x00, 0x00, 0x8E, 0x95, 0x80, 0x00, 0x00, 0xAD, 0xB4, 0x9F, 0x01, 0x10,
                                             0x09, 0x10, 0xFD, 0x01, 0x11, 0x66);
                read_6e_38 = 1;
            }
            else
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             38,
                                             0x01, 0x11, 0x17, 0x17, 0x17, 0x00, 0x00, 0x6C, 0x76, 0x58, 0x00, 0x00, 0x73, 0x7D, 0x5F, 0x00,
                                             0x00, 0x84, 0x8E, 0x71, 0x00, 0x00, 0xA8, 0xB2, 0x95, 0x00, 0x00, 0xC7, 0xD0, 0xB4, 0x01, 0x11,
                                             0x22, 0x2B, 0x10, 0x01, 0x11, 0x7D);
            }
        }
        else if(return_size == 52)
        {
            if(read_6e_52 == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             52,
                                             0x00, 0x00, 0x43, 0x43, 0x43, 0x00, 0x00, 0x51, 0x58, 0x43, 0x00, 0x00, 0x58, 0x5F, 0x4A, 0x00,
                                             0x00, 0x6A, 0x71, 0x5C, 0x00, 0x00, 0x8E, 0x95, 0x80, 0x00, 0x00, 0xAD, 0xB4, 0x9F, 0x01, 0x10,
                                             0x09, 0x10, 0xFD, 0x01, 0x11, 0x66, 0x6C, 0x5A, 0x01, 0x11, 0xE1, 0xE7, 0xD6, 0x02, 0x22, 0xF7,
                                             0xFC, 0xEE, 0x04, 0x44);
                read_6e_52 = 1;
            }
            else
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             52,
                                             0x01, 0x11, 0x17, 0x17, 0x17, 0x00, 0x00, 0x6C, 0x76, 0x58, 0x00, 0x00, 0x73, 0x7D, 0x5F, 0x00,
                                             0x00, 0x84, 0x8E, 0x71, 0x00, 0x00, 0xA8, 0xB2, 0x95, 0x00, 0x00, 0xC7, 0xD0, 0xB4, 0x01, 0x11,
                                             0x22, 0x2B, 0x10, 0x01, 0x11, 0x7D, 0x86, 0x6C, 0x01, 0x11, 0xF7, 0xFF, 0xE7, 0x03, 0x32, 0x09,
                                             0x0F, 0xFC, 0x04, 0x44);
            }
        }
        else if(return_size == 66)
        {
            if(read_6e_66 == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             66,
                                             0x00, 0x00, 0x43, 0x43, 0x43, 0x00, 0x00, 0x51, 0x58, 0x43, 0x00, 0x00, 0x58, 0x5F, 0x4A, 0x00,
                                             0x00, 0x6A, 0x71, 0x5C, 0x00, 0x00, 0x8E, 0x95, 0x80, 0x00, 0x00, 0xAD, 0xB4, 0x9F, 0x01, 0x10,
                                             0x09, 0x10, 0xFD, 0x01, 0x11, 0x66, 0x6C, 0x5A, 0x01, 0x11, 0xE1, 0xE7, 0xD6, 0x02, 0x22, 0xF7,
                                             0xFC, 0xEE, 0x04, 0x44, 0xE5, 0xE7, 0xDF, 0x06, 0x66, 0x76, 0x77, 0x73, 0x07, 0x77, 0xFF, 0xFF,
                                             0xFF, 0x09);
                read_6e_66 = 1;
            }
            else
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             66,
                                             0x01, 0x11, 0x17, 0x17, 0x17, 0x00, 0x00, 0x6C, 0x76, 0x58, 0x00, 0x00, 0x73, 0x7D, 0x5F, 0x00,
                                             0x00, 0x84, 0x8E, 0x71, 0x00, 0x00, 0xA8, 0xB2, 0x95, 0x00, 0x00, 0xC7, 0xD0, 0xB4, 0x01, 0x11,
                                             0x22, 0x2B, 0x10, 0x01, 0x11, 0x7D, 0x86, 0x6C, 0x01, 0x11, 0xF7, 0xFF, 0xE7, 0x03, 0x32, 0x09,
                                             0x0F, 0xFC, 0x04, 0x44, 0xF0, 0xF4, 0xE7, 0x06, 0x66, 0x7B, 0x7D, 0x77, 0x07, 0x77, 0xFF, 0xFF,
                                             0xFF, 0x08);
            }
        }
        else if(return_size == 70)
        {
            if(read_6e_70 == 0)
            {
//				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
//											DSI_ACK_DT_DSC_LONG_RESPONSE,
//											DSI_VC_0,
//											70,
//											0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43,0x00,0x00,0x58,0x5F,0x4A,0x00,
//											0x00,0x6A,0x71,0x5C,0x00,0x00,0x8E,0x95,0x80,0x00,0x00,0xAD,0xB4,0x9F,0x01,0x10,
//											0x09,0x10,0xFD,0x01,0x11,0x66,0x6C,0x5A,0x01,0x11,0xE1,0xE7,0xD6,0x02,0x22,0xF7,
//											0xFC,0xEE,0x04,0x44,0xE5,0xE7,0xDF,0x06,0x66,0x76,0x77,0x73,0x07,0x77,0xFF,0xFF,
//											0xFF,0x09,0x9B,0xEB,0x38,0xBF);

                //G988B
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             70,
                                             0x00, 0x00, 0xC2, 0xC2, 0xC2, 0x00, 0x00, 0x53, 0x5A, 0x44, 0x00, 0x00, 0x5A, 0x61, 0x4B, 0x00,
                                             0x00, 0x6C, 0x73, 0x5D, 0x00, 0x00, 0x90, 0x97, 0x81, 0x00, 0x00, 0xAF, 0xB5, 0xA0, 0x01, 0x10,
                                             0x0B, 0x12, 0xFE, 0x01, 0x11, 0x68, 0x6E, 0x5B, 0x01, 0x11, 0xE3, 0xE9, 0xD7, 0x02, 0x22, 0xF8,
                                             0xFD, 0xEE, 0x04, 0x44, 0xE5, 0xE8, 0xDF, 0x06, 0x66, 0x76, 0x77, 0x73, 0x07, 0x77, 0xFF, 0xFF,
                                             0xFF, 0x0A, 0x9C, 0x26, 0x6A, 0x0E);

                read_6e_70 = 1;
            }
            else
            {
//				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
//											DSI_ACK_DT_DSC_LONG_RESPONSE,
//											DSI_VC_0,
//											70,
//											0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58,0x00,0x00,0x73,0x7D,0x5F,0x00,
//											0x00,0x84,0x8E,0x71,0x00,0x00,0xA8,0xB2,0x95,0x00,0x00,0xC7,0xD0,0xB4,0x01,0x11,
//											0x22,0x2B,0x10,0x01,0x11,0x7D,0x86,0x6C,0x01,0x11,0xF7,0xFF,0xE7,0x03,0x32,0x09,
//											0x0F,0xFC,0x04,0x44,0xF0,0xF4,0xE7,0x06,0x66,0x7B,0x7D,0x77,0x07,0x77,0xFF,0xFF,
//											0xFF,0x08,0x79,0x75,0xDE,0xFA);
                //G988B
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             70,
                                             0x01, 0x11, 0x95, 0x95, 0x95, 0x00, 0x00, 0x70, 0x7C, 0x5A, 0x00, 0x00, 0x77, 0x83, 0x61, 0x00,
                                             0x00, 0x88, 0x94, 0x73, 0x00, 0x00, 0xAC, 0xB8, 0x97, 0x00, 0x00, 0xCA, 0xD6, 0xB5, 0x01, 0x11,
                                             0x26, 0x30, 0x12, 0x01, 0x11, 0x81, 0x8B, 0x6E, 0x01, 0x21, 0xFA, 0x04, 0xE9, 0x03, 0x32, 0x0B,
                                             0x13, 0xFD, 0x04, 0x44, 0xF1, 0xF6, 0xE8, 0x06, 0x66, 0x7C, 0x7E, 0x77, 0x07, 0x77, 0xFF, 0xFF,
                                             0xFF, 0x08, 0x8A, 0xB9, 0x14, 0x57);
            }
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0x0A)
    {
        if(return_size == 3)
        {
            //G988BϵҪص
//			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
//									 DSI_ACK_DT_DSC_LONG_RESPONSE,
//									 DSI_VC_0,
//									 3, 0x99,0x99,0x99);

            //G988BҪص
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         3, 0x9D, 0x9D, 0x9D);

        }
        else if(return_size == 1)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         0x1, 0x9F);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
    else if(dcs_cmd == 0xEA)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_LONG_RESPONSE,
                                     DSI_VC_0,
                                     5, 0x00, 0x00, 0x00, 0x00, 0x00);
    }
    else if(dcs_cmd == 0x87)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0x00);
    }
    else if(dcs_cmd == 0xFE)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0xC0);
    }
    else if(dcs_cmd == 0x5A)
    {
        if(return_size == 39)
        {
            static uint8_t read_5a_39 = 0;
            if(read_5a_39 < 2)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             39,
                                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
                read_5a_39++;
            }
            else if(read_5a_39 < 6)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             39,
                                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x4F, 0x00, 0x28, 0x00, 0x48,
                                             0x00, 0x60, 0x00, 0x4F, 0x00, 0x28, 0x00, 0x48, 0x00, 0x60, 0x00, 0x4F, 0x00, 0x28, 0x00, 0x48,
                                             0x00, 0x60, 0x00, 0x4F, 0x00, 0x28, 0x48);
                read_5a_39++;
            }
            else
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             39,
                                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x4F, 0x00, 0x29, 0x00, 0x48,
                                             0x00, 0x60, 0x00, 0x4F, 0x00, 0x29, 0x00, 0x48, 0x00, 0x60, 0x00, 0x4F, 0x00, 0x29, 0x00, 0x48,
                                             0x00, 0x60, 0x00, 0x4F, 0x00, 0x29, 0x48);
            }
        }
        else
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                         DSI_VC_0,
                                         1, 0);
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }

    //----
    else if(dcs_cmd == 0x0E)
    {
    	 if (return_size == 3)
       { 
       		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_LONG_RESPONSE,
                                     DSI_VC_0,
                                     3, 0x80, 0x80, 0x80);
       	}
	   else
	   	{
	   		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     0x1, 0x81);
	   	}
        
    }
    else if(dcs_cmd == 0xEE)
    {
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     1, 0x00);
    }
    else if(dcs_cmd == 0xE9)
    {
       if (return_size == 5)
       { 
       		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_LONG_RESPONSE,
                                     DSI_VC_0,
                                     5, 0x05, 0x05, 0x05, 0x05, 0x05);
       	}
	   else
	   	{
	   		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_2B,
                                     DSI_VC_0,
                                     2, 0x05, 0x05);
	   	}
    }
    /*
    	else if (dcs_cmd == 0xB5)// ?
    	{
    		uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);

    		if (return_size == 0x0A)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43);
    		}
    		else if (return_size == 0x18)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43,
    			0x00,0x00,0x58,0x5F,0x4A,0x00,0x00,0x6A,0x71,0x5C,
    			0x00,0x00,0x8E,0x95);
    		}
    		else if (return_size == 0x26)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43,
    			0x00,0x00,0x58,0x5F,0x4A,0x00,0x00,0x6A,0x71,0x5C,
    			0x00,0x00,0x8E,0x95,0x80,0x00,0x00,0xAD,0xB4,0x9F,
    			0x01,0x10,0x09,0x10,0xFD,0x01,0x11,0x66);
    		}
    		else if (return_size == 0x34)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43,
    			0x00,0x00,0x58,0x5F,0x4A,0x00,0x00,0x6A,0x71,0x5C,
    			0x00,0x00,0x8E,0x95,0x80,0x00,0x00,0xAD,0xB4,0x9F,
    			0x01,0x10,0x09,0x10,0xFD,0x01,0x11,0x66,0x6C,0x5A,
    			0x01,0x11,0xE1,0xE7,0xD6,0x02,0x22,0xF7,0xFC,0xEE,
    			0x04,0x44);
    		}
    		else if (return_size == 0x42)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43,
    			0x00,0x00,0x58,0x5F,0x4A,0x00,0x00,0x6A,0x71,0x5C,
    			0x00,0x00,0x8E,0x95,0x80,0x00,0x00,0xAD,0xB4,0x9F,
    			0x01,0x10,0x09,0x10,0xFD,0x01,0x11,0x66,0x6C,0x5A,
    			0x01,0x11,0xE1,0xE7,0xD6,0x02,0x22,0xF7,0xFC,0xEE,
    			0x04,0x44,0xE5,0xE7,0xDF,0x06,0x66,0x76,0x77,0x73,
    			0x07,0x77,0xFF,0xFF,0xFF,0x09);
    		}
    			else if (return_size == 0x46)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x00,0x00,0x43,0x43,0x43,0x00,0x00,0x51,0x58,0x43,
    			0x00,0x00,0x58,0x5F,0x4A,0x00,0x00,0x6A,0x71,0x5C,
    			0x00,0x00,0x8E,0x95,0x80,0x00,0x00,0xAD,0xB4,0x9F,
    			0x01,0x10,0x09,0x10,0xFD,0x01,0x11,0x66,0x6C,0x5A,
    			0x01,0x11,0xE1,0xE7,0xD6,0x02,0x22,0xF7,0xFC,0xEE,
    			0x04,0x44,0xE5,0xE7,0xDF,0x06,0x66,0x76,0x77,0x73,
    			0x07,0x77,0xFF,0xFF,0xFF,0x09,0x9B,0xEB,0x38,0xBF);
    		}
    	}
    	else if (dcs_cmd == 0xC8)  //?
    	{
    		uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);

    		if (return_size == 0x0A)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58);
    		}
    		else if (return_size == 0x18)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58,
    			0x00,0x00,0x73,0x7D,0x5F,0x00,0x00,0x84,0x8E,0x71,
    			0x00,0x00,0xA8,0xB2);
    		}
    		else if (return_size == 0x26)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58,
    			0x00,0x00,0x73,0x7D,0x5F,0x00,0x00,0x84,0x8E,0x71,
    			0x00,0x00,0xA8,0xB2,0x95,0x00,0x00,0xC7,0xD0,0xB4,
    			0x01,0x11,0x22,0x2B,0x10,0x01,0x11,0x7D);
    		}
    		else if (return_size == 0x34)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58,
    			0x00,0x00,0x73,0x7D,0x5F,0x00,0x00,0x84,0x8E,0x71,
    			0x00,0x00,0xA8,0xB2,0x95,0x00,0x00,0xC7,0xD0,0xB4,
    			0x01,0x11,0x22,0x2B,0x10,0x01,0x11,0x7D,0x86,0x6C,
    			0x01,0x11,0xF7,0xFF,0xE7,0x03,0x32,0x09,0x0F,0xFC,
    			0x04,0x44);
    		}
    		else if (return_size == 0x42)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58,
    			0x00,0x00,0x73,0x7D,0x5F,0x00,0x00,0x84,0x8E,0x71,
    			0x00,0x00,0xA8,0xB2,0x95,0x00,0x00,0xC7,0xD0,0xB4,
    			0x01,0x11,0x22,0x2B,0x10,0x01,0x11,0x7D,0x86,0x6C,
    			0x01,0x11,0xF7,0xFF,0xE7,0x03,0x32,0x09,0x0F,0xFC,
    			0x04,0x44,0xF0,0xF4,0xE7,0x06,0x66,0x7B,0x7D,0x77,
    			0x07,0x77,0xFF,0xFF,0xFF,0x08);
    		}
    			else if (return_size == 0x46)
    		{
    			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
    										 DSI_ACK_DT_DSC_LONG_RESPONSE,
    										 DSI_VC_0,
    										 return_size,
    			0x01,0x11,0x17,0x17,0x17,0x00,0x00,0x6C,0x76,0x58,
    			0x00,0x00,0x73,0x7D,0x5F,0x00,0x00,0x84,0x8E,0x71,
    			0x00,0x00,0xA8,0xB2,0x95,0x00,0x00,0xC7,0xD0,0xB4,
    			0x01,0x11,0x22,0x2B,0x10,0x01,0x11,0x7D,0x86,0x6C,
    			0x01,0x11,0xF7,0xFF,0xE7,0x03,0x32,0x09,0x0F,0xFC,
    			0x04,0x44,0xF0,0xF4,0xE7,0x06,0x66,0x7B,0x7D,0x77,
    			0x07,0x77,0xFF,0xFF,0xFF,0x08,0x79,0x75,0xDE,0xFA);
    		}
    	}
    */
    else if(dcs_cmd == 0x7F)
    {
        uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);
        if(return_size == 10)
        {
            static uint8_t read_7F_count = 0;

            if(read_7F_count == 0)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10, 0x20, 0x44, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
                read_7F_count = 1;
            }
            else if(read_7F_count == 1)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10, 0x00, 0x03, 0x01, 0xC1, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00);
                read_7F_count = 2;
            }
            else if(read_7F_count == 2)
            {
                hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                             DSI_ACK_DT_DSC_LONG_RESPONSE,
                                             DSI_VC_0,
                                             10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
                read_7F_count = 0;
            }
        }
        else if(return_size == 4)   //G988Bָ
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         4, 0x00, 0x00, 0x000, 0x00);
        }
        else if(return_size == 3)
        {
            hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                         DSI_ACK_DT_DSC_LONG_RESPONSE,
                                         DSI_VC_0,
                                         3, 0x00, 0x00, 0x00);
        }
        else
        {
            //TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
        }
    }
		else if (dcs_cmd == 0x01)
		{ 
        ap_get_tp_calibration_status_01(g_rx_ctrl_handle,param);
    } 
    else
    {
        uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);
        hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
                                     DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
                                     DSI_VC_0,
                                     1, 0);
        TAU_LOGD("r[%x] [%d] err!!!!!!", dcs_cmd, return_size);
    }
//	TAU_LOGD("r[%x] [%d] err!!!!!!", dcs_cmd, return_size);
    return true;
}


#if 0
//720*1600
const uint8_t pps_1[88] = { 0x11, 0x00, 0x00, 0x89, 0x30, 0x80, 0x06, 0x40, 0x02, 0xD0, 0x00, 0x50, 0x01, 0x68, 0x01, 0x68,
                            0x02, 0x00, 0x01, 0xB4, 0x00, 0x20, 0x06, 0x2F, 0x00, 0x05, 0x00, 0x0C, 0x01, 0x38, 0x01, 0xE9,
                            0x18, 0x00, 0x10, 0xF0, 0x03, 0x0C, 0x20, 0x00, 0x06, 0x0B, 0x0B, 0x33, 0x0E, 0x1C, 0x2A, 0x38,
                            0x46, 0x54, 0x62, 0x69, 0x70, 0x77, 0x79, 0x7B, 0x7D, 0x7E, 0x01, 0x02, 0x01, 0x00, 0x09, 0x40,
                            0x09, 0xBE, 0x19, 0xFC, 0x19, 0xFA, 0x19, 0xF8, 0x1A, 0x38, 0x1A, 0x78, 0x1A, 0xB6, 0x2A, 0xF6,
                            0x2B, 0x34, 0x2B, 0x74, 0x3B, 0x74, 0x6B, 0xF4
                          };

//1080*2400
const uint8_t pps_2[88] = { 0x11, 0x00, 0x00, 0x89, 0x30, 0x80, 0x09, 0x60, 0x04, 0x38, 0x00, 0x28, 0x02, 0x1C, 0x02, 0x1C,
                            0x02, 0x00, 0x02, 0x0E, 0x00, 0x20, 0x03, 0xDD, 0x00, 0x07, 0x00, 0x0C, 0x02, 0x77, 0x02, 0x8B,
                            0x18, 0x00, 0x10, 0xF0, 0x03, 0x0C, 0x20, 0x00, 0x06, 0x0B, 0x0B, 0x33, 0x0E, 0x1C, 0x2A, 0x38,
                            0x46, 0x54, 0x62, 0x69, 0x70, 0x77, 0x79, 0x7B, 0x7D, 0x7E, 0x01, 0x02, 0x01, 0x00, 0x09, 0x40,
                            0x09, 0xBE, 0x19, 0xFC, 0x19, 0xFA, 0x19, 0xF8, 0x1A, 0x38, 0x1A, 0x78, 0x1A, 0xB6, 0x2A, 0xF6,
                            0x2B, 0x34, 0x2B, 0x74, 0x3B, 0x74, 0x6B, 0xF4
                          };

//1440*3200
const	uint8_t pps_3[88] = { 0x11, 0x00, 0x00, 0x89, 0x30, 0x80, 0x0C, 0x80, 0x05, 0xA0, 0x00, 0x28, 0x02, 0xD0, 0x02, 0xD0,
                              0x02, 0x00, 0x02, 0x68, 0x00, 0x20, 0x04, 0x6C, 0x00, 0x0A, 0x00, 0x0C, 0x02, 0x77, 0x01, 0xE9,
                              0x18, 0x00, 0x10, 0xF0, 0x03, 0x0C, 0x20, 0x00, 0x06, 0x0B, 0x0B, 0x33, 0x0E, 0x1C, 0x2A, 0x38,
                              0x46, 0x54, 0x62, 0x69, 0x70, 0x77, 0x79, 0x7B, 0x7D, 0x7E, 0x01, 0x02, 0x01, 0x00, 0x09, 0x40,
                              0x09, 0xBE, 0x19, 0xFC, 0x19, 0xFA, 0x19, 0xF8, 0x1A, 0x38, 0x1A, 0x78, 0x1A, 0xB6, 0x2A, 0xF6,
                              0x2B, 0x34, 0x2B, 0x74, 0x3B, 0x74, 0x6B, 0xF4
                          };
#endif

/* PPS update callback ڷֱлcase */
static bool pps_update_handle(uint8_t *pps, uint8_t size, uint32_t pic_width, uint32_t pic_height)
{
	/* AVDD ϵ, ڽϢPPS */
//	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
		
    if (pic_width != g_rx_ctrl_handle->base_info.src_w || pic_height != g_rx_ctrl_handle->base_info.src_h)
    {
		//hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
        /* PPS Update ҷֱʷ仯 */
				hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x22);
				s_pps_updata_allpixeloff_flag = true;
			  	BaseTime = hal_system_get_tick();
        		g_rx_ctrl_handle->base_info.src_w = pic_width;
        		g_rx_ctrl_handle->base_info.src_h = pic_height;
		/* עⲿֻPPSǰ Compression Mode Command */
        g_rx_ctrl_handle->compress_en = true; //hal_dsi_rx_ctrl_get_compressen_en(g_rx_ctrl_handle);
				g_tx_ctrl_handle->base_info.src_w = pic_width;
				g_tx_ctrl_handle->base_info.src_h = pic_height;
		
//		hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
				hal_dsi_rx_ctrl_toggle_resolution_ex(g_rx_ctrl_handle);
//				delayMs(20);
//				hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x13);
	#if 0 
		if (pic_width == 720 && pic_height == 1600)
		{
			hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps_1, 88); 
		}
		else if (pic_width == 1080 && pic_height == 2400)
		{
			//hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps_2, 88); 
		}
		else if (pic_width == 1440 && pic_height == 3200)
		{
			//hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps_3, 88);;
		}
	#endif
		//hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
//		TAU_LOGD("resolution update w[%d] h[%d] compress[%d]", pic_width, pic_height, g_rx_ctrl_handle->compress_en);
    #if CUS_SCLD_FILTER // ݲͬķֱʣѡͬ //
        if( 720 == pic_width )
        {
            hal_dsi_rx_ctrl_set_cus_scld_filter( g_rx_ctrl_handle, rx_filter_1080_h_4_96, rx_filter_2400_v_4_96 );
        }
        else if( 1080 == pic_width )
        {
            hal_dsi_rx_ctrl_set_cus_scld_filter( g_rx_ctrl_handle, rx_filter_1080_h_4_86, rx_filter_2400_v_4_69 );
        }
        else 
        {
            hal_dsi_rx_ctrl_set_cus_scld_filter( g_rx_ctrl_handle, rx_filter_1440_h_4_72, rx_filter_3200_v_4_59 );
        }
        
    #endif
    
    }
	
    TAU_LOGD("PPS Update"); 
    return true;
}


static bool ap_set_display_on(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	TAU_LOGD("disp on");
	return true;
}

static bool ap_set_display_off(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x28);
	TAU_LOGD("disp off");
	
//#if ENABLE_TP_WAKE_UP
//	hal_gpio_set_output_data(POWER_IO_A, IO_LVL_HIGH);
//#endif
    return true;
}


static bool ap_set_enter_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
	
	Gpio_swire_output(0, 0);
	delayMs(50);
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x10);
	delayMs(20);
	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);
	
	TAU_LOGD("enter sleep mode");
 
#if ENABLE_TP_WAKE_UP
	g_need_enter_sleep_mode = true;
#endif
	g_exit_sleep_mode = false;
	
    return true;
}

static bool ap_set_exit_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	TAU_LOGD("exit sleep mode");
	g_exit_sleep_mode = true;

	/* AVDD ϵ, ڽϢPPS */
	//hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
	//hal_dsi_tx_ctrl_write_cmd(0x05, 0, 2, 0x11);
	return true;
}

/*****************************************************************************
*GPIOswire
*flag:  =0, SWIRE=0;  =1,SWIREź; =2, øٷSWIREź
*num: 
*עFLAG=1ʱGPIOʼ!!!!!!
*****************************************************************************/
void Gpio_swire_output(uint8_t flag, uint8_t num)
{
	uint8_t ii;

	if (flag)
	{
		if (flag ==2)
		{
			hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_HIGH);	  
			//hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
			delayMs(20);
		}
		for (ii =0; ii< num; ii++)
		{
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_LOW);
			delayUs(10);
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
			delayUs(9);
		}
	}
	else
	{
		hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_LOW);	  
	}
}



#if 1 // 0:test
#ifdef ADD_PWM_OUTPUT_FOR_BL

/*****************************************************************************
* @brief  pwmԿƱ
* @param  init:     ǷΪʼһαѡʼ
* @param  polarity: ԣfalse:ȸߺͣtrue:ȵͺ
* @param  duty_ratio: ռձ(0-100)
* @param  frequency: ƵʣλHZ
* @retval null
*****************************************************************************/
static void test_pwm_out_adjust(bool init, bool polarity, uint8_t duty_ratio, uint32_t frequency)
{
    pwm_out_ctrl_e ctl0 = PWMO_CTRL_HIGH;
    pwm_out_ctrl_e ctl1 = PWMO_CTRL_LOW;
    if (polarity)
    {
        ctl0 = PWMO_CTRL_LOW;
        ctl1 = PWMO_CTRL_HIGH;
    }
    uint32_t period = 1000000 / frequency; //λus
    uint32_t thr0 = 0;
    uint32_t thr1 = (period * duty_ratio / 100);

    if (duty_ratio == 100)
    {
        ctl1 = ctl0;
        thr1 = period / 2;
    }
    if (init)
    {
        hal_pwm_out_init();
        hal_pwm_out_config_all(ctl0, ctl1, thr0, thr1, period);
    }
    else
    {
        hal_pwm_out_sync_all(ctl0, ctl1, thr0, thr1, period);
    }
}

void PWM_OUTPUT_TEST(void)
{
    test_pwm_out_adjust(true, true, 30, 20000);
    delayMs(2);
    test_pwm_out_adjust(false, false, 40, 10000);
}

#define PWM_PERIOD     1000     //PWM.λUS
#define PWM_MIN		   8		//Сֵɵ
static void PWM_init(void)
{
	// 1ms ڳʼ͵ƽ1000
	hal_pwm_out_init();
	hal_pwm_out_config_all(PWMO_CTRL_LOW, PWMO_CTRL_HIGH, 0, PWM_PERIOD, PWM_PERIOD);
}

static uint16_t read_bl_data =0;
static uint16_t read_bl_data_bak =0;
void PWM_Task(void)
{
uint16_t pwm_h;

#ifdef USE_FOR_SUMSUNG_S21U
	
#if AMOLED_NT37701_CSOT667
	// s20: read_bl_data = 1~FD
	uint8_t reg51_val_h=0;
	uint8_t reg51_val_l=0;
	if(Flag_blacklight_EN)
	{
		read_bl_data_bak =0;
//		hal_pwm_out_sync_thr(0, PWM_PERIOD+1);
		hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, 0x00, 0x3F);  
//		printf("Flag_blacklight_EN!!!! read_bl_data[%4x] \n", read_bl_data);
		return;
	}

	if (g_need_enter_sleep_mode)
	{
		//ΪϨʱ
		read_bl_data_bak =0;
//		hal_pwm_out_sync_thr(0, PWM_PERIOD-PWM_MIN); //ΪС
		hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, 0x00, 0x3F);  
//		printf("tp_sleep_in!!!! read_bl_data[%4x] \n", read_bl_data);
//		return;
	}
	
	if(read_bl_data !=read_bl_data_bak)
	{
#if 0	
	#if 1//Բ
		if (pwm_h >700)
			pwm_h = 300+(pwm_h-700)*7/3;
		else
			pwm_h = 1+(pwm_h-1)*3/7;
	#endif
		if(pwm_h <PWM_MIN)
			pwm_h =PWM_MIN;
	
		//printf("ok!!!! read_bl_data[%4x],pwm_h[%d] \n", read_bl_data, pwm_h);

		if(pwm_h <PWM_PERIOD)
			pwm_h = PWM_PERIOD-pwm_h;
		else
			pwm_h = 1;		
		//hal_pwm_out_sync_thr(0, pwm_h);
#endif	
		
		pwm_h = read_bl_data*16;  //NT37701 51  (0~FFF)
		reg51_val_l= ( uint8_t )pwm_h;
		reg51_val_h= pwm_h>>8;
		hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, reg51_val_h, reg51_val_l);  //0FFF
		read_bl_data_bak =read_bl_data;
	}

#else
// s20: read_bl_data = 1~FD

	if(Flag_blacklight_EN)
	{
		read_bl_data_bak =0;
		hal_pwm_out_sync_thr(0, PWM_PERIOD+1);
		//printf("Flag_blacklight_EN!!!! read_bl_data[%4x] \n", read_bl_data);
		return;
	}

	if (g_need_enter_sleep_mode)
	{
		//ΪϨʱ
		read_bl_data_bak =0;
		hal_pwm_out_sync_thr(0, PWM_PERIOD-PWM_MIN); //ΪС
//		printf("tp_sleep_in!!!! read_bl_data[%4x] \n", read_bl_data);
	//	return;
	}
	
	if(read_bl_data !=read_bl_data_bak)
	{
		pwm_h = PWM_PERIOD*read_bl_data/0xFF;
	#if 1//Բ
		if (pwm_h >700)
			pwm_h = 300+(pwm_h-700)*7/3;
		else
			pwm_h = 1+(pwm_h-1)*3/7;
	#endif
		if(pwm_h <PWM_MIN)
			pwm_h =PWM_MIN;
	
		//printf("ok!!!! read_bl_data[%4x],pwm_h[%d] \n", read_bl_data, pwm_h);

		if(pwm_h <PWM_PERIOD)
			pwm_h = PWM_PERIOD-pwm_h;
		else
			pwm_h = 1;
		hal_pwm_out_sync_thr(0, pwm_h);
		read_bl_data_bak =read_bl_data;
	}
	
#endif	
	
#endif

}
#endif

/* B1ص      g_cus_rx_dcs_execute_table Ϊ첽ִУCAͬ*/

uint16_t value_reg_b1 =0;
uint16_t value_reg_ca =0;
//static uint32_t value_reg_b5 =0;
static uint32_t value_reg_df =0;
static uint8_t value_blue =0;
static uint8_t blue_flag =0;
#if 1 //
#define BLUE_MAX			0xF0	//ֵ
#define BLUE_MIN			0x86	//Сֵ
#define BLUE_STEP			10		//ȼ-1
#endif

#if 1//def USE_FOR_SUMSUNG_S21U
static uint32_t s20_power_on_flag =0;   // >0: Ϊǡʱ
uint16_t value_reg_ca_bak =0;
uint16_t value_reg_b1_bak =0;
//#define USE_BL_ADJ6  //֮ǰS20ⷽʽ
#define USE_BL_ADJ7    //ĹS20ⷽʽ
#endif

static uint8_t R60_Parma_backup = 0x00;
 static bool ap_update_frame_rate(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
#if 0
	static uint8_t frame_rate = 100;
	if (frame_rate != dcs_packet->packet_param[0])
	{
		frame_rate = dcs_packet->packet_param[0];	
		if (frame_rate == 0x00)
		{
			hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LINE, TE_HW_MODE);
		}
		else
		{
			//0x08 120Hz
			hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LINE, TE_SOFT_120HZ_MODE);
		}
		//TAU_LOGD("frame_rate:%02x", frame_rate); 
	}
#else

        if (R60_Parma_backup != dcs_packet->packet_param[0])
        {
            R60_Parma_backup = dcs_packet->packet_param[0];

            if (R60_Parma_backup == 0x08)
            {
                hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, g_rx_ctrl_handle->base_info.src_h, TE_SOFT_120HZ_MODE);
            }

            else
            {
                hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, g_rx_ctrl_handle->base_info.src_h, TE_HW_MODE);
                //hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle,2000,TE_SOFT_120HZ_MODE);
            }
        }

#endif
    
	return true;
}

#if 1 //
static bool ap_set_backlight_51(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
#if 1 // video mode
	uint16_t rd_51_val, rd_51_val2;

	rd_51_val = dcs_packet->packet_param[0];
	rd_51_val = (rd_51_val<<8);
	rd_51_val |= dcs_packet->packet_param[1];
	rd_51_val2 = (rd_51_val-0x04)*1945/2043+0x66;

	if (rd_51_val2 < 0x220 && rd_51_val2 > 0x1B3){	
		rd_51_val2 = 0x1B3; 
	}
//	TAU_LOGD("51[%04X][%04X]", rd_51_val, rd_51_val2);

	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, rd_51_val2>>8, rd_51_val2&0x00FF);

#else
	uint8_t cmd_data[2];

    cmd_data[0] = dcs_packet->packet_param[0];
    cmd_data[1] = dcs_packet->packet_param[1];
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, cmd_data[0], cmd_data[1]);
	//TAU_LOGD("51:[%x]", (cmd_data[0]<<8)|cmd_data[1]);
#endif	
    return true;
}	

static bool ap_set_backlight(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    /* AP  0xC  0xb8d , ʱ0xC,ƽҪһŻ */
	uint8_t temp_u8;

	value_reg_b1 = (dcs_packet->packet_param[0] << 8) + dcs_packet->packet_param[1];
	////TAU_LOGD("CA[%4x],B1[%4x]", value_reg_ca, value_reg_b1);

#ifdef USE_BL_ADJ7

#ifdef ADD_PWM_OUTPUT_FOR_BL
	if (value_reg_b1 &0x8000)
	{
		// 60Hz	
		if(value_reg_ca >0x15FE)
		{
			read_bl_data = 0xFF;
		}
		else if(value_reg_ca >=0x1550)
		{
			// value_reg_ca =0x1550Ӧ105(ǵ⼶Ϊ256)
			read_bl_data = 105+(value_reg_ca-0x1550)*150/175;
		}
		else
		{
			//value_reg_b1_bak=0xC65~0x1E4Ӧ1~104
			if (value_reg_b1_bak>0xC65)
				read_bl_data =1;
			else if (value_reg_b1_bak<0x1E4)
				read_bl_data =104;
			else
				read_bl_data = 1+(0xC65-value_reg_b1_bak)*103/2689;
		}
	}	
	else if (value_reg_b1 &0x4000)
	{
		// 120Hz	
		if(value_reg_ca >0x15AD)
		{
			read_bl_data = 0xFF;
		}
		else if(value_reg_ca >=0x150F)
		{
			// value_reg_ca =0x15AD~0x150FӦ256~109(ǵ⼶Ϊ256)
			read_bl_data = 109+(value_reg_ca-0x150F)*146/158;
		}
		else
		{
			//value_reg_b1_bak=0xC54~0x1E4Ӧ1~108
			if (value_reg_b1_bak>0xC54)
				read_bl_data =1;
			else if (value_reg_b1_bak<0x1E4)
				read_bl_data =108;
			else
				read_bl_data = 1+(0xC54-value_reg_b1_bak)*107/2672;
		}
	}	
	else
	{
		value_reg_b1_bak = value_reg_b1;
		if ((value_reg_ca ==0x2A00) &&(value_reg_b1 >0x500))
			s20_power_on_flag =1; 
		else
			s20_power_on_flag =0;
	}


#else
	if (value_reg_b1 &0x8000)
	{
	//Ϊ60Hz		
		if(value_reg_ca >0x15FC)
		{
			swire_num = SWIRE_MAX_NUM;
		}
		else if(value_reg_ca >0x15ED)
		{
			swire_num = SWIRE_MAX_NUM+1;
		}
		else if(value_reg_ca >0x15DD)
		{
			swire_num = SWIRE_MAX_NUM+2;
		}
		else if(value_reg_ca >0x15CC)
		{
			swire_num = SWIRE_MAX_NUM+3;
		}
		else if(value_reg_ca >0x15BE)
		{
			swire_num = SWIRE_MAX_NUM+4;
		}
		else if(value_reg_ca >0x15AC)
		{
			swire_num = SWIRE_MAX_NUM+5;
		}
		else if(value_reg_ca >0x159A)
		{
			swire_num = SWIRE_MAX_NUM+6;
		}
		else if(value_reg_ca >0x155E)
		{
			swire_num = SWIRE_MAX_NUM+7;
		}
		else
		{
			if(value_reg_b1_bak <0x500)
			{
				swire_num = SWIRE_MAX_NUM+8;
			}
			else if(value_reg_b1_bak <0x900)
			{
				swire_num = SWIRE_MAX_NUM+9;
			}
			else if(value_reg_b1_bak <0xAE0)
			{
				swire_num = SWIRE_MAX_NUM+10;
			}
			else if(value_reg_b1_bak <0xBE8)
			{
				swire_num = SWIRE_MAX_NUM+11;
			}
			else if(value_reg_b1_bak <0xC38)
			{
				swire_num = SWIRE_MAX_NUM+12;
			}
			else
			{
				swire_num = SWIRE_MAX_NUM+13;
			}
		}
	}
	else if (value_reg_b1 &0x4000)
	{
	//Ϊ120Hz		
		if(value_reg_ca >0x15AC)
		{
			swire_num = SWIRE_MAX_NUM;
		}
		else if(value_reg_ca >0x159A)
		{
			swire_num = SWIRE_MAX_NUM+1;
		}
		else if(value_reg_ca >0x158B)
		{
			swire_num = SWIRE_MAX_NUM+2;
		}
		else if(value_reg_ca >0x157B)
		{
			swire_num = SWIRE_MAX_NUM+3;
		}
		else if(value_reg_ca >0x156A)
		{
			swire_num = SWIRE_MAX_NUM+4;
		}
		else if(value_reg_ca >0x1559)
		{
			swire_num = SWIRE_MAX_NUM+5;
		}
		else if(value_reg_ca >0x1547)
		{
			swire_num = SWIRE_MAX_NUM+6;
		}
		else if(value_reg_ca >0x1510)
		{
			swire_num = SWIRE_MAX_NUM+7;
		}
		else
		{
			if(value_reg_b1_bak <0x500)
			{
				swire_num = SWIRE_MAX_NUM+8;
			}
			else if(value_reg_b1_bak <0x900)
			{
				swire_num = SWIRE_MAX_NUM+9;
			}
			else if(value_reg_b1_bak <0xAE0)
			{
				swire_num = SWIRE_MAX_NUM+10;
			}
			else if(value_reg_b1_bak <0xBE8)
			{
				swire_num = SWIRE_MAX_NUM+11;
			}
			else if(value_reg_b1_bak <0xC38)
			{
				swire_num = SWIRE_MAX_NUM+12;
			}
			else
			{
				swire_num = SWIRE_MAX_NUM+13;
			}
		}
	}	
	else
	{
		value_reg_b1_bak = value_reg_b1;
		if ((value_reg_ca ==0x2A00) &&(value_reg_b1 >0x500))
			s20_power_on_flag =1; 
		else
			s20_power_on_flag =0;
	}
	#if 0
		if (swire_num !=swire_num_bak)
		{
			swire_num_bak = swire_num;
			printf("CA[%4x],B1[%4x]. swire_num[%d]\n", value_reg_ca, value_reg_b1,swire_num);
			
		}
	#endif

#endif

#endif //  // USE_BL_ADJ7

#ifdef USE_BL_ADJ6
	if ( (value_reg_b1 &0xC000) || ((value_reg_b1_bak == value_reg_b1)&&(value_reg_ca_bak == value_reg_ca)))
	{
		return true;
	}
	value_reg_b1_bak = value_reg_b1;
	value_reg_ca_bak = value_reg_ca;
		
	if(value_reg_ca >0x15FC)
	{
		swire_num = SWIRE_MAX_NUM;
	}
	else if(value_reg_ca >0x15EC)
	{
		swire_num = SWIRE_MAX_NUM+1;
	}
	else if(value_reg_ca >0x15EC)
	{
		swire_num = SWIRE_MAX_NUM+2;
	}
	else if(value_reg_ca >0x15DD)
	{
		swire_num = SWIRE_MAX_NUM+3;
	}
	else if(value_reg_ca >0x15CC)
	{
		swire_num = SWIRE_MAX_NUM+4;
	}
	else if(value_reg_ca >0x15BE)
	{
		swire_num = SWIRE_MAX_NUM+5;
	}
	else if(value_reg_ca >0x15AC)
	{
		swire_num = SWIRE_MAX_NUM+7;
	}
	else if(value_reg_ca >0x159A)
	{
		swire_num = SWIRE_MAX_NUM+8;
	}
	else if(value_reg_ca >0x155E)
	{
		swire_num = SWIRE_MAX_NUM+9;
	}
	else
	{
		if(value_reg_b1 <0x500)
		{
			swire_num = SWIRE_MAX_NUM+10;
		}
		else if(value_reg_b1 <0x900)
		{
			swire_num = SWIRE_MAX_NUM+11;
		}
		else if(value_reg_b1 <0xAE0)
		{
			swire_num = SWIRE_MAX_NUM+12;
		}
		else if(value_reg_b1 <0xBE8)
		{
			swire_num = SWIRE_MAX_NUM+13;
		}
		else if(value_reg_b1 <0xC38)
		{
			swire_num = SWIRE_MAX_NUM+14;
		}
		else
		{
			swire_num = SWIRE_MAX_NUM+15;
		}
	}
//	printf("CA[%4x],B1[%4x]. swire_num[%d]\n", value_reg_ca, value_reg_b1,swire_num);
#endif //  // USE_BL_ADJ4

    return true;
}
#endif

static bool ap_get_reg_ca(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    value_reg_ca = (dcs_packet->packet_param[0] << 8) + dcs_packet->packet_param[1];
    ////TAU_LOGD("CA[%x]", value_reg_ca);
    
    return true;
}

#if 0
static bool ap_get_reg_b5(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    value_reg_b5 = (dcs_packet->packet_param[3] << 8) + dcs_packet->packet_param[2];
    //TAU_LOGD("CA[%4x],B1[%4x],B5[%4x]", value_reg_ca,value_reg_b1,value_reg_b5);

    return true;
}
#endif

#ifdef ADD_PANEL_DISPLAY_MODE
uint8_t panel_mode =1; 			// DFĴ100:ۿ,01:۹,11:3(ӰԺ/Ƭ/.Ŀǰû)
uint16_t panel_r,panel_g,panel_b; // ¼RGBֵ

#ifdef USE_FOR_SUMSUNG_S9PLUS
#define RATIO_VALUE 2   				 //Żϵ
#else
#define RATIO_VALUE 2   				 //Żϵ
#endif

#endif

static bool ap_get_reg_df(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	ccm_coef_t ccm;
	ccm.coef_c00 = 255;
	ccm.coef_c01 = 0;
	ccm.coef_c02 = 0;
	ccm.coef_c10 = 0;
	ccm.coef_c11 = 255;
	ccm.coef_c12 = 0;
	ccm.coef_c20 = 0;
	ccm.coef_c21 = 0;
	ccm.coef_c22 = 255;
	
#ifdef ADD_PANEL_DISPLAY_MODE
	value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];
	panel_mode = dcs_packet->packet_param[0];
	panel_r =dcs_packet->packet_param[49];
	panel_g =dcs_packet->packet_param[51];
	panel_b =dcs_packet->packet_param[53];
//	//TAU_LOGD("value_reg_df[%4x],panel_mode[%4x],panel_r[%4x],panel_g[%4x],panel_b[%4x]", value_reg_df,panel_mode,panel_r,panel_g,panel_b);

	if (panel_mode ==00)
	{
	  	//ģʽ
	#ifdef USE_FOR_S10_BLUE_MODE
		//panel_r =256-RATIO_VALUE*(0xFF-panel_r);
		//panel_g =256-RATIO_VALUE*(0xFF-panel_g);
		//panel_b =256-RATIO_VALUE*(0xFF-panel_b);
	//	hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);
		ccm.coef_c00 = panel_r;
		ccm.coef_c11 = panel_g;
		ccm.coef_c22 = panel_b;
		hal_dsi_tx_ctrl_set_ccm(ccm);

	#else
		value_reg_df =value_reg_df&0xFF;
		switch(value_reg_df)
		{
			case 0xC1:
			case 0xC3:
				value_blue = BLUE_MIN;
			break;
			
			case 0xCF:
			case 0xD0:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)/BLUE_STEP;
			break;
			
			case 0xD8:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*2/BLUE_STEP;
			break;
			
			case 0xDE:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*3/BLUE_STEP;
			break;
			
			case 0xE4:
			case 0xE5:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*4/BLUE_STEP;
			break;
			
			case 0xE9:
			case 0xEA:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*5/BLUE_STEP;
			break;
			
			case 0xED:
			case 0xEE:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*6/BLUE_STEP;
			break;
			
			case 0xF1:
			case 0xF2:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*7/BLUE_STEP;
			break;
			
			case 0xF4:
			case 0xF5:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*8/BLUE_STEP;
			break;
			
			case 0xF7:
			case 0xF8:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*9/BLUE_STEP;
			break;
			
			case 0xFA:
				value_blue = BLUE_MAX;
			break;

			default:
			case 0xFF:
				value_blue = 0;
			break;
			
		}
		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,256,256,256);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
		
	#endif	

	}
	else
	{
	#ifndef USE_FOR_S10_BLUE_MODE
		value_blue =0;
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);  //ģʽs8+/s9+
	#endif

		//һ㣬ЧԡҪݿͻҪϸ
		
		panel_r =256-RATIO_VALUE*(0xFF-panel_r);
		panel_g =256-RATIO_VALUE*(0xFF-panel_g);
		panel_b =256-RATIO_VALUE*(0xFF-panel_b);
	//	hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);
		
		ccm.coef_c00 = panel_r;
		ccm.coef_c11 = panel_g;
		ccm.coef_c22 = panel_b;
		hal_dsi_tx_ctrl_set_ccm(ccm);
	}
	
#ifndef USE_FOR_S10_BLUE_MODE
	if (blue_flag==0)
	{
		blue_flag =1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
#endif

#else
    value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];

	value_reg_df =value_reg_df&0xFF;
	switch(value_reg_df)
	{
		case 0xC1:
		case 0xC3:
			value_blue = BLUE_MIN;
		break;
		
		case 0xCF:
		case 0xD0:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)/BLUE_STEP;
		break;
		
		case 0xD8:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*2/BLUE_STEP;
		break;
		
		case 0xDE:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*3/BLUE_STEP;
		break;
		
		case 0xE4:
		case 0xE5:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*4/BLUE_STEP;
		break;
		
		case 0xE9:
		case 0xEA:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*5/BLUE_STEP;
		break;
		
		case 0xED:
		case 0xEE:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*6/BLUE_STEP;
		break;
		
		case 0xF1:
		case 0xF2:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*7/BLUE_STEP;
		break;
		
		case 0xF4:
		case 0xF5:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*8/BLUE_STEP;
		break;
		
		case 0xF7:
		case 0xF8:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*9/BLUE_STEP;
		break;
		
		case 0xFA:
			value_blue = BLUE_MAX;
		break;

		default:
		case 0xFF:
			value_blue = 0;
		break;
		
	}
	
	//TAU_LOGD("df[%4x]", value_reg_df);
	hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	if (blue_flag==0)
	{
		blue_flag =1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
#endif

    return true;
}
#endif

static bool ap_set_hbm_53(hal_dsi_rx_ctrl_handle_t* handler, hal_dcs_packet_t* dcs_packet)
{

    if(dcs_packet->packet_param[0] == 0x24 || dcs_packet->packet_param[0] == 0x23)	// AODģʽ
    {
        g_tp_sleep_in = true;
//		hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0x01, 0x80);
    }
//    else
//    {
//        g_tp_sleep_in = false;
//    }
//    TAU_LOGD("53:[%2x]", dcs_packet->packet_param[0]);

    return true;
}


/* ƻDCS command  */
static const hal_dcs_execute_entry_t g_cus_rx_dcs_execute_table[] =
{
	{DCS_SET_DISPLAY_ON, ap_set_display_on, true},
	{DCS_SET_DISPLAY_OFF, ap_set_display_off, true},
	{0xDF, ap_get_reg_df, false},  //
//	{0xCA, ap_get_reg_ca, false},  // ⡣ҪB1ܵ
//	{0xB1, ap_set_backlight, false},
	{0x51, ap_set_backlight_51, false},   //leo S21U51
	{0x60, ap_update_frame_rate, true},
	{0x53, ap_set_hbm_53, true},
#if ADD_TP_CALIBRATION
//  TP calibration
	{0x04, ap_set_tp_calibration_04, true},
#endif  	
	{DCS_ENTER_SLEEP_MODE, ap_set_enter_sleep_mode, true},
	{DCS_EXIT_SLEEP_MODE, ap_set_exit_sleep_mode, true},
	{0, NULL, false}                        //{0,NULL,false} һ̶ԱΪtableβжϱ׼
};

static void tx_panel_reset(void)
{
#ifdef USE_WL518_INTERNAL_FLASH	
		hal_system_share_flash_mode(true);
#endif	
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(10);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);
    delayMs(10);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(30);
}




#if PANEL_INIT_CODE_ARRAY
static void send_panel_init_code(uint32_t size, uint8_t * data)
{
	uint32_t data_offeset = 0;
	uint8_t data_type;
	uint8_t vc;
	uint8_t data_size;
	uint8_t * p_data;

	while(data_offeset < size)
	{
		data_type = data[data_offeset];
		vc = data[data_offeset + 1];
		data_size = data[data_offeset + 2];
		p_data = &data[data_offeset + 3];
		hal_dsi_tx_ctrl_write_array_cmd(data_type, vc, data_size, p_data);
		data_offeset = data_offeset + data_size + 3;
		delayUs(50);
	}
}

const uint8_t panel_init_code[] = {
//#if AMOLED_NT37701_CSOT667
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x00,
//	0x39, 0, 9, 0xBA,0x02,0x79,0x00,0x14,0x03,0x9C,0x00,0x01,
//	0x39, 0, 2, 0x6F,0x08,
//	0x39, 0, 9, 0xBA,0x01,0xAF,0x00,0x14,0x00,0x1C,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 8, 0xBA,0x01,0x66,0x00,0x14,0x00,0x1C,0x00,
//	0x39, 0, 9, 0xBB,0x02,0x79,0x00,0x14,0x03,0x9C,0x00,0x21,
//	0x39, 0, 2, 0xB5,0x84,
//	0x39, 0, 2, 0x6F,0x06,
//	0x39, 0, 4, 0xB5,0x2B,0x0C,0x33,
//	0x39, 0, 2, 0x6F,0x0B,
//	0x39, 0, 4, 0xB5,0x2B,0x23,0x33,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 6, 0xB5,0x0C,0x0C,0x0C,0x0C,0x0C,
//	0x39, 0, 2, 0x6F,0x01,
//	0x39, 0, 2, 0xB6,0x19,
//	0x39, 0, 19, 0xB7,0x99,0x99,0x99,0x99,0x99,0x99,0x87,0x65,0x43,0x32,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x13,
//	0x39, 0, 13, 0xB7,0x00,0x00,0x01,0x13,0x78,0x89,0x9A,0xAB,0xBC,0xCD,0xDE,0xEF,
//	0x39, 0, 2, 0x6F,0x1F,
//	0x39, 0, 25, 0xB7,0x08,0x31,0x66,0x8F,0xF5,0xC1,0xC2,0x33,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0xFF,
//	0x39, 0, 3, 0xB2,0x98,0x60,
//	0x39, 0, 2, 0x6F,0x09,
//	0x39, 0, 2, 0xB2,0x40,
//	0x39, 0, 2, 0x6F,0x0F,
//	0x39, 0, 9, 0xB2,0x20,0x20,0x21,0xC2,0x21,0xC2,0x2F,0xFF,
//	0x39, 0, 13, 0xB3,0x00,0x08,0x00,0x1C,0x00,0x1C,0x00,0x3C,0x00,0x3C,0x00,0x70,
//	0x39, 0, 2, 0x6F,0x0C,
//	0x39, 0, 13, 0xB3,0x00,0x70,0x00,0xC8,0x00,0xC8,0x01,0x48,0x01,0x48,0x01,0xAD,
//	0x39, 0, 2, 0x6F,0x18,
//	0x39, 0, 13, 0xB3,0x01,0xAD,0x01,0xC2,0x01,0xC2,0x01,0xC2,0x07,0xFF,0x0F,0xFF,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 9, 0xB3,0x01,0x55,0x08,0xCC,0x08,0xCC,0x0F,0xFF,
//	0x39, 0, 2, 0x6F,0x2C,
//	0x39, 0, 15, 0xB3,0x09,0x90,0x08,0xDC,0x08,0x70,0x08,0x70,0x07,0xC8,0x07,0xC8,0x06,0xB8,
//	0x39, 0, 2, 0x6F,0x3A,
//	0x39, 0, 13, 0xB3,0x06,0xB8,0x04,0xE8,0x04,0xE8,0x02,0x48,0x02,0x48,0x00,0x38,
//	0x39, 0, 2, 0x6F,0x46,
//	0x39, 0, 13, 0xB3,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,
//	0x39, 0, 15, 0xB4,0x0D,0x10,0x0C,0x1C,0x0B,0x88,0x0B,0x88,0x0A,0xA0,0x0A,0xA0,0x09,0x28,
//	0x39, 0, 2, 0x6F,0x0E,
//	0x39, 0, 13, 0xB4,0x09,0x28,0x06,0xB0,0x06,0xB0,0x03,0x18,0x03,0x18,0x00,0x48,
//	0x39, 0, 2, 0x6F,0x1A,
//	0x39, 0, 13, 0xB4,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,
//	0x39, 0, 2, 0x6F,0x26,
//	0x39, 0, 11, 0xB4,0x0D,0x10,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,
//	0x39, 0, 2, 0x6F,0x30,
//	0x39, 0, 15, 0xB4,0x09,0x90,0x08,0xDC,0x08,0x70,0x08,0x70,0x07,0xC8,0x07,0xC8,0x06,0xB8,
//	0x39, 0, 2, 0x6F,0x3E,
//	0x39, 0, 13, 0xB4,0x06,0xB8,0x04,0xE8,0x04,0xE8,0x02,0x48,0x02,0x48,0x00,0x38,
//	0x39, 0, 2, 0x6F,0x4A,
//	0x39, 0, 13, 0xB4,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,
//	0x39, 0, 2, 0x6F,0xAC,
//	0x39, 0, 21, 0xB2,0x0F,0xFF,0x0F,0xFF,0x08,0x09,0x08,0x6C,0x08,0xCA,0x09,0x24,0x09,0x79,0x09,0xCB,0x0A,0x1A,0x0A,0x66,
//	0x39, 0, 2, 0x6F,0xC0,
//	0x39, 0, 21, 0xB2,0x0A,0xB0,0x0A,0xF7,0x0B,0x3D,0x0B,0x80,0x0B,0xC1,0x0C,0x01,0x0C,0x40,0x0C,0x7C,0x0C,0xB8,0x0C,0xF2,
//	0x39, 0, 2, 0x6F,0xD4,
//	0x39, 0, 21, 0xB2,0x0D,0x2B,0x0D,0x63,0x0D,0x9A,0x0D,0xCF,0x0E,0x04,0x0E,0x38,0x0E,0x6B,0x0E,0x9D,0x0E,0xCF,0x0E,0xFF,
//	0x39, 0, 2, 0x6F,0xE8,
//	0x39, 0, 11, 0xB2,0x0F,0x2F,0x0F,0x5E,0x0F,0x8D,0x0F,0xBB,0x0F,0xFF,
//	0x39, 0, 2, 0x6F,0x52,
//	0x39, 0, 21, 0xB3,0x01,0xC2,0x01,0xC3,0x01,0xF5,0x02,0x27,0x02,0x59,0x02,0x8B,0x02,0xBD,0x02,0xEF,0x03,0x21,0x03,0x53,
//	0x39, 0, 2, 0x6F,0x66,
//	0x39, 0, 21, 0xB3,0x03,0x84,0x03,0xB6,0x03,0xE8,0x04,0x1A,0x04,0x4C,0x04,0x7E,0x04,0xB0,0x04,0xE2,0x05,0x14,0x05,0x46,
//	0x39, 0, 2, 0x6F,0x7A,
//	0x39, 0, 21, 0xB3,0x05,0x78,0x05,0xA9,0x05,0xDB,0x06,0x0D,0x06,0x3F,0x06,0x71,0x06,0xA3,0x06,0xD5,0x07,0x07,0x07,0x39,
//	0x39, 0, 2, 0x6F,0x8E,
//	0x39, 0, 9, 0xB3,0x07,0x6B,0x07,0x9D,0x07,0xCE,0x07,0xFF,
//	0x39, 0, 3, 0xB9,0x00,0x96,
//	0x39, 0, 3, 0xBD,0x04,0xB0,
//	0x39, 0, 4, 0xC0,0x76,0xF3,0xC1,
//	0x39, 0, 2, 0x6F,0x08,
//	0x39, 0, 2, 0xC0,0x40,
//	0x39, 0, 2, 0x6F,0x09,
//	0x39, 0, 3, 0xC0,0x20,0x20,
//	0x39, 0, 2, 0x6F,0x02,
//	0x39, 0, 7, 0xC1,0x24,0x86,0x00,0x57,0x00,0x45,
//	0x39, 0, 2, 0x6F,0x0A,
//	0x39, 0, 3, 0xC1,0x00,0x86,
//	0x39, 0, 2, 0xC5,0x05,
//	0x39, 0, 2, 0x6F,0x08,
//	0x39, 0, 2, 0xC3,0x00,
//	0x39, 0, 15, 0xC6,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
//	0x39, 0, 2, 0xCA,0x12,
//	0x39, 0, 2, 0xB9,0x00,
//	0x39, 0, 5, 0xBE,0x0E,0x0B,0x14,0x13,
//	0x39, 0, 2, 0x6F,0x05,
//	0x39, 0, 2, 0xBE,0x8A,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x2A,
//	0x39, 0, 2, 0xD9,0x43,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x01,
//	0x39, 0, 11, 0xB5,0x00,0xB0,0x00,0x98,0x00,0x98,0x00,0xB0,0x00,0x98,
//	0x39, 0, 11, 0xB6,0x01,0x38,0x00,0xD0,0x00,0xD0,0x01,0x38,0x00,0xD0,
//	0x39, 0, 13, 0xC2,0x00,0xB0,0x01,0x38,0x00,0xB0,0x01,0x38,0x00,0xB0,0x01,0x38,
//	0x39, 0, 3, 0xB0,0x04,0x04,
//	0x39, 0, 3, 0xB3,0x13,0x13,
//	0x39, 0, 7, 0xB7,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,
//	0x39, 0, 3, 0xB1,0x08,0x08,
//	0x39, 0, 3, 0xB4,0x13,0x13,
//	0x39, 0, 8, 0xB8,0x46,0x46,0x46,0x46,0x46,0x46,0x46,
//	0x39, 0, 29, 0xB9,0x00,0x1F,0x00,0x00,0x00,0x1F,0x00,0x00,0x1F,0x00,0x00,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x1F,0x1F,0x1F,0x1F,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 6, 0xBB,0x03,0x94,0x00,0x19,0x3C,
//	0x39, 0, 2, 0x6F,0x05,
//	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
//	0x39, 0, 2, 0x6F,0x18,
//	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
//	0x39, 0, 2, 0x6F,0x2B,
//	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
//	0x39, 0, 2, 0x6F,0x3E,
//	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
//	0x39, 0, 5, 0xBA,0x10,0x10,0x10,0x10,
//	0x39, 0, 3, 0xC4,0x80,0x03,
//	0x39, 0, 2, 0xC7,0x01,
//	0x39, 0, 3, 0xCD,0x05,0x81,
//	0x39, 0, 2, 0xCF,0x1D,
//	0x39, 0, 2, 0x6F,0x01,
//	0x39, 0, 5, 0xCE,0x00,0x01,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x09,
//	0x39, 0, 2, 0xD2,0x00,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 2, 0xD8,0x0C,
//	0x39, 0, 2, 0xD9,0xAB,
//	0x39, 0, 2, 0xD1,0x07,
//	0x39, 0, 2, 0x6F,0x02,
//	0x39, 0, 2, 0xD1,0x06,
//	0x39, 0, 2, 0x6F,0x05,
//	0x39, 0, 2, 0xD1,0x06,
//	0x39, 0, 3, 0xD6,0x00,0x40,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
//	0x39, 0, 25, 0xB9,0x00,0x04,0x00,0x0C,0x00,0x14,0x00,0x1C,0x00,0x2C,0x00,0x3C,0x00,0x4C,0x00,0x5C,0x00,0x7C,0x00,0x9C,0x00,0xBC,0x00,0xDC,
//	0x39, 0, 25, 0xBA,0x00,0xFC,0x01,0x3C,0x01,0x7C,0x01,0xBC,0x01,0xFC,0x02,0x7C,0x02,0xFC,0x03,0x7C,0x03,0xBC,0x03,0xDC,0x03,0xFC,0x03,0xFF,
//	0x39, 0, 2, 0xBC,0x11,
//	0x39, 0, 17, 0xBD,0x96,0x00,0x69,0x00,0x00,0x96,0x00,0x69,0xBB,0x44,0x44,0xBB,0xEE,0x11,0x11,0xEE,
//	0x39, 0, 2, 0xC1,0x02,
//	0x39, 0, 9, 0xC2,0x19,0x00,0x91,0x00,0x19,0x00,0x91,0x00,
//	0x39, 0, 3, 0xC0,0x00,0x00,
//	0x39, 0, 2, 0xCE,0x01,
//	0x39, 0, 2, 0xCC,0x00,

//#if 1
//	///////////#1_gamma.txt///////////////

//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
//	0x39, 0, 2, 0xCC,0x30,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
//	0x39, 0, 2, 0xBF,0x09,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x3C,0x02,0x8A,0x02,0xD8,0x03,0x19,0x03,0x99,0x04,0x02,0x04,0x58,0x04,0xAC,
//	0x39, 0, 19, 0xB1,0x05,0x37,0x05,0xA7,0x06,0x15,0x06,0x6F,0x06,0xC7,0x07,0x5D,0x07,0xE1,0x08,0x5E,0x08,0xD2,
//	0x39, 0, 15, 0xB2,0x09,0xB8,0x0A,0x91,0x0B,0x68,0x0B,0xD7,0x0C,0x12,0x0C,0x4A,0x0C,0x4A,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x01,0xB0,0x02,0x29,0x02,0x75,0x02,0xB7,0x03,0x38,0x03,0x98,0x03,0xE4,0x04,0x2E,
//	0x39, 0, 19, 0xB4,0x04,0xA4,0x05,0x05,0x05,0x65,0x05,0xB3,0x06,0x00,0x06,0x7F,0x06,0xF5,0x07,0x60,0x07,0xC1,
//	0x39, 0, 15, 0xB5,0x08,0x80,0x09,0x33,0x09,0xE4,0x0A,0x38,0x0A,0x61,0x0A,0x8C,0x0A,0x8C,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x01,0xE6,0x02,0x6C,0x02,0xDC,0x03,0x31,0x03,0xD7,0x04,0x53,0x04,0xB4,0x05,0x14,
//	0x39, 0, 19, 0xB7,0x05,0xA4,0x06,0x1A,0x06,0x8E,0x06,0xEF,0x07,0x4E,0x07,0xEC,0x08,0x7D,0x09,0x03,0x09,0x83,
//	0x39, 0, 15, 0xB8,0x0A,0x7F,0x0B,0x79,0x0C,0x72,0x0C,0xFB,0x0D,0x42,0x0D,0x8E,0x0D,0x8E,
//	0x39, 0, 2, 0xBF,0x08,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x90,0x02,0xCC,0x03,0x08,0x03,0x40,0x03,0xAD,0x04,0x04,0x04,0x59,0x04,0x9D,
//	0x39, 0, 19, 0xB1,0x05,0x22,0x05,0x8D,0x05,0xEB,0x06,0x47,0x06,0x96,0x07,0x1B,0x07,0x9F,0x08,0x0F,0x08,0x7D,
//	0x39, 0, 15, 0xB2,0x09,0x42,0x0A,0x05,0x0A,0xBF,0x0B,0x1B,0x0B,0x4C,0x0B,0x7C,0x0B,0x7C,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x26,0x02,0x6E,0x02,0x9B,0x02,0xD0,0x03,0x37,0x03,0x86,0x03,0xD4,0x04,0x0F,
//	0x39, 0, 19, 0xB4,0x04,0x81,0x04,0xDF,0x05,0x2F,0x05,0x7E,0x05,0xC1,0x06,0x36,0x06,0xA9,0x07,0x0B,0x07,0x6C,
//	0x39, 0, 15, 0xB5,0x08,0x10,0x08,0xB2,0x09,0x4E,0x09,0x9A,0x09,0xC0,0x09,0xE7,0x09,0xE7,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x45,0x02,0xA6,0x02,0xF7,0x03,0x44,0x03,0xDB,0x04,0x45,0x04,0xAE,0x04,0xF9,
//	0x39, 0, 19, 0xB7,0x05,0x8C,0x06,0x02,0x06,0x64,0x06,0xC4,0x07,0x16,0x07,0xA3,0x08,0x2F,0x08,0xAC,0x09,0x27,
//	0x39, 0, 15, 0xB8,0x0A,0x00,0x0A,0xD8,0x0B,0xAD,0x0C,0x16,0x0C,0x4D,0x0C,0x87,0x0C,0x87,
//	0x39, 0, 2, 0xBF,0x07,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x76,0x02,0x92,0x02,0xAE,0x02,0xCA,0x03,0x06,0x03,0x45,0x03,0x7C,0x03,0xAF,
//	0x39, 0, 19, 0xB1,0x04,0x0F,0x04,0x5F,0x04,0xAD,0x04,0xF1,0x05,0x2E,0x05,0x97,0x05,0xF8,0x06,0x4F,0x06,0x9E,
//	0x39, 0, 15, 0xB2,0x07,0x2A,0x07,0xA6,0x08,0x19,0x08,0x4E,0x08,0x68,0x08,0x82,0x08,0x82,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x24,0x02,0x42,0x02,0x60,0x02,0x73,0x02,0x9F,0x02,0xD4,0x03,0x08,0x03,0x3A,
//	0x39, 0, 19, 0xB4,0x03,0x8E,0x03,0xD6,0x04,0x1C,0x04,0x55,0x04,0x8A,0x04,0xE8,0x05,0x3B,0x05,0x85,0x05,0xCC,
//	0x39, 0, 15, 0xB5,0x06,0x43,0x06,0xAF,0x07,0x12,0x07,0x41,0x07,0x57,0x07,0x6C,0x07,0x6C,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x39,0x02,0x64,0x02,0x8F,0x02,0xB3,0x03,0x04,0x03,0x58,0x03,0xA2,0x03,0xE4,
//	0x39, 0, 19, 0xB7,0x04,0x57,0x04,0xB5,0x05,0x0D,0x05,0x55,0x05,0x97,0x06,0x0A,0x06,0x70,0x06,0xC9,0x07,0x21,
//	0x39, 0, 15, 0xB8,0x07,0xB2,0x08,0x38,0x08,0xB3,0x08,0xED,0x09,0x0A,0x09,0x26,0x09,0x26,
//	0x39, 0, 2, 0xBF,0x06,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x6D,0x02,0x8B,0x02,0xA9,0x02,0xC7,0x03,0x03,0x03,0x3C,0x03,0x74,0x03,0xA8,
//	0x39, 0, 19, 0xB1,0x04,0x05,0x04,0x53,0x04,0xA0,0x04,0xE3,0x05,0x1B,0x05,0x87,0x05,0xEB,0x06,0x40,0x06,0x94,
//	0x39, 0, 15, 0xB2,0x07,0x1E,0x07,0x98,0x08,0x06,0x08,0x3D,0x08,0x57,0x08,0x72,0x08,0x72,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x29,0x02,0x44,0x02,0x5F,0x02,0x70,0x02,0x9C,0x02,0xD0,0x03,0x03,0x03,0x36,
//	0x39, 0, 19, 0xB4,0x03,0x87,0x03,0xCB,0x04,0x0D,0x04,0x48,0x04,0x79,0x04,0xD9,0x05,0x2F,0x05,0x78,0x05,0xBF,
//	0x39, 0, 15, 0xB5,0x06,0x37,0x06,0xA1,0x07,0x02,0x07,0x31,0x07,0x47,0x07,0x5D,0x07,0x5D,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x39,0x02,0x63,0x02,0x8D,0x02,0xB0,0x03,0x00,0x03,0x4D,0x03,0x98,0x03,0xDE,
//	0x39, 0, 19, 0xB7,0x04,0x4D,0x04,0xA6,0x04,0xFE,0x05,0x45,0x05,0x82,0x05,0xF9,0x06,0x62,0x06,0xBC,0x07,0x15,
//	0x39, 0, 15, 0xB8,0x07,0xA5,0x08,0x28,0x08,0x9F,0x08,0xDA,0x08,0xF6,0x09,0x11,0x09,0x11,
//	0x39, 0, 2, 0xBF,0x05,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x98,0x02,0xAE,0x02,0xC4,0x02,0xDA,0x03,0x10,0x03,0x44,0x03,0x77,0x03,0xA8,
//	0x39, 0, 19, 0xB1,0x04,0x07,0x04,0x5C,0x04,0xA5,0x04,0xE6,0x05,0x1B,0x05,0x81,0x05,0xE5,0x06,0x36,0x06,0x86,
//	0x39, 0, 15, 0xB2,0x07,0x12,0x07,0x89,0x07,0xF7,0x08,0x2D,0x08,0x48,0x08,0x60,0x08,0x60,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x41,0x02,0x59,0x02,0x71,0x02,0x80,0x02,0xA7,0x02,0xD6,0x03,0x03,0x03,0x30,
//	0x39, 0, 19, 0xB4,0x03,0x87,0x03,0xD2,0x04,0x11,0x04,0x4B,0x04,0x7D,0x04,0xD5,0x05,0x2B,0x05,0x72,0x05,0xB7,
//	0x39, 0, 15, 0xB5,0x06,0x2F,0x06,0x98,0x06,0xF7,0x07,0x25,0x07,0x3C,0x07,0x51,0x07,0x51,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x54,0x02,0x79,0x02,0x9E,0x02,0xBD,0x03,0x06,0x03,0x4E,0x03,0x94,0x03,0xD2,
//	0x39, 0, 19, 0xB7,0x04,0x4B,0x04,0xAD,0x04,0xFF,0x05,0x48,0x05,0x84,0x05,0xF1,0x06,0x5D,0x06,0xB4,0x07,0x09,
//	0x39, 0, 15, 0xB8,0x07,0x9C,0x08,0x1D,0x08,0x92,0x08,0xCB,0x08,0xE7,0x09,0x02,0x09,0x02,
//	0x39, 0, 2, 0xBF,0x04,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0xA2,0x02,0xB9,0x02,0xD0,0x02,0xE7,0x03,0x18,0x03,0x4B,0x03,0x7D,0x03,0xB2,
//	0x39, 0, 19, 0xB1,0x04,0x03,0x04,0x53,0x04,0x95,0x04,0xD6,0x05,0x11,0x05,0x7A,0x05,0xDC,0x06,0x2D,0x06,0x7D,
//	0x39, 0, 15, 0xB2,0x07,0x01,0x07,0x77,0x07,0xE4,0x08,0x18,0x08,0x31,0x08,0x49,0x08,0x49,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x65,0x02,0x79,0x02,0x8D,0x02,0x9A,0x02,0xC0,0x02,0xEC,0x03,0x16,0x03,0x45,
//	0x39, 0, 19, 0xB4,0x03,0x90,0x03,0xDA,0x04,0x15,0x04,0x4E,0x04,0x83,0x04,0xDF,0x05,0x31,0x05,0x77,0x05,0xBB,
//	0x39, 0, 15, 0xB5,0x06,0x31,0x06,0x98,0x06,0xF7,0x07,0x23,0x07,0x38,0x07,0x4C,0x07,0x4C,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x7A,0x02,0x96,0x02,0xB2,0x02,0xCA,0x03,0x10,0x03,0x55,0x03,0x99,0x03,0xDC,
//	0x39, 0, 19, 0xB7,0x04,0x40,0x04,0xA2,0x04,0xEE,0x05,0x38,0x05,0x79,0x05,0xEE,0x06,0x54,0x06,0xA9,0x06,0xFC,
//	0x39, 0, 15, 0xB8,0x07,0x8A,0x08,0x09,0x08,0x80,0x08,0xB8,0x08,0xD2,0x08,0xEC,0x08,0xEC,
//	0x39, 0, 2, 0xBF,0x03,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0xEA,0x02,0xFB,0x03,0x0C,0x03,0x1D,0x03,0x40,0x03,0x6C,0x03,0x96,0x03,0xBE,
//	0x39, 0, 19, 0xB1,0x04,0x0D,0x04,0x52,0x04,0x91,0x04,0xCF,0x05,0x06,0x05,0x6A,0x05,0xC3,0x06,0x13,0x06,0x62,
//	0x39, 0, 15, 0xB2,0x06,0xE5,0x07,0x59,0x07,0xC0,0x07,0xF2,0x08,0x0A,0x08,0x21,0x08,0x21,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x95,0x02,0xAA,0x02,0xBF,0x02,0xD4,0x02,0xEF,0x03,0x11,0x03,0x34,0x03,0x55,
//	0x39, 0, 19, 0xB4,0x03,0x9E,0x03,0xDD,0x04,0x15,0x04,0x4B,0x04,0x7D,0x04,0xD5,0x05,0x21,0x05,0x66,0x05,0xAA,
//	0x39, 0, 15, 0xB5,0x06,0x19,0x06,0x7D,0x06,0xD7,0x07,0x03,0x07,0x17,0x07,0x2B,0x07,0x2B,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0xA4,0x02,0xC2,0x02,0xE0,0x02,0xFE,0x03,0x31,0x03,0x6C,0x03,0xA3,0x03,0xD8,
//	0x39, 0, 19, 0xB7,0x04,0x40,0x04,0x95,0x04,0xE0,0x05,0x29,0x05,0x69,0x05,0xD8,0x06,0x38,0x06,0x8E,0x06,0xE2,
//	0x39, 0, 15, 0xB8,0x07,0x6D,0x07,0xE8,0x08,0x58,0x08,0x8E,0x08,0xA8,0x08,0xC1,0x08,0xC1,
//	0x39, 0, 2, 0xBF,0x02,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0x24,0x03,0x34,0x03,0x44,0x03,0x54,0x03,0x74,0x03,0x94,0x03,0xB4,0x03,0xD3,
//	0x39, 0, 19, 0xB1,0x04,0x16,0x04,0x53,0x04,0x8B,0x04,0xC1,0x04,0xF2,0x05,0x51,0x05,0xA7,0x05,0xF2,0x06,0x3E,
//	0x39, 0, 15, 0xB2,0x06,0xB9,0x07,0x26,0x07,0x8E,0x07,0xBE,0x07,0xD4,0x07,0xEA,0x07,0xEA,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0xB7,0x02,0xCD,0x02,0xE3,0x02,0xF9,0x03,0x25,0x03,0x41,0x03,0x5B,0x03,0x74,
//	0x39, 0, 19, 0xB4,0x03,0xAD,0x03,0xE8,0x04,0x19,0x04,0x49,0x04,0x73,0x04,0xC4,0x05,0x11,0x05,0x50,0x05,0x8C,
//	0x39, 0, 15, 0xB5,0x05,0xF9,0x06,0x57,0x06,0xAE,0x06,0xD7,0x06,0xEA,0x06,0xFD,0x06,0xFD,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0xC9,0x02,0xE5,0x03,0x01,0x03,0x1D,0x03,0x56,0x03,0x86,0x03,0xB3,0x03,0xDE,
//	0x39, 0, 19, 0xB7,0x04,0x37,0x04,0x8A,0x04,0xCF,0x05,0x12,0x05,0x4A,0x05,0xB8,0x06,0x1A,0x06,0x6B,0x06,0xB9,
//	0x39, 0, 15, 0xB8,0x07,0x3F,0x07,0xB6,0x08,0x23,0x08,0x56,0x08,0x6E,0x08,0x86,0x08,0x86,
//	0x39, 0, 2, 0xBF,0x01,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0x6F,0x03,0x7A,0x03,0x85,0x03,0x90,0x03,0xA7,0x03,0xBE,0x03,0xD5,0x03,0xEE,
//	0x39, 0, 19, 0xB1,0x04,0x1E,0x04,0x4F,0x04,0x7E,0x04,0xAD,0x04,0xD8,0x05,0x2A,0x05,0x71,0x05,0xB7,0x05,0xFA,
//	0x39, 0, 15, 0xB2,0x06,0x70,0x06,0xDB,0x07,0x38,0x07,0x65,0x07,0x7B,0x07,0x8F,0x07,0x8F,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x03,0x20,0x03,0x2D,0x03,0x3A,0x03,0x47,0x03,0x62,0x03,0x7D,0x03,0x8E,0x03,0xA2,
//	0x39, 0, 19, 0xB4,0x03,0xC7,0x03,0xEE,0x04,0x17,0x04,0x3E,0x04,0x64,0x04,0xAC,0x04,0xE9,0x05,0x24,0x05,0x5B,
//	0x39, 0, 15, 0xB5,0x05,0xBD,0x06,0x17,0x06,0x66,0x06,0x8C,0x06,0x9F,0x06,0xB1,0x06,0xB1,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0x2E,0x03,0x40,0x03,0x52,0x03,0x64,0x03,0x88,0x03,0xAC,0x03,0xCA,0x03,0xED,
//	0x39, 0, 19, 0xB7,0x04,0x2F,0x04,0x6D,0x04,0xAD,0x04,0xE8,0x05,0x1D,0x05,0x83,0x05,0xD5,0x06,0x25,0x06,0x6F,
//	0x39, 0, 15, 0xB8,0x06,0xF0,0x07,0x63,0x07,0xC5,0x07,0xF5,0x08,0x0D,0x08,0x23,0x08,0x23,
//	0x39, 0, 2, 0xBF,0x00,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0xBE,0x03,0xC4,0x03,0xCA,0x03,0xD0,0x03,0xDD,0x03,0xEA,0x03,0xF7,0x04,0x04,
//	0x39, 0, 19, 0xB1,0x04,0x1F,0x04,0x3C,0x04,0x58,0x04,0x77,0x04,0x94,0x04,0xCD,0x05,0x03,0x05,0x37,0x05,0x69,
//	0x39, 0, 15, 0xB2,0x05,0xC6,0x06,0x18,0x06,0x69,0x06,0x8F,0x06,0xA1,0x06,0xB5,0x06,0xB5,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x03,0x83,0x03,0x8A,0x03,0x91,0x03,0x98,0x03,0xA6,0x03,0xB4,0x03,0xC2,0x03,0xD0,
//	0x39, 0, 19, 0xB4,0x03,0xE2,0x03,0xF8,0x04,0x0D,0x04,0x26,0x04,0x3C,0x04,0x6A,0x04,0x96,0x04,0xC1,0x04,0xEB,
//	0x39, 0, 15, 0xB5,0x05,0x39,0x05,0x7D,0x05,0xBF,0x05,0xDF,0x05,0xED,0x05,0xFD,0x05,0xFD,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0x81,0x03,0x8B,0x03,0x95,0x03,0x9F,0x03,0xB4,0x03,0xC9,0x03,0xDE,0x03,0xF3,
//	0x39, 0, 19, 0xB7,0x04,0x16,0x04,0x3E,0x04,0x67,0x04,0x8F,0x04,0xB3,0x04,0xFE,0x05,0x43,0x05,0x83,0x05,0xC1,
//	0x39, 0, 15, 0xB8,0x06,0x2F,0x06,0x8B,0x06,0xE5,0x07,0x0F,0x07,0x22,0x07,0x35,0x07,0x35,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
//	0x39, 0, 2, 0xBF,0x19,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x26,0x02,0x64,0x02,0xA2,0x02,0xDB,0x03,0x4A,0x03,0xB1,0x04,0x04,0x04,0x55,
//	0x39, 0, 19, 0xB1,0x04,0xD8,0x05,0x46,0x05,0xB3,0x06,0x0B,0x06,0x61,0x06,0xFC,0x07,0x7F,0x07,0xFB,0x08,0x6F,
//	0x39, 0, 15, 0xB2,0x09,0x55,0x0A,0x31,0x0B,0x0B,0x0B,0x7E,0x0B,0xBA,0x0B,0xF3,0x0B,0xF3,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x01,0xC0,0x02,0x1B,0x02,0x54,0x02,0x89,0x02,0xF1,0x03,0x4D,0x03,0x94,0x03,0xDA,
//	0x39, 0, 19, 0xB4,0x04,0x4F,0x04,0xAD,0x05,0x0A,0x05,0x56,0x05,0xA1,0x06,0x28,0x06,0x98,0x07,0x03,0x07,0x64,
//	0x39, 0, 15, 0xB5,0x08,0x24,0x08,0xD7,0x09,0x88,0x09,0xE1,0x0A,0x0B,0x0A,0x35,0x0A,0x35,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x01,0xF3,0x02,0x57,0x02,0xAB,0x02,0xF5,0x03,0x86,0x04,0x00,0x04,0x5D,0x04,0xB8,
//	0x39, 0, 19, 0xB7,0x05,0x4A,0x05,0xBD,0x06,0x2F,0x06,0x8D,0x06,0xE9,0x07,0x92,0x08,0x1B,0x08,0xA1,0x09,0x20,
//	0x39, 0, 15, 0xB8,0x0A,0x1B,0x0B,0x1B,0x0C,0x1A,0x0C,0xA6,0x0C,0xF3,0x0D,0x44,0x0D,0x44,
//	0x39, 0, 2, 0xBF,0x18,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x97,0x02,0xC2,0x02,0xED,0x03,0x18,0x03,0x6C,0x03,0xBA,0x04,0x07,0x04,0x48,
//	0x39, 0, 19, 0xB1,0x04,0xC7,0x05,0x31,0x05,0x8E,0x05,0xE9,0x06,0x37,0x06,0xBA,0x07,0x3B,0x07,0xAB,0x08,0x1A,
//	0x39, 0, 15, 0xB2,0x08,0xE1,0x09,0xA6,0x0A,0x62,0x0A,0xBE,0x0A,0xED,0x0B,0x20,0x0B,0x20,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x47,0x02,0x77,0x02,0x95,0x02,0xBA,0x03,0x00,0x03,0x43,0x03,0x84,0x03,0xBD,
//	0x39, 0, 19, 0xB4,0x04,0x2B,0x04,0x87,0x04,0xD7,0x05,0x26,0x05,0x68,0x05,0xDA,0x06,0x4A,0x06,0xAB,0x07,0x0B,
//	0x39, 0, 15, 0xB5,0x07,0xAF,0x08,0x52,0x08,0xEC,0x09,0x38,0x09,0x60,0x09,0x88,0x09,0x88,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x60,0x02,0xA5,0x02,0xDF,0x03,0x1C,0x03,0x92,0x03,0xF2,0x04,0x51,0x04,0x9B,
//	0x39, 0, 19, 0xB7,0x05,0x2C,0x05,0x9F,0x06,0x02,0x06,0x64,0x06,0xB7,0x07,0x44,0x07,0xCF,0x08,0x48,0x08,0xBF,
//	0x39, 0, 15, 0xB8,0x09,0x9A,0x0A,0x74,0x0B,0x51,0x0B,0xBE,0x0B,0xF5,0x0C,0x30,0x0C,0x30,
//	0x39, 0, 2, 0xBF,0x17,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x8B,0x02,0x9B,0x02,0xAB,0x02,0xBB,0x02,0xE6,0x03,0x16,0x03,0x44,0x03,0x72,
//	0x39, 0, 19, 0xB1,0x03,0xC0,0x04,0x0C,0x04,0x53,0x04,0x93,0x04,0xCC,0x05,0x36,0x05,0x97,0x05,0xEA,0x06,0x3A,
//	0x39, 0, 15, 0xB2,0x06,0xC6,0x07,0x44,0x07,0xB6,0x07,0xE9,0x08,0x04,0x08,0x1E,0x08,0x1E,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x3B,0x02,0x51,0x02,0x67,0x02,0x75,0x02,0x92,0x02,0xB8,0x02,0xDD,0x03,0x03,
//	0x39, 0, 19, 0xB4,0x03,0x47,0x03,0x88,0x03,0xC4,0x03,0xFE,0x04,0x2E,0x04,0x8B,0x04,0xE0,0x05,0x2A,0x05,0x6C,
//	0x39, 0, 15, 0xB5,0x05,0xE5,0x06,0x4C,0x06,0xB0,0x06,0xDF,0x06,0xF6,0x07,0x0C,0x07,0x0C,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x55,0x02,0x73,0x02,0x91,0x02,0xAA,0x02,0xE3,0x03,0x27,0x03,0x65,0x03,0xA0,
//	0x39, 0, 19, 0xB7,0x04,0x02,0x04,0x5C,0x04,0xAC,0x04,0xF5,0x05,0x34,0x05,0xA6,0x06,0x0F,0x06,0x69,0x06,0xBC,
//	0x39, 0, 15, 0xB8,0x07,0x51,0x07,0xD4,0x08,0x4F,0x08,0x88,0x08,0xA6,0x08,0xC2,0x08,0xC2,
//	0x39, 0, 2, 0xBF,0x16,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0x8E,0x02,0x9D,0x02,0xAC,0x02,0xBB,0x02,0xE4,0x03,0x11,0x03,0x3D,0x03,0x68,
//	0x39, 0, 19, 0xB1,0x03,0xC1,0x04,0x08,0x04,0x4E,0x04,0x8D,0x04,0xC3,0x05,0x2D,0x05,0x8B,0x05,0xDC,0x06,0x2B,
//	0x39, 0, 15, 0xB2,0x06,0xB5,0x07,0x31,0x07,0xA3,0x07,0xD8,0x07,0xF1,0x08,0x0C,0x08,0x0C,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x3F,0x02,0x53,0x02,0x67,0x02,0x74,0x02,0x91,0x02,0xB5,0x02,0xD7,0x02,0xFB,
//	0x39, 0, 19, 0xB4,0x03,0x46,0x03,0x84,0x03,0xC1,0x03,0xF8,0x04,0x27,0x04,0x81,0x04,0xD2,0x05,0x18,0x05,0x5D,
//	0x39, 0, 15, 0xB5,0x05,0xD6,0x06,0x40,0x06,0xA3,0x06,0xD1,0x06,0xE6,0x06,0xFD,0x06,0xFD,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x58,0x02,0x74,0x02,0x90,0x02,0xA8,0x02,0xE1,0x03,0x1F,0x03,0x5B,0x03,0x93,
//	0x39, 0, 19, 0xB7,0x04,0x01,0x04,0x55,0x04,0xA7,0x04,0xEE,0x05,0x28,0x05,0x9A,0x05,0xFF,0x06,0x55,0x06,0xA9,
//	0x39, 0, 15, 0xB8,0x07,0x3F,0x07,0xC2,0x08,0x3E,0x08,0x77,0x08,0x92,0x08,0xAF,0x08,0xAF,
//	0x39, 0, 2, 0xBF,0x15,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0xA9,0x02,0xB8,0x02,0xC7,0x02,0xD6,0x02,0xF7,0x03,0x22,0x03,0x4C,0x03,0x73,
//	0x39, 0, 19, 0xB1,0x03,0xBF,0x04,0x04,0x04,0x49,0x04,0x88,0x04,0xBF,0x05,0x22,0x05,0x83,0x05,0xD4,0x06,0x23,
//	0x39, 0, 15, 0xB2,0x06,0xAE,0x07,0x28,0x07,0x94,0x07,0xC8,0x07,0xE4,0x07,0xFD,0x07,0xFD,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x52,0x02,0x66,0x02,0x7A,0x02,0x87,0x02,0x9F,0x02,0xBF,0x02,0xDD,0x03,0x01,
//	0x39, 0, 19, 0xB4,0x03,0x45,0x03,0x86,0x03,0xBF,0x03,0xF4,0x04,0x27,0x04,0x7C,0x04,0xD0,0x05,0x15,0x05,0x58,
//	0x39, 0, 15, 0xB5,0x05,0xD1,0x06,0x38,0x06,0x97,0x06,0xC5,0x06,0xDB,0x06,0xF1,0x06,0xF1,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x75,0x02,0x8F,0x02,0xA9,0x02,0xBF,0x02,0xEE,0x03,0x29,0x03,0x62,0x03,0x96,
//	0x39, 0, 19, 0xB7,0x03,0xFC,0x04,0x54,0x04,0xA2,0x04,0xE6,0x05,0x26,0x05,0x90,0x05,0xF9,0x06,0x4F,0x06,0xA3,
//	0x39, 0, 15, 0xB8,0x07,0x37,0x07,0xB9,0x08,0x2F,0x08,0x69,0x08,0x84,0x08,0x9F,0x08,0x9F,
//	0x39, 0, 2, 0xBF,0x14,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0xBE,0x02,0xC9,0x02,0xD4,0x02,0xDF,0x03,0x00,0x03,0x25,0x03,0x49,0x03,0x6F,
//	0x39, 0, 19, 0xB1,0x03,0xBA,0x04,0x04,0x04,0x44,0x04,0x82,0x04,0xBA,0x05,0x20,0x05,0x79,0x05,0xC9,0x06,0x18,
//	0x39, 0, 15, 0xB2,0x06,0x9E,0x07,0x15,0x07,0x82,0x07,0xB6,0x07,0xCE,0x07,0xE5,0x07,0xE5,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x6B,0x02,0x7E,0x02,0x91,0x02,0x9D,0x02,0xB5,0x02,0xD5,0x02,0xF3,0x03,0x10,
//	0x39, 0, 19, 0xB4,0x03,0x52,0x03,0x93,0x03,0xCB,0x04,0x01,0x04,0x33,0x04,0x8A,0x04,0xD3,0x05,0x18,0x05,0x5B,
//	0x39, 0, 15, 0xB5,0x05,0xCF,0x06,0x36,0x06,0x95,0x06,0xC1,0x06,0xD6,0x06,0xEA,0x06,0xEA,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x8B,0x02,0xA3,0x02,0xBB,0x02,0xCF,0x02,0xFA,0x03,0x30,0x03,0x64,0x03,0x95,
//	0x39, 0, 19, 0xB7,0x03,0xF3,0x04,0x50,0x04,0x99,0x04,0xE1,0x05,0x22,0x05,0x92,0x05,0xEF,0x06,0x43,0x06,0x95,
//	0x39, 0, 15, 0xB8,0x07,0x25,0x07,0xA7,0x08,0x1E,0x08,0x56,0x08,0x70,0x08,0x89,0x08,0x89,
//	0x39, 0, 2, 0xBF,0x13,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0xF5,0x03,0x01,0x03,0x0D,0x03,0x19,0x03,0x32,0x03,0x50,0x03,0x6F,0x03,0x8D,
//	0x39, 0, 19, 0xB1,0x03,0xCC,0x04,0x0B,0x04,0x45,0x04,0x7D,0x04,0xB1,0x05,0x15,0x05,0x6A,0x05,0xB4,0x05,0xFD,
//	0x39, 0, 15, 0xB2,0x06,0x82,0x06,0xF8,0x07,0x5F,0x07,0x91,0x07,0xA9,0x07,0xBF,0x07,0xBF,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0xA6,0x02,0xB7,0x02,0xC8,0x02,0xD9,0x02,0xEF,0x03,0x05,0x03,0x1F,0x03,0x38,
//	0x39, 0, 19, 0xB4,0x03,0x6C,0x03,0xA1,0x03,0xD4,0x04,0x05,0x04,0x30,0x04,0x86,0x04,0xCF,0x05,0x10,0x05,0x4F,
//	0x39, 0, 15, 0xB5,0x05,0xBF,0x06,0x20,0x06,0x7A,0x06,0xA5,0x06,0xB9,0x06,0xCC,0x06,0xCC,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0xC9,0x02,0xDE,0x02,0xF3,0x03,0x08,0x03,0x2C,0x03,0x55,0x03,0x81,0x03,0xAC,
//	0x39, 0, 19, 0xB7,0x03,0xFD,0x04,0x4C,0x04,0x91,0x04,0xD5,0x05,0x10,0x05,0x80,0x05,0xDF,0x06,0x2F,0x06,0x7D,
//	0x39, 0, 15, 0xB8,0x07,0x0C,0x07,0x8A,0x07,0xF9,0x08,0x2F,0x08,0x48,0x08,0x61,0x08,0x61,
//	0x39, 0, 2, 0xBF,0x12,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0x33,0x03,0x3E,0x03,0x49,0x03,0x54,0x03,0x6A,0x03,0x80,0x03,0x97,0x03,0xAD,
//	0x39, 0, 19, 0xB1,0x03,0xE1,0x04,0x13,0x04,0x47,0x04,0x79,0x04,0xA6,0x04,0xFE,0x05,0x4E,0x05,0x99,0x05,0xDE,
//	0x39, 0, 15, 0xB2,0x06,0x58,0x06,0xC7,0x07,0x2B,0x07,0x5B,0x07,0x71,0x07,0x88,0x07,0x88,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0xE6,0x02,0xF4,0x03,0x02,0x03,0x10,0x03,0x2C,0x03,0x3E,0x03,0x51,0x03,0x62,
//	0x39, 0, 19, 0xB4,0x03,0x8D,0x03,0xB5,0x03,0xE1,0x04,0x0C,0x04,0x33,0x04,0x7D,0x04,0xBF,0x04,0xFD,0x05,0x37,
//	0x39, 0, 15, 0xB5,0x05,0x9E,0x05,0xFB,0x06,0x50,0x06,0x79,0x06,0x8C,0x06,0xA0,0x06,0xA0,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0x0C,0x03,0x1D,0x03,0x2E,0x03,0x3F,0x03,0x61,0x03,0x7E,0x03,0x9F,0x03,0xBE,
//	0x39, 0, 19, 0xB7,0x04,0x05,0x04,0x44,0x04,0x85,0x04,0xC5,0x04,0xFA,0x05,0x62,0x05,0xBC,0x06,0x0F,0x06,0x5C,
//	0x39, 0, 15, 0xB8,0x06,0xE0,0x07,0x57,0x07,0xC1,0x07,0xF4,0x08,0x0C,0x08,0x26,0x08,0x26,
//	0x39, 0, 2, 0xBF,0x11,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0x7E,0x03,0x86,0x03,0x8E,0x03,0x96,0x03,0xA7,0x03,0xB8,0x03,0xC9,0x03,0xDC,
//	0x39, 0, 19, 0xB1,0x03,0xFE,0x04,0x24,0x04,0x4A,0x04,0x6F,0x04,0x96,0x04,0xE2,0x05,0x24,0x05,0x64,0x05,0xA2,
//	0x39, 0, 15, 0xB2,0x06,0x12,0x06,0x78,0x06,0xD4,0x07,0x01,0x07,0x17,0x07,0x2B,0x07,0x2B,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x03,0x29,0x03,0x35,0x03,0x41,0x03,0x4D,0x03,0x65,0x03,0x7D,0x03,0x8C,0x03,0x9B,
//	0x39, 0, 19, 0xB4,0x03,0xB7,0x03,0xD3,0x03,0xF2,0x04,0x14,0x04,0x34,0x04,0x72,0x04,0xA8,0x04,0xDD,0x05,0x10,
//	0x39, 0, 15, 0xB5,0x05,0x6D,0x05,0xC0,0x06,0x0D,0x06,0x32,0x06,0x44,0x06,0x55,0x06,0x55,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0x45,0x03,0x54,0x03,0x63,0x03,0x72,0x03,0x91,0x03,0xB0,0x03,0xCA,0x03,0xE3,
//	0x39, 0, 19, 0xB7,0x04,0x13,0x04,0x45,0x04,0x78,0x04,0xAA,0x04,0xDA,0x05,0x37,0x05,0x85,0x05,0xD1,0x06,0x16,
//	0x39, 0, 15, 0xB8,0x06,0x91,0x07,0x01,0x07,0x64,0x07,0x94,0x07,0xAB,0x07,0xC1,0x07,0xC1,
//	0x39, 0, 2, 0xBF,0x10,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0xE6,0x03,0xE9,0x03,0xEC,0x03,0xEF,0x03,0xF6,0x03,0xFD,0x04,0x04,0x04,0x0B,
//	0x39, 0, 19, 0xB1,0x04,0x1A,0x04,0x2D,0x04,0x45,0x04,0x59,0x04,0x6E,0x04,0x9E,0x04,0xCC,0x04,0xF8,0x05,0x22,
//	0x39, 0, 15, 0xB2,0x05,0x78,0x05,0xC5,0x06,0x11,0x06,0x36,0x06,0x47,0x06,0x56,0x06,0x56,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x03,0x8D,0x03,0x93,0x03,0x99,0x03,0x9F,0x03,0xAC,0x03,0xB9,0x03,0xC6,0x03,0xD3,
//	0x39, 0, 19, 0xB4,0x03,0xE4,0x03,0xF5,0x04,0x06,0x04,0x17,0x04,0x28,0x04,0x4E,0x04,0x72,0x04,0x96,0x04,0xB9,
//	0x39, 0, 15, 0xB5,0x04,0xFC,0x05,0x3A,0x05,0x77,0x05,0x94,0x05,0xA1,0x05,0xAF,0x05,0xAF,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0xB3,0x03,0xBA,0x03,0xC1,0x03,0xC8,0x03,0xD7,0x03,0xE6,0x03,0xF5,0x04,0x04,
//	0x39, 0, 19, 0xB7,0x04,0x1D,0x04,0x37,0x04,0x56,0x04,0x74,0x04,0x92,0x04,0xD1,0x05,0x0B,0x05,0x43,0x05,0x79,
//	0x39, 0, 15, 0xB8,0x05,0xDD,0x06,0x35,0x06,0x8B,0x06,0xB3,0x06,0xC5,0x06,0xD9,0x06,0xD9,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
//	0x39, 0, 2, 0xBF,0x42,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0xB0,0x03,0xDA,0x04,0x04,0x04,0x2E,0x04,0x77,0x04,0xB8,0x04,0xF8,0x05,0x33,
//	0x39, 0, 19, 0xB1,0x05,0xA6,0x06,0x06,0x06,0x64,0x06,0xB6,0x06,0xFF,0x07,0x8D,0x08,0x03,0x08,0x69,0x08,0xCD,
//	0x39, 0, 15, 0xB2,0x09,0x7A,0x0A,0x10,0x0A,0x94,0x0A,0xCF,0x0A,0xEE,0x0B,0x0C,0x0B,0x0C,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x03,0x06,0x03,0x2A,0x03,0x4E,0x03,0x65,0x03,0x97,0x03,0xDB,0x04,0x1E,0x04,0x5A,
//	0x39, 0, 19, 0xB4,0x04,0xCF,0x05,0x25,0x05,0x79,0x05,0xC3,0x06,0x03,0x06,0x80,0x06,0xE1,0x07,0x3B,0x07,0x93,
//	0x39, 0, 15, 0xB5,0x08,0x27,0x08,0xA5,0x09,0x1A,0x09,0x4C,0x09,0x67,0x09,0x80,0x09,0x80,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0x3D,0x03,0x76,0x03,0xAF,0x03,0xDF,0x04,0x41,0x04,0xA4,0x05,0x06,0x05,0x55,
//	0x39, 0, 19, 0xB7,0x05,0xF1,0x06,0x63,0x06,0xD4,0x07,0x2D,0x07,0x7D,0x08,0x1B,0x08,0x95,0x09,0x00,0x09,0x6A,
//	0x39, 0, 15, 0xB8,0x0A,0x1E,0x0A,0xBE,0x0B,0x51,0x0B,0x93,0x0B,0xB7,0x0B,0xD9,0x0B,0xD9,
//	0x39, 0, 2, 0xBF,0x41,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x02,0xCF,0x03,0xCB,0x03,0xEB,0x04,0x0B,0x04,0x47,0x04,0x7E,0x04,0xCC,0x04,0xFD,
//	0x39, 0, 19, 0xB1,0x05,0x2A,0x05,0x78,0x05,0xC9,0x06,0x12,0x06,0x99,0x06,0xE1,0x07,0x30,0x07,0x9A,0x07,0xF4,
//	0x39, 0, 15, 0xB2,0x08,0x44,0x08,0xE8,0x09,0xAD,0x09,0xE6,0x0A,0x03,0x0A,0x1D,0x0A,0x20,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x02,0x4E,0x03,0x1D,0x03,0x39,0x03,0x52,0x03,0x76,0x03,0x9E,0x03,0xF0,0x04,0x23,
//	0x39, 0, 19, 0xB4,0x04,0x50,0x04,0xA0,0x04,0xEE,0x05,0x2F,0x05,0xA9,0x05,0xE9,0x06,0x2E,0x06,0x8B,0x06,0xD5,
//	0x39, 0, 15, 0xB5,0x07,0x1A,0x07,0xAA,0x08,0x52,0x08,0x82,0x08,0x9A,0x08,0xB1,0x08,0xB3,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x78,0x03,0x62,0x03,0x8D,0x03,0xB7,0x04,0x01,0x04,0x4C,0x04,0xC3,0x05,0x0C,
//	0x39, 0, 19, 0xB7,0x05,0x48,0x05,0xB3,0x06,0x1A,0x06,0x71,0x07,0x0E,0x07,0x5C,0x07,0xB4,0x08,0x28,0x08,0x85,
//	0x39, 0, 15, 0xB8,0x08,0xD9,0x09,0x86,0x0A,0x54,0x0A,0x91,0x0A,0xB0,0x0A,0xCD,0x0A,0xD0,
//	0x39, 0, 2, 0xBF,0x40,
//	0x39, 0, 19, 0xB0,0x00,0x00,0x03,0xCD,0x03,0xD2,0x03,0xD7,0x03,0xDC,0x03,0xF4,0x04,0x10,0x04,0x2A,0x04,0x42,
//	0x39, 0, 19, 0xB1,0x04,0x6F,0x04,0x99,0x04,0xC1,0x04,0xF0,0x05,0x17,0x05,0x62,0x05,0xAB,0x05,0xED,0x06,0x2E,
//	0x39, 0, 15, 0xB2,0x06,0x9C,0x06,0xFE,0x07,0x5C,0x07,0x8C,0x07,0xA0,0x07,0xB2,0x07,0xB2,
//	0x39, 0, 19, 0xB3,0x00,0x00,0x03,0x2F,0x03,0x37,0x03,0x3F,0x03,0x44,0x03,0x4B,0x03,0x54,0x03,0x5B,0x03,0x6D,
//	0x39, 0, 19, 0xB4,0x03,0x8F,0x03,0xB8,0x03,0xE0,0x04,0x0E,0x04,0x38,0x04,0x8A,0x04,0xCF,0x05,0x0D,0x05,0x49,
//	0x39, 0, 15, 0xB5,0x05,0xAF,0x06,0x06,0x06,0x56,0x06,0x79,0x06,0x8C,0x06,0x9E,0x06,0x9E,
//	0x39, 0, 19, 0xB6,0x00,0x00,0x03,0x72,0x03,0x78,0x03,0x7E,0x03,0x83,0x03,0x9B,0x03,0xB6,0x03,0xCF,0x03,0xF0,
//	0x39, 0, 19, 0xB7,0x04,0x30,0x04,0x70,0x04,0xAE,0x04,0xF1,0x05,0x27,0x05,0x91,0x05,0xEF,0x06,0x3F,0x06,0x8D,
//	0x39, 0, 15, 0xB8,0x07,0x11,0x07,0x80,0x07,0xE1,0x08,0x11,0x08,0x28,0x08,0x3D,0x08,0x3D,
//	0x39, 0, 2, 0xCE,0x01,
//	0x39, 0, 2, 0xCC,0x00,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
//	0x39, 0, 25, 0xB9,0x00,0x04,0x00,0x0C,0x00,0x14,0x00,0x1C,0x00,0x2C,0x00,0x3C,0x00,0x5C,0x00,0x7C,0x00,0x9C,0x00,0xBC,0x00,0xDC,0x00,0xFC,
//	0x39, 0, 25, 0xBA,0x01,0x3C,0x01,0x7C,0x01,0xBC,0x01,0xFC,0x02,0x3C,0x02,0x7C,0x02,0xFC,0x03,0x7C,0x03,0xBC,0x03,0xDC,0x03,0xFC,0x03,0xFF,

//	/////////#1_gamma.txt end///////////
//	#endif


//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x03,
//	0x39, 0, 6, 0xB2,0x00,0x1F,0x1F,0x06,0x01,
//	0x39, 0, 2, 0x6F,0x05,
//	0x39, 0, 13, 0xB2,0x00,0x10,0x10,0x00,0x0F,0x0F,0x00,0x10,0x10,0x00,0x1F,0x1F,
//	0x39, 0, 2, 0x6F,0x11,
//	0x39, 0, 9, 0xB2,0x06,0x01,0x06,0x01,0x06,0x01,0x06,0x01,
//	0x39, 0, 2, 0x6F,0x19,
//	0x39, 0, 2, 0xB2,0x00,
//	0x39, 0, 16, 0xB6,0xF0,0x1C,0x1C,0x00,0x10,0x01,0x00,0x10,0x01,0x00,0x10,0x01,0x00,0x1C,0x1C,
//	0x39, 0, 2, 0x6F,0x0F,
//	0x39, 0, 4, 0xB6,0x1F,0x00,0x0A,
//	0x39, 0, 2, 0x6F,0x1A,
//	0x39, 0, 4, 0xB6,0x0F,0x00,0x0A,
//	0x39, 0, 2, 0x6F,0x25,
//	0x39, 0, 4, 0xB6,0x0F,0x00,0x0A,
//	0x39, 0, 2, 0x6F,0x30,
//	0x39, 0, 4, 0xB6,0x0F,0x00,0x0A,
//	0x39, 0, 17, 0xBB,0x11,0x00,0x1D,0x7E,0x00,0x0F,0x5E,0x00,0x0E,0x4C,0x00,0x00,0x00,0x00,0x1D,0x7E,
//	0x39, 0, 17, 0xBC,0x22,0x10,0x1D,0x5C,0x00,0x0F,0x3C,0x00,0x0E,0x29,0x00,0x00,0x00,0x00,0x1D,0x5C,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x04,
//	0x39, 0, 2, 0xC2,0x14,
//	0x39, 0, 2, 0xB1,0x02,
//	0x39, 0, 2, 0xB2,0x40,
//	0x39, 0, 2, 0x6F,0x01,
//	0x39, 0, 4, 0xB2,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x04,
//	0x39, 0, 4, 0xB2,0x09,0xE3,0x40,
//	0x39, 0, 2, 0x6F,0x07,
//	0x39, 0, 4, 0xB2,0x09,0xE4,0x00,
//	0x39, 0, 2, 0x6F,0x0A,
//	0x39, 0, 4, 0xB2,0x09,0xE3,0x40,
//	0x39, 0, 2, 0xCB,0x86,
//	0x39, 0, 5, 0xD0,0x00,0x00,0x00,0x10,
//	0x39, 0, 2, 0x6F,0x04,
//	0x39, 0, 2, 0xD0,0x01,
//	0x39, 0, 2, 0x6F,0x01,
//	0x39, 0, 6, 0xCB,0x05,0x0F,0x1F,0x3E,0x7C,
//	0x39, 0, 2, 0x6F,0x06,
//	0x39, 0, 11, 0xCB,0x00,0x08,0x00,0x3C,0x01,0x48,0x07,0xFF,0x0F,0xFF,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 6, 0xD2,0x12,0x0C,0x0C,0x0A,0x06,
//	0x39, 0, 2, 0x6F,0x05,
//	0x39, 0, 6, 0xD2,0x30,0x14,0x16,0x0E,0x0A,
//	0x39, 0, 2, 0x6F,0x0A,
//	0x39, 0, 6, 0xD2,0x48,0x20,0x16,0x12,0x0E,
//	0x39, 0, 2, 0x6F,0x0F,
//	0x39, 0, 6, 0xD2,0x44,0x20,0x16,0x12,0x15,
//	0x39, 0, 2, 0x6F,0x14,
//	0x39, 0, 6, 0xD2,0x40,0x20,0x16,0x12,0x12,
//	0x39, 0, 2, 0x6F,0x19,
//	0x39, 0, 6, 0xD2,0xFF,0xE4,0xA9,0x40,0x30,
//	0x39, 0, 2, 0x6F,0x1E,
//	0x39, 0, 6, 0xD2,0xFF,0xD8,0x40,0x26,0x20,
//	0x39, 0, 2, 0x6F,0x23,
//	0x39, 0, 6, 0xD2,0xFF,0x8F,0x40,0x26,0x1F,
//	0x39, 0, 2, 0x6F,0x28,
//	0x39, 0, 6, 0xD2,0x9F,0x60,0x40,0x20,0x1B,
//	0x39, 0, 2, 0x6F,0x2D,
//	0x39, 0, 6, 0xD2,0x84,0x40,0x40,0x20,0x1B,
//	0x39, 0, 2, 0x6F,0x32,
//	0x39, 0, 6, 0xD2,0x12,0x08,0x10,0x10,0x06,
//	0x39, 0, 2, 0x6F,0x37,
//	0x39, 0, 6, 0xD2,0x30,0x08,0x15,0x0B,0x0A,
//	0x39, 0, 2, 0x6F,0x3C,
//	0x39, 0, 6, 0xD2,0x46,0x08,0x10,0x10,0x0C,
//	0x39, 0, 2, 0x6F,0x41,
//	0x39, 0, 6, 0xD2,0x30,0x1A,0x10,0x16,0x16,
//	0x39, 0, 2, 0x6F,0x46,
//	0x39, 0, 6, 0xD2,0x30,0x1A,0x10,0x12,0x12,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 6, 0xD4,0x08,0x08,0x04,0x0C,0x06,
//	0x39, 0, 2, 0x6F,0x05,
//	0x39, 0, 6, 0xD4,0x29,0x18,0x10,0x0D,0x0A,
//	0x39, 0, 2, 0x6F,0x0A,
//	0x39, 0, 6, 0xD4,0x40,0x14,0x10,0x11,0x0C,
//	0x39, 0, 2, 0x6F,0x0F,
//	0x39, 0, 6, 0xD4,0x40,0x1F,0x13,0x14,0x10,
//	0x39, 0, 2, 0x6F,0x14,
//	0x39, 0, 6, 0xD4,0x5f,0x16,0x14,0x16,0x13,
//	0x39, 0, 2, 0x6F,0x19,
//	0x39, 0, 6, 0xD4,0xFF,0xFF,0xA0,0x50,0x2F,
//	0x39, 0, 2, 0x6F,0x1E,
//	0x39, 0, 6, 0xD4,0xFF,0xF0,0x9A,0x30,0x0C,
//	0x39, 0, 2, 0x6F,0x23,
//	0x39, 0, 6, 0xD4,0xFF,0xA0,0x6A,0x30,0x0F,
//	0x39, 0, 2, 0x6F,0x28,
//	0x39, 0, 6, 0xD4,0xF0,0x80,0x40,0x30,0x12,
//	0x39, 0, 2, 0x6F,0x2D,
//	0x39, 0, 6, 0xD4,0xB0,0x40,0x40,0x30,0x14,
//	0x39, 0, 2, 0x6F,0x32,
//	0x39, 0, 6, 0xD4,0x04,0x04,0x04,0x0A,0x05,
//	0x39, 0, 2, 0x6F,0x37,
//	0x39, 0, 6, 0xD4,0x32,0x14,0x10,0x0B,0x07,
//	0x39, 0, 2, 0x6F,0x3C,
//	0x39, 0, 6, 0xD4,0x40,0x18,0x10,0x0C,0x09,
//	0x39, 0, 2, 0x6F,0x41,
//	0x39, 0, 6, 0xD4,0x20,0x1C,0x1A,0x0E,0x0B,
//	0x39, 0, 2, 0x6F,0x46,
//	0x39, 0, 6, 0xD4,0xB5,0x18,0x18,0x08,0x0C,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x05,
//	0x39, 0, 3, 0xC7,0x07,0x01,
//	0x39, 0, 4, 0xB0,0x07,0x21,0x00,
//	0x39, 0, 3, 0xB3,0x86,0x80,
//	0x39, 0, 3, 0xB5,0x85,0x81,
//	0x39, 0, 5, 0xB7,0x85,0x00,0x00,0x81,
//	0x39, 0, 5, 0xB8,0x85,0x00,0x00,0x81,
//	0x39, 0, 5, 0xB9,0x85,0x00,0x00,0x81,
//	0x39, 0, 4, 0xD0,0x00,0x03,0x10,
//	0x39, 0, 5, 0xE0,0x82,0x00,0x00,0x02,
//	0x39, 0, 4, 0xD1,0x00,0x01,0x10,
//	0x39, 0, 5, 0xE1,0x82,0x00,0x00,0x02,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x06,
//	0x39, 0, 6, 0xB0,0x13,0x32,0x12,0x32,0x04,
//	0x39, 0, 6, 0xB1,0x32,0x31,0x0E,0x32,0x31,
//	0x39, 0, 6, 0xB2,0x32,0x00,0x32,0x31,0x32,
//	0x39, 0, 2, 0xB3,0x0F,
//	0x39, 0, 6, 0xB6,0x13,0x32,0x12,0x32,0x04,
//	0x39, 0, 6, 0xB7,0x32,0x31,0x0E,0x32,0x31,
//	0x39, 0, 6, 0xB8,0x32,0x00,0x32,0x31,0x32,
//	0x39, 0, 2, 0xB9,0x0F,
//	0x39, 0, 2, 0xD0,0x01,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x07,
//	0x39, 0, 2, 0xB4,0xC0,
//	0x39, 0, 6, 0xB0,0x84,0xC0,0x78,0x70,0x00,
//	0x39, 0, 7, 0xB1,0x0C,0x1C,0x00,0x1C,0x0C,0x00,
//	0x39, 0, 2, 0xB2,0x20,
//	0x39, 0, 2, 0x6F,0x36,
//	0x39, 0, 2, 0xB2,0x32,
//	0x39, 0, 2, 0x6F,0x3F,
//	0x39, 0, 2, 0xB2,0x04,
//	0x39, 0, 2, 0x6F,0x09,
//	0x39, 0, 2, 0xB2,0x20,
//	0x39, 0, 2, 0x6F,0x48,
//	0x39, 0, 2, 0xB2,0x32,
//	0x39, 0, 2, 0x6F,0x51,
//	0x39, 0, 2, 0xB2,0x04,
//	0x39, 0, 2, 0x6F,0x12,
//	0x39, 0, 2, 0xB2,0xF0,
//	0x39, 0, 2, 0x6F,0x5A,
//	0x39, 0, 2, 0xB2,0x03,
//	0x39, 0, 2, 0x6F,0x63,
//	0x39, 0, 2, 0xB2,0x9B,
//	0x39, 0, 2, 0x6F,0x1B,
//	0x39, 0, 2, 0xB2,0x20,
//	0x39, 0, 2, 0x6F,0x6C,
//	0x39, 0, 2, 0xB2,0x32,
//	0x39, 0, 2, 0x6F,0x75,
//	0x39, 0, 2, 0xB2,0x04,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 2, 0xB2,0x20,
//	0x39, 0, 2, 0x6F,0x7E,
//	0x39, 0, 2, 0xB2,0x32,
//	0x39, 0, 2, 0x6F,0x87,
//	0x39, 0, 2, 0xB2,0x04,
//	0x39, 0, 2, 0x6F,0x2D,
//	0x39, 0, 2, 0xB2,0xCC,
//	0x39, 0, 2, 0x6F,0x90,
//	0x39, 0, 2, 0xB2,0x03,
//	0x39, 0, 2, 0x6F,0x99,
//	0x39, 0, 2, 0xB2,0x3A,
//	0x39, 0, 2, 0xB4,0xC0,
//	0x39, 0, 3, 0xB7,0x00,0x00,
//	0x39, 0, 6, 0xC0,0x01,0x01,0x00,0x00,0x55,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC1,0x2C,0x00,0x1C,0x39,0x1C,0x39,0x38,0x72,0x3F,0xD9,0xA2,0x84,0x40,0x00,0xE7,0x18,0x80,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC1,0x90,0x00,0x0A,0x90,0x59,0x5F,0x33,0xE0,0x00,0x00,0x0C,0xAB,0x59,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC2,0x2A,0x0F,0x1C,0x39,0x1C,0x39,0xC7,0x8E,0x00,0x12,0xBD,0xDA,0x40,0x14,0x86,0xBA,0xFF,0xF6,0x12,0xBF,0x8D,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC2,0x93,0xDE,0x0A,0x94,0x37,0x5F,0x33,0xEF,0xE2,0x73,0x00,0x55,0x59,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC3,0x26,0x00,0x1C,0x39,0x1C,0x39,0x38,0x72,0x00,0x00,0x00,0x00,0x3F,0xD8,0xBB,0x6C,0x80,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC3,0x03,0xDE,0x00,0x04,0x37,0x55,0x33,0x60,0x00,0x00,0x03,0x55,0xA7,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC4,0x20,0x0F,0x1C,0x39,0x1C,0x39,0xC7,0x8E,0x3F,0xEC,0x60,0x5E,0x3F,0xEC,0x5B,0x0E,0x80,0x03,0x69,0x3F,0xA9,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC4,0x00,0x00,0x00,0x00,0x59,0x55,0x33,0x60,0x1D,0x8D,0x0F,0xAB,0xA7,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC5,0x21,0x00,0x03,0xC1,0x03,0x49,0x00,0x00,0x3F,0xFF,0x26,0x46,0x3F,0xFF,0x34,0x52,0x00,0x00,0x0C,0x55,0x09,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC5,0x01,0xFE,0x14,0x02,0x1B,0x33,0x33,0x80,0x03,0x83,0x0F,0xE1,0xE3,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC6,0x27,0x00,0x03,0x84,0x03,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xFF,0x3A,0xE4,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC6,0x02,0x1C,0x14,0x02,0x39,0x32,0x33,0x80,0x00,0x00,0x03,0x1E,0xE3,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC7,0x2D,0x00,0x03,0x84,0x03,0x49,0x00,0x00,0x3F,0xFF,0x34,0x18,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC7,0x01,0xFE,0x34,0x02,0x1B,0x52,0x33,0x50,0x00,0x00,0x0C,0xE2,0x1D,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC8,0x2B,0x00,0x03,0xC1,0x03,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xF3,0xAA,0xF7,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC8,0x02,0x1C,0x33,0x02,0x39,0x52,0x33,0x6F,0xFC,0x7D,0x00,0x1F,0x1D,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x00,
//	0x39, 0, 22, 0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x15,
//	0x39, 0, 16, 0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x24,
//	0x39, 0, 8, 0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x08,
//	0x39, 0, 17, 0xB6,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 17, 0xB6,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,
//	0x39, 0, 2, 0x6F,0x20,
//	0x39, 0, 7, 0xB6,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,
//	0x39, 0, 17, 0xB7,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 17, 0xB7,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x20,
//	0x39, 0, 7, 0xB7,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 17, 0xB8,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 17, 0xB8,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x20,
//	0x39, 0, 7, 0xB8,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 17, 0xB9,0x01,0x01,0x00,0x91,0x00,0x38,0x60,0x00,0x00,0x00,0xA6,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 17, 0xB9,0x00,0x00,0x00,0x00,0x01,0x00,0x05,0x00,0x0C,0x00,0x1F,0x00,0x44,0x00,0x86,0x00,
//	0x39, 0, 2, 0x6F,0x20,
//	0x39, 0, 17, 0xB9,0xF5,0x01,0xB3,0x02,0xD7,0x04,0x1C,0x05,0x61,0x06,0xA6,0x07,0xEB,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x30,
//	0x39, 0, 17, 0xB9,0x00,0x00,0x00,0x00,0x01,0x00,0x02,0x00,0x05,0x00,0x0C,0x00,0x18,0x00,0x2C,0x00,
//	0x39, 0, 2, 0x6F,0x40,
//	0x39, 0, 17, 0xB9,0x4F,0x00,0xAD,0x01,0x27,0x01,0xA1,0x02,0x1B,0x02,0x95,0x03,0x0F,0x03,0x89,0x00,
//	0x39, 0, 2, 0x6F,0x50,
//	0x39, 0, 17, 0xB9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x0D,0x00,0x1D,0x00,
//	0x39, 0, 2, 0x6F,0x60,
//	0x39, 0, 17, 0xB9,0x48,0x00,0x9D,0x01,0x34,0x02,0x32,0x03,0xE4,0x05,0xF6,0x08,0xF1,0x0B,0xEC,0x0E,
//	0x39, 0, 2, 0x6F,0x70,
//	0x39, 0, 17, 0xB9,0xE7,0x03,0xD0,0xB0,0xE0,0x0A,0x80,0x80,0x82,0x7D,0x7B,0x79,0x77,0x72,0x70,0x80,
//	0x39, 0, 2, 0x6F,0x80,
//	0x39, 0, 17, 0xB9,0x80,0x80,0x7D,0x7E,0x7B,0x7B,0x77,0x73,0x80,0x80,0x82,0x81,0x80,0x7F,0x7E,0x7B,
//	0x39, 0, 2, 0x6F,0x90,
//	0x39, 0, 17, 0xB9,0x78,0x80,0x80,0x81,0x82,0x82,0x82,0x81,0x7F,0x7C,0x80,0x80,0x80,0x83,0x86,0x86,
//	0x39, 0, 2, 0x6F,0xA0,
//	0x39, 0, 17, 0xB9,0x85,0x81,0x7D,0x80,0x80,0x82,0x81,0x84,0x85,0x87,0x85,0x88,0x80,0x80,0x81,0x8B,
//	0x39, 0, 2, 0x6F,0xB0,
//	0x39, 0, 17, 0xB9,0x88,0x8A,0x8C,0x8D,0x8E,0x80,0x80,0x84,0x87,0x8A,0x8C,0x8F,0x90,0x91,0x80,0x80,
//	0x39, 0, 2, 0x6F,0xC0,
//	0x39, 0, 17, 0xB9,0x84,0x87,0x8A,0x8D,0x91,0x91,0x92,0x80,0x80,0x85,0x88,0x8D,0x8F,0x8F,0x95,0x96,
//	0x39, 0, 2, 0x6F,0xD0,
//	0x39, 0, 17, 0xB9,0x80,0x80,0x7A,0x73,0x6E,0x69,0x66,0x60,0x5D,0x80,0x80,0x80,0x80,0x76,0x74,0x70,
//	0x39, 0, 2, 0x6F,0xE0,
//	0x39, 0, 17, 0xB9,0x6C,0x6A,0x80,0x80,0x81,0x7F,0x7F,0x7C,0x7B,0x76,0x73,0x80,0x80,0x83,0x83,0x83,
//	0x39, 0, 2, 0x6F,0xF0,
//	0x39, 0, 14, 0xB9,0x82,0x82,0x7F,0x7C,0x80,0x80,0x82,0x84,0x85,0x84,0x87,0x83,0x80,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
//	0x39, 0, 2, 0x6F,0x20,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
//	0x39, 0, 2, 0x6F,0x30,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
//	0x39, 0, 2, 0x6F,0x40,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
//	0x39, 0, 2, 0x6F,0x50,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
//	0x39, 0, 2, 0x6F,0x60,
//	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x05,0xD1,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x70,
//	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0x80,
//	0x39, 0, 17, 0xBA,0x08,0x00,0x05,0x3E,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,
//	0x39, 0, 2, 0x6F,0x90,
//	0x39, 0, 17, 0xBA,0x07,0x36,0x07,0x36,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x05,0x3E,0x07,0x36,
//	0x39, 0, 2, 0x6F,0xA0,
//	0x39, 0, 17, 0xBA,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x08,0x00,
//	0x39, 0, 2, 0x6F,0xB0,
//	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x05,0xD1,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0xC0,
//	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0xD0,
//	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 2, 0x6F,0xE0,
//	0x39, 0, 11, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
//	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,
//	0x39, 0, 2, 0x6F,0x10,
//	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x2C,0x01,0x2C,0x01,0x2C,
//	0x39, 0, 2, 0x6F,0x20,
//	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x00,0x01,0x00,
//	0x39, 0, 2, 0x6F,0x30,
//	0x39, 0, 17, 0xBB,0x01,0x00,0x01,0x00,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,
//	0x39, 0, 2, 0x6F,0x40,
//	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x2C,
//	0x39, 0, 2, 0x6F,0x50,
//	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,
//	0x39, 0, 2, 0x6F,0x60,
//	0x39, 0, 17, 0xBB,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
//	0x39, 0, 2, 0x6F,0x70,
//	0x39, 0, 17, 0xBB,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
//	0x39, 0, 2, 0x6F,0x80,
//	0x39, 0, 17, 0xBB,0x01,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//	0x39, 0, 2, 0x6F,0x90,
//	0x39, 0, 17, 0xBB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x10,
//	0x39, 0, 2, 0x6F,0xA0,
//	0x39, 0, 5, 0xBB,0x80,0x80,0x80,0x00,
//	0x39, 0, 2, 0xEE,0x05,
//	0x39, 0, 5, 0xFF,0xAA,0x55,0xA5,0x80,
//	0x39, 0, 2, 0x6F,0x1D,
//	0x39, 0, 2, 0xF2,0x05,
//	0x39, 0, 5, 0x3B,0x00,0x14,0x00,0x12,
//	0x39, 0, 2, 0x03,0x01,
//	0x39, 0, 2, 0x90,0x02,
//	0x39, 0, 19, 0x91,0x89,0x28,0x00,0x0C,0xC2,0x00,0x03,0x1C,0x01,0x7E,0x00,0x0F,0x08,0xBB,0x04,0x3D,0x10,0xF0,
//	0x39, 0, 1, 0x2C,
//	0x39, 0, 5, 0x51,0x07,0xFF,0x0F,0xFF,
//	0x39, 0, 2, 0x53,0x20,
//	0x39, 0, 1, 0x35,
//	0x39, 0, 5, 0x2A,0x00,0x00,0x04,0x37,
//	0x39, 0, 5, 0x2B,0x00,0x00,0x09,0x5F,
//	0x39, 0, 2, 0x2F,0x01,

//	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x00,
//	0x39, 0, 2, 0xC0,0x77,
////	0x39, 0, 5, 0x3B,0x00,0x10,0x09,0x90,
////	0x39, 0, 2, 0x90,0x00,
////	0x05, 0, 1, 0x2C,
//	0x39, 0, 3, 0x51,0x03,0x00,

//#if 0//BIST MODE
//	0x39, 0, 6,0xF0,0x55,0xAA,0x52,0x08,0x00,
//	0x39, 0, 8,0xEF,0x01,0x02,0xFF,0xFF,0xFF,0x17,0xFF,
//	0x39, 0, 5,0xEE,0x87,0x78,0x02,0x40
//#endif

//#endif	
0x39,0,5,0xFF,0xAA,0x55,0xA5,0x80,
0x39,0,2,0x6F,0x1D,
0x39,0,2,0xF2,0x05,
0x39,0,5,0xFF,0xAA,0x55,0xA5,0x81,
0x39,0,1,0x35,
0x39,0,2,0x53,0x20,
0x39,0,5,0x51,0x0D,0xBB,0x0F,0xFE,
0x39,0,5,0x2A,0x00,0x00,0x04,0xAF,
0x39,0,5,0x2B,0x00,0x00,0x0A,0x5B,
0x39,0,2,0x82,0xAC,
0x39,0,2,0x03,0x01,
0x39,0,2,0x90,0x01,
0x39,0,19,0x91,0x89,0x28,0x00,0x0C,0xC2,0x00,0x03,0x58,0x01,0x8A,0x00,0x10,0x08,0xBB,0x03,0xD1,0x10,0xF0,
0x39,0,1,0x2C,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x07,
0x39,0,2,0x6F,0x04,
0x39,0,2,0xC0,0x55,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC9,0x21,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x3F,0xE5,0x00,0x00,0x3F,0xE5,0x00,0x00,0x80,0x05,0x10,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC9,0x91,0xF1,0x19,0x92,0x51,0x79,0x33,0xC0,0x24,0x00,0x0F,0xA0,0xA0,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCA,0x27,0x00,0x24,0x00,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE5,0x8F,0x40,0x80,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCA,0x92,0x52,0x19,0x92,0xB1,0x79,0x33,0xB0,0x00,0x00,0x03,0x60,0xA1,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCB,0x2D,0x00,0x23,0x41,0x24,0x00,0x00,0x00,0x3F,0xE5,0x8F,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCB,0x91,0xF1,0x7A,0x92,0x51,0xD9,0x33,0x20,0x00,0x00,0x0C,0xA1,0x60,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCC,0x2B,0x00,0x23,0x41,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x7F,0xFB,0x25,0x29,0x7F,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCC,0x92,0x52,0x7A,0x92,0xB1,0xD9,0x33,0x3F,0xDC,0xBF,0x00,0x5F,0x5F,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x02,
0x39,0,2,0xD1,0x01,
0x39,0,2,0x6F,0x01,
0x39,0,2,0xD1,0x00,
0x39,0,2,0x6F,0x02,
0x39,0,2,0xD1,0x00,
0x39,0,2,0x6F,0x03,
0x39,0,5,0xD1,0x02,0x52,0x09,0x7A,
0x39,0,2,0x6F,0x07,
0x39,0,5,0xD1,0x01,0xF1,0x09,0x19,
0x39,0,2,0x6F,0x0B,
0x39,0,5,0xD1,0x02,0xB1,0x09,0xD9,
0x39,0,2,0x6F,0x0F,
0x39,0,7,0xD1,0x3F,0xFC,0x3F,0xFC,0x3F,0xFC,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x07,
0x39,0,2,0xD9,0x40,
0x39,0,2,0x88,0x01,
0x39,0,2,0x6F,0x01,
0x39,0,5,0x88,0x02,0x4B,0x09,0x78,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x09,
0x39,0,2,0xD5,0x80,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x00,
0x39,0,31,0xb0,0x04,0x03,0x0c,0x1e,0x38,0x5b,0x89,0xc0,0xff,0x55,0x56,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,243,0xb2,0x11,0x63,0x20,0x20,0x00,0x08,0x08,0x00,0x00,0x40,0x00,0x00,0x00,0x20,0x00,0x70,0x90,0xa5,0x02,0x05,0x02,0x25,0x03,0x0f,0xff,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x39,0x01,0xba,0x02,0xd9,0x03,0xe8,0x04,0xc6,0x06,0x3d,0x0b,0x03,0x0d,0x13,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,
0x39,0,151,0xb3,0x00,0x01,0x00,0xda,0x00,0xda,0x01,0xd6,0x01,0xd6,0x02,0xbf,0x02,0xbf,0x03,0xa5,0x03,0xa5,0x05,0x02,0x05,0x02,0x05,0x03,0x05,0x03,0x0a,0xc9,0x0a,0xc9,0x0d,0xbb,0x0d,0xbb,0x0f,0xff,0x01,0xff,0x02,0xff,0x02,0xff,0x04,0x00,0x0e,0x00,0x0d,0x28,0x0c,0xba,0x0c,0xba,0x0b,0xe6,0x0b,0xe6,0x0a,0x80,0x0a,0x80,0x08,0x44,0x08,0x44,0x04,0x34,0x04,0x34,0x00,0x11,0x00,0x11,0x00,0x11,0x00,0x11,0x00,0x11,0x00,0x11,0x00,0x11,0x00,0x01,0x00,0xda,0x01,0xd6,0x02,0xbf,0x03,0xa5,0x05,0x02,0x0a,0xc9,0x0d,0xbb,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,0x0f,0xff,
0x39,0,125,0xb4,0x0a,0x80,0x09,0xe0,0x09,0x8c,0x09,0x8c,0x08,0xec,0x08,0xec,0x07,0xe0,0x07,0xe0,0x06,0x34,0x06,0x34,0x03,0x28,0x03,0x28,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x0a,0x80,0x09,0x6c,0x07,0x58,0x07,0x58,0x05,0x3c,0x15,0x00,0x13,0xbc,0x13,0x18,0x13,0x18,0x11,0xd8,0x11,0xd8,0x0f,0xc0,0x0f,0xc0,0x0c,0x68,0x0c,0x68,0x06,0x4e,0x06,0x4e,0x00,0x1a,0x00,0x1a,0x00,0x1a,0x00,0x1a,0x00,0x1a,0x00,0x1a,0x00,0x1a,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,0x00,0x0d,
0x39,0,39,0xb5,0x84,0x42,0x25,0x00,0x00,0x7f,0x4b,0x13,0x4f,0x00,0x00,0x40,0x25,0x00,0x00,0x00,0x13,0x13,0x13,0x13,0x13,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x25,0x00,0x00,0x00,0x00,0x00,
0x39,0,16,0xb6,0x00,0x19,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,61,0xb7,0x21,0x0f,0xed,0xcb,0xa9,0x87,0x65,0x43,0x21,0x00,0x00,0x00,0x05,0x01,0x00,0x00,0x00,0x00,0x00,0xab,0xbc,0xcc,0xdd,0xde,0xee,0xee,0xff,0xff,0xff,0xff,0xff,0xc9,0x35,0xa1,0x0d,0x79,0xe5,0x51,0xbb,0xf0,0x25,0x5a,0x8f,0xc4,0xf9,0x2e,0x63,0x98,0xcd,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x39,0,82,0xb8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,6,0xb9,0x00,0xb4,0x04,0x04,0x00,
0x39,0,36,0xba,0x01,0x8a,0x00,0x10,0x00,0x14,0x00,0x01,0x01,0x8a,0x00,0x10,0x03,0x94,0x00,0x00,0x01,0x8a,0x00,0x10,0x0a,0x94,0x00,0x01,0x8a,0x00,0x10,0x00,0x14,0x00,0x00,0x00,0x01,0x3b,0x01,
0x39,0,9,0xbb,0x01,0x8a,0x00,0x10,0x00,0x14,0x00,0x41,
0x39,0,19,0xbc,0x1c,0x15,0x02,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,4,0xbd,0x05,0x2e,0x00,
0x39,0,12,0xbe,0x0e,0x09,0x10,0x11,0x00,0x0f,0x00,0x00,0x00,0x00,0x00,
0x39,0,3,0xbf,0x00,0x01,
0x39,0,17,0xc0,0x7e,0xb3,0x21,0x02,0x00,0x00,0x60,0x1b,0x55,0x20,0x40,0x60,0x80,0xe0,0x00,0x00,
0x39,0,4,0xc0,0x6D,0xB3,0x20,
0x39,0,13,0xc1,0x00,0x80,0x00,0x58,0x00,0x58,0x00,0x58,0x00,0x58,0x00,0x58,
0x39,0,2,0xc2,0x00,
0x39,0,10,0xc3,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,8,0xc4,0x00,0x00,0x38,0x01,0x00,0x01,0x00,
0x39,0,3,0xc5,0x05,0x00,
0x39,0,56,0xc6,0x55,0x55,0x55,0x55,0x11,0x11,0x11,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x85,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,
0x39,0,2,0xc7,0x00,
0x39,0,2,0xc9,0x04,
0x39,0,5,0xca,0x32,0x01,0x82,0xa0,
0x39,0,3,0xcb,0x80,0x02,
0x39,0,25,0xcc,0x40,0x54,0x5a,0x60,0x66,0x6a,0x6c,0x6c,0x68,0x62,0x5b,0x53,0x4d,0x48,0x44,0x41,0x40,0x50,0x60,0x70,0x58,0x68,0x78,0x77,
0x39,0,18,0xcd,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x45,0x49,0x4c,0x4b,0x48,0x44,0x41,0x40,
0x39,0,104,0xce,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,105,0xcf,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,7,0xd0,0x00,0x00,0xff,0x77,0x04,0x1d,
0x39,0,46,0xd1,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x0c,0x03,0x09,0x0f,0x68,0x88,0x00,
0x39,0,52,0xd2,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
0x39,0,7,0xd3,0x30,0x52,0x74,0x77,0x50,0x10,
0x39,0,40,0xd4,0x0f,0x77,0x77,0x05,0x0d,0x14,0x0f,0x18,0x1f,0x05,0x0d,0x14,0x03,0x07,0x0a,0xa0,0x55,0xff,0x39,0x44,0x12,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,55,0xd7,0x30,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,18,0xd8,0x03,0x07,0x0b,0x0f,0x13,0x17,0x1b,0x1f,0x03,0x07,0x0b,0x0f,0x13,0x17,0x1b,0x1f,0x00,
0x39,0,51,0xd9,0x00,0x80,0x00,0x08,0x80,0x07,0x9c,0x06,0xcc,0x05,0xec,0x05,0x1c,0x04,0x3c,0x03,0x6c,0x02,0x8c,0x01,0xac,0x00,0xdc,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x22,
0x39,0,16,0xdd,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,4,0xde,0x00,0x01,0x00,
0x39,0,42,0xdf,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,39,0xe0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,47,0xe1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,32,0xe2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,20,0xe3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,3,0xe5,0x00,0x00,
0x39,0,6,0xe6,0x00,0x10,0x15,0x01,0x00,
0x39,0,3,0xe7,0x02,0xd0,
0x39,0,2,0xe8,0x00,
0x39,0,3,0xe9,0x00,0x00,
0x39,0,2,0xed,0x01,
0x39,0,5,0xee,0x00,0x00,0x02,0x40,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x01,
0x39,0,3,0xb0,0x04,0x04,
0x39,0,3,0xb1,0x04,0x04,
0x39,0,5,0xb2,0x03,0x03,0x33,0x33,
0x39,0,5,0xb3,0x13,0x13,0x33,0x33,
0x39,0,5,0xb4,0x13,0x13,0x33,0x33,
0x39,0,11,0xb5,0x00,0xc0,0x00,0x70,0x00,0x70,0x00,0xc0,0x00,0x70,
0x39,0,11,0xb6,0x00,0xf8,0x00,0xf8,0x00,0xf8,0x00,0xf8,0x00,0xf8,
0x39,0,9,0xb7,0x1e,0x14,0x14,0x1e,0x1e,0x1e,0x1e,0x1e,
0x39,0,8,0xb8,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
0x39,0,33,0xb9,0x3e,0x0f,0x1f,0x00,0x21,0x21,0x21,0x21,0x1f,0x1f,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x12,0x14,0x0f,0x14,0x14,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0x21,0x21,
0x39,0,5,0xba,0x10,0x15,0x10,0x15,
0x39,0,235,0xbb,0x33,0x00,0x19,0x32,0x4b,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x27,0x27,0x30,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x27,0x27,0x30,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x27,0x27,0x30,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x27,0x27,0x30,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
0x39,0,4,0xbe,0x00,0x01,0x00,
0x39,0,7,0xbf,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,4,0xc1,0x00,0x00,0x08,
0x39,0,9,0xc2,0x00,0xb0,0x00,0xd0,0x00,0xb0,0x00,0xd0,
0x39,0,16,0xc3,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x00,
0x39,0,2,0xc4,0x00,
0x39,0,6,0xc5,0x00,0x00,0x00,0x00,0x00,
0x39,0,5,0xc7,0xaf,0x04,0x32,0x00,
0x39,0,3,0xc9,0x0c,0x11,
0x39,0,4,0xca,0x00,0x00,0x00,
0x39,0,3,0xcb,0x00,0x00,
0x39,0,2,0xcc,0x00,
0x39,0,3,0xcd,0x08,0x82,
0x39,0,5,0xce,0x00,0x00,0x01,0x00,
0x39,0,2,0xcf,0x5c,
0x39,0,5,0xd0,0x00,0x00,0x00,0x00,
0x39,0,26,0xd1,0x04,0x02,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,19,0xd2,0x00,0x00,0x11,0x33,0x25,0x00,0x00,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0xd5,0x00,
0x39,0,9,0xd6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,9,0xd7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,25,0xd8,0x0a,0x02,0x06,0x04,0x06,0x00,0x0a,0x0a,0x00,0x00,0x00,0x04,0x04,0x04,0x04,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,51,0xd9,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,16,0xdd,0x14,0x01,0x00,0x00,0x01,0x0f,0x00,0x10,0x48,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,5,0xde,0x00,0x00,0x00,0x00,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x02,
0x39,0,25,0xb9,0x00,0x04,0x00,0x0c,0x00,0x14,0x00,0x1c,0x00,0x3c,0x00,0x5c,0x00,0x7c,0x00,0xbc,0x00,0xfc,0x01,0x3c,0x01,0xbc,0x02,0x3c,
0x39,0,25,0xba,0x02,0xbc,0x02,0xfc,0x03,0x3c,0x03,0xbc,0x03,0xfc,0x03,0xff,0x03,0xff,0x03,0xff,0x03,0xff,0x03,0xff,0x03,0xff,0x03,0xff,
0x39,0,2,0xbc,0x11,
0x39,0,17,0xbd,0x96,0x00,0x69,0x00,0x00,0x96,0x00,0x69,0xbb,0x44,0x44,0xbb,0xee,0x11,0x11,0xee,
0x39,0,5,0xbf,0x00,0x00,0x00,0x00,
0x39,0,5,0xc0,0x00,0x00,0x02,0xaa,
0x39,0,2,0xc1,0x02,
0x39,0,9,0xc2,0x19,0x00,0x91,0x00,0x19,0x00,0x91,0x00,
0x39,0,25,0xc3,0x00,0x01,0x00,0x02,0x00,0x03,0x00,0x04,0x00,0x05,0x00,0x06,0x00,0x07,0x00,0x08,0x00,0x09,0x00,0x0a,0x00,0x0b,0x00,0x0c,
0x39,0,2,0xBF,0x42,
0x39,0,19,0xb0,0x00,0x00,0x00,0x54,0x00,0xfd,0x01,0x46,0x01,0x54,0x02,0x42,0x02,0xdb,0x03,0x59,0x04,0x1c,
0x39,0,19,0xb1,0x04,0xb5,0x05,0x33,0x05,0xf9,0x06,0xa2,0x07,0x2f,0x07,0x71,0x07,0xb0,0x08,0x24,0x08,0x5d,
0x39,0,15,0xb2,0x08,0x5d,0x08,0x5d,0x08,0x5d,0x08,0x5d,0x08,0x5d,0x08,0x5d,0x08,0x5d,
0x39,0,19,0xb3,0x00,0x00,0x00,0x7f,0x01,0x7e,0x01,0xa7,0x01,0xb5,0x02,0x46,0x02,0xb8,0x03,0x1f,0x03,0xc7,
0x39,0,19,0xb4,0x04,0x4b,0x04,0xb4,0x05,0x6b,0x05,0xff,0x06,0x80,0x06,0xb8,0x06,0xf1,0x07,0x59,0x07,0x89,
0x39,0,15,0xb5,0x07,0x89,0x07,0x89,0x07,0x89,0x07,0x89,0x07,0x89,0x07,0x89,0x07,0x89,
0x39,0,19,0xb6,0x00,0x00,0x00,0xa8,0x01,0xf8,0x02,0x6a,0x02,0x78,0x03,0x48,0x03,0xcb,0x04,0x41,0x05,0x04,
0x39,0,19,0xb7,0x05,0xa9,0x06,0x2e,0x07,0x05,0x07,0xb6,0x08,0x4d,0x08,0x92,0x08,0xd5,0x09,0x51,0x09,0x8e,
0x39,0,15,0xb8,0x09,0x8e,0x09,0x8e,0x09,0x8e,0x09,0x8e,0x09,0x8e,0x09,0x8e,0x09,0x8e,
0x39,0,2,0xBF,0x41,
0x39,0,19,0xb0,0x00,0x00,0x00,0x48,0x00,0xd8,0x01,0x68,0x01,0x8b,0x02,0x25,0x02,0xc0,0x03,0x3c,0x03,0xf7,
0x39,0,19,0xb1,0x04,0x8b,0x05,0x00,0x05,0xc8,0x06,0x69,0x06,0xf3,0x07,0x33,0x07,0x6e,0x07,0xe0,0x08,0x15,
0x39,0,15,0xb2,0x08,0x15,0x08,0x15,0x08,0x15,0x08,0x15,0x08,0x15,0x08,0x15,0x08,0x15,
0x39,0,19,0xb3,0x00,0x00,0x00,0x63,0x01,0x29,0x01,0xf0,0x02,0x13,0x02,0x58,0x02,0xc0,0x03,0x19,0x03,0xac,
0x39,0,19,0xb4,0x04,0x28,0x04,0x92,0x05,0x41,0x05,0xd0,0x06,0x4e,0x06,0x85,0x06,0xb9,0x07,0x1e,0x07,0x4c,
0x39,0,15,0xb5,0x07,0x4c,0x07,0x4c,0x07,0x4c,0x07,0x4c,0x07,0x4c,0x07,0x4c,0x07,0x4c,
0x39,0,19,0xb6,0x00,0x00,0x00,0x8c,0x01,0xa4,0x02,0xbd,0x02,0xe0,0x03,0x45,0x03,0xc8,0x04,0x33,0x04,0xe7,
0x39,0,19,0xb7,0x05,0x80,0x05,0xfd,0x06,0xd1,0x07,0x7b,0x08,0x10,0x08,0x54,0x08,0x92,0x09,0x08,0x09,0x40,
0x39,0,15,0xb8,0x09,0x40,0x09,0x40,0x09,0x40,0x09,0x40,0x09,0x40,0x09,0x40,0x09,0x40,
0x39,0,2,0xBF,0x40,
0x39,0,19,0xb0,0x00,0x00,0x00,0x4c,0x00,0xe4,0x01,0x7d,0x02,0x16,0x02,0x38,0x02,0x94,0x02,0xcf,0x03,0x6d,
0x39,0,19,0xb1,0x03,0xea,0x04,0x52,0x05,0x07,0x05,0x98,0x06,0x10,0x06,0x4a,0x06,0x7d,0x06,0xe0,0x07,0x0d,
0x39,0,15,0xb2,0x07,0x0d,0x07,0x0d,0x07,0x0d,0x07,0x0d,0x07,0x0d,0x07,0x0d,0x07,0x0d,
0x39,0,19,0xb3,0x00,0x00,0x00,0x62,0x01,0x27,0x01,0xed,0x02,0xb3,0x02,0xd7,0x03,0x02,0x03,0x1d,0x03,0x7b,
0x39,0,19,0xb4,0x03,0xc8,0x04,0x1d,0x04,0xa5,0x05,0x20,0x05,0x89,0x05,0xbe,0x05,0xea,0x06,0x41,0x06,0x69,
0x39,0,15,0xb5,0x06,0x69,0x06,0x69,0x06,0x69,0x06,0x69,0x06,0x69,0x06,0x69,0x06,0x69,
0x39,0,19,0xb6,0x00,0x00,0x00,0x80,0x01,0x82,0x02,0x84,0x03,0x86,0x03,0x9c,0x03,0xdf,0x04,0x09,0x04,0x93,
0x39,0,19,0xb7,0x05,0x05,0x05,0x6d,0x06,0x1b,0x06,0xa3,0x07,0x22,0x07,0x61,0x07,0x96,0x07,0xfe,0x08,0x2e,
0x39,0,15,0xb8,0x08,0x2e,0x08,0x2e,0x08,0x2e,0x08,0x2e,0x08,0x2e,0x08,0x2e,0x08,0x2e,
0x39,0,2,0xBF,0x00,
0x39,0,19,0xb0,0x00,0x00,0x00,0x12,0x00,0x38,0x00,0x5e,0x00,0x84,0x01,0x53,0x01,0x6f,0x01,0xb5,0x01,0xfe,
0x39,0,19,0xb1,0x02,0x6c,0x02,0xd8,0x03,0x9c,0x04,0x43,0x04,0xed,0x05,0x39,0x05,0x73,0x05,0xd7,0x06,0x03,
0x39,0,15,0xb2,0x06,0x03,0x06,0x03,0x06,0x03,0x06,0x03,0x06,0x03,0x06,0x03,0x06,0x03,
0x39,0,19,0xb3,0x00,0x00,0x00,0x28,0x00,0x79,0x00,0xcb,0x01,0x1d,0x02,0x31,0x02,0x3b,0x02,0x5b,0x02,0xab,
0x39,0,19,0xb4,0x02,0xf0,0x03,0x2d,0x03,0xb9,0x04,0x33,0x04,0xae,0x04,0xf7,0x05,0x26,0x05,0x8d,0x05,0xb5,
0x39,0,15,0xb5,0x05,0x9c,0x05,0x9c,0x05,0x9c,0x05,0x9c,0x05,0x9c,0x05,0x9c,0x05,0x9c,
0x39,0,19,0xb6,0x00,0x00,0x00,0x75,0x01,0x60,0x02,0x4b,0x03,0x37,0x04,0x1e,0x04,0x28,0x04,0x44,0x04,0x8f,
0x39,0,19,0xb7,0x04,0xb4,0x05,0x08,0x05,0x89,0x06,0x00,0x06,0x6b,0x06,0x96,0x06,0xc4,0x07,0x14,0x07,0x3a,
0x39,0,15,0xb8,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,
0x39,0,2,0xBF,0x01,
0x39,0,19,0xb0,0x00,0x00,0x00,0x18,0x00,0x48,0x00,0x78,0x00,0xa8,0x01,0x6f,0x01,0xc6,0x02,0x16,0x02,0x9f,
0x39,0,19,0xb1,0x03,0x31,0x03,0xad,0x04,0x87,0x05,0x41,0x05,0xc4,0x05,0xf9,0x06,0x2c,0x06,0x87,0x06,0xb3,
0x39,0,15,0xb2,0x06,0xb3,0x06,0xb3,0x06,0xb3,0x06,0xb3,0x06,0xb3,0x06,0xb3,0x06,0xb3,
0x39,0,19,0xb3,0x00,0x00,0x00,0x3d,0x00,0xb7,0x01,0x32,0x01,0xad,0x01,0xe2,0x02,0x26,0x02,0x65,0x02,0xc5,
0x39,0,19,0xb4,0x03,0x32,0x03,0x97,0x04,0x3d,0x04,0xe3,0x05,0x64,0x05,0x99,0x05,0xc7,0x06,0x1a,0x06,0x41,
0x39,0,15,0xb5,0x06,0x41,0x06,0x41,0x06,0x41,0x06,0x41,0x06,0x41,0x06,0x41,0x06,0x41,
0x39,0,19,0xb6,0x00,0x00,0x00,0x82,0x01,0x88,0x02,0x8e,0x03,0x94,0x03,0xc8,0x04,0x00,0x04,0x34,0x04,0x96,
0x39,0,19,0xb7,0x04,0xf5,0x05,0x5c,0x05,0xf7,0x06,0x7b,0x06,0xec,0x07,0x1f,0x07,0x4f,0x07,0xa7,0x07,0xd3,
0x39,0,15,0xb8,0x07,0xd3,0x07,0xd3,0x07,0xd3,0x07,0xd3,0x07,0xd3,0x07,0xd3,0x07,0xd3,
0x39,0,2,0xBF,0x02,
0x39,0,19,0xb0,0x00,0x00,0x00,0x1f,0x00,0x5d,0x00,0x9b,0x00,0xd9,0x01,0xb7,0x02,0x47,0x02,0xbe,0x03,0x7c,
0x39,0,19,0xb1,0x04,0x1b,0x04,0xa5,0x05,0x71,0x06,0x08,0x06,0x83,0x06,0xba,0x06,0xee,0x07,0x4c,0x07,0x7c,
0x39,0,15,0xb2,0x07,0x7c,0x07,0x7c,0x07,0x7c,0x07,0x7c,0x07,0x7c,0x07,0x7c,0x07,0x7c,
0x39,0,19,0xb3,0x00,0x00,0x00,0x3d,0x00,0xb9,0x01,0x35,0x01,0xb1,0x02,0x25,0x02,0x82,0x02,0xcd,0x03,0x68,
0x39,0,19,0xb4,0x03,0xe3,0x04,0x54,0x05,0x18,0x05,0xa3,0x06,0x13,0x06,0x44,0x06,0x73,0x06,0xc6,0x06,0xef,
0x39,0,15,0xb5,0x06,0xef,0x06,0xef,0x06,0xef,0x06,0xef,0x06,0xef,0x06,0xef,0x06,0xef,
0x39,0,19,0xb6,0x00,0x00,0x00,0x7d,0x01,0x77,0x02,0x72,0x03,0x6d,0x03,0xc4,0x04,0x18,0x04,0x60,0x04,0xf9,
0x39,0,19,0xb7,0x05,0x72,0x05,0xda,0x06,0x88,0x07,0x17,0x07,0x92,0x07,0xcb,0x08,0x01,0x08,0x64,0x08,0x97,
0x39,0,15,0xb8,0x08,0x97,0x08,0x97,0x08,0x97,0x08,0x97,0x08,0x97,0x08,0x97,0x08,0x97,
0x39,0,2,0xBF,0x03,
0x39,0,19,0xb0,0x00,0x00,0x00,0x3d,0x00,0xb7,0x01,0x31,0x01,0x80,0x02,0x1c,0x02,0xb8,0x03,0x33,0x03,0xeb,
0x39,0,19,0xb1,0x04,0x86,0x04,0xff,0x05,0xbb,0x06,0x4f,0x06,0xc8,0x07,0x00,0x07,0x35,0x07,0x9b,0x07,0xc9,
0x39,0,15,0xb2,0x07,0xc9,0x07,0xc9,0x07,0xc9,0x07,0xc9,0x07,0xc9,0x07,0xc9,0x07,0xc9,
0x39,0,19,0xb3,0x00,0x00,0x00,0x5f,0x01,0x1f,0x01,0xdf,0x01,0xfa,0x02,0x61,0x02,0xbf,0x03,0x1f,0x03,0xba,
0x39,0,19,0xb4,0x04,0x3a,0x04,0xae,0x05,0x5c,0x05,0xe2,0x06,0x50,0x06,0x81,0x06,0xaf,0x07,0x05,0x07,0x2e,
0x39,0,15,0xb5,0x07,0x2e,0x07,0x2e,0x07,0x2e,0x07,0x2e,0x07,0x2e,0x07,0x2e,0x07,0x2e,
0x39,0,19,0xb6,0x00,0x00,0x00,0xae,0x02,0x0a,0x03,0x67,0x03,0x73,0x03,0xc6,0x04,0x1d,0x04,0x77,0x05,0x18,
0x39,0,19,0xb7,0x05,0x9b,0x06,0x08,0x06,0xbc,0x07,0x54,0x07,0xd3,0x08,0x0e,0x08,0x45,0x08,0xaf,0x08,0xe1,
0x39,0,15,0xb8,0x08,0xe1,0x08,0xe1,0x08,0xe1,0x08,0xe1,0x08,0xe1,0x08,0xe1,0x08,0xe1,
0x39,0,2,0xBF,0x04,
0x39,0,19,0xb0,0x00,0x00,0x00,0x46,0x00,0xd2,0x01,0x5f,0x01,0xb1,0x02,0x6a,0x02,0xf7,0x03,0x72,0x04,0x1d,
0x39,0,19,0xb1,0x04,0xa9,0x05,0x18,0x05,0xcb,0x06,0x5a,0x06,0xd2,0x07,0x0a,0x07,0x41,0x07,0xa5,0x07,0xd5,
0x39,0,15,0xb2,0x07,0xd5,0x07,0xd5,0x07,0xd5,0x07,0xd5,0x07,0xd5,0x07,0xd5,0x07,0xd5,
0x39,0,19,0xb3,0x00,0x00,0x00,0x65,0x01,0x30,0x01,0xfb,0x02,0x1c,0x02,0x8a,0x02,0xee,0x03,0x47,0x03,0xe4,
0x39,0,19,0xb4,0x04,0x5e,0x04,0xc8,0x05,0x6e,0x05,0xed,0x06,0x58,0x06,0x8a,0x06,0xba,0x07,0x13,0x07,0x3a,
0x39,0,15,0xb5,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,0x07,0x3a,
0x39,0,19,0xb6,0x00,0x00,0x00,0xa3,0x01,0xeb,0x03,0x33,0x03,0x54,0x03,0xc4,0x04,0x1a,0x04,0x78,0x05,0x1b,
0x39,0,19,0xb7,0x05,0xa0,0x06,0x0d,0x06,0xc4,0x07,0x59,0x07,0xd9,0x08,0x13,0x08,0x4e,0x08,0xbb,0x08,0xed,
0x39,0,15,0xb8,0x08,0xed,0x08,0xed,0x08,0xed,0x08,0xed,0x08,0xed,0x08,0xed,0x08,0xed,
0x39,0,2,0xBF,0x05,
0x39,0,19,0xb0,0x00,0x00,0x00,0x8c,0x01,0xa4,0x01,0xf4,0x02,0x18,0x02,0xbd,0x03,0x43,0x03,0xa9,0x04,0x50,
0x39,0,19,0xb1,0x04,0xcd,0x05,0x3a,0x05,0xe8,0x06,0x76,0x06,0xee,0x07,0x26,0x07,0x5c,0x07,0xc2,0x07,0xf4,
0x39,0,15,0xb2,0x07,0xf4,0x07,0xf4,0x07,0xf4,0x07,0xf4,0x07,0xf4,0x07,0xf4,0x07,0xf4,
0x39,0,19,0xb3,0x00,0x00,0x00,0xb1,0x02,0x13,0x02,0x3d,0x02,0x54,0x02,0xb3,0x03,0x1b,0x03,0x7b,0x04,0x10,
0x39,0,19,0xb4,0x04,0x85,0x04,0xe6,0x05,0x83,0x06,0x01,0x06,0x6f,0x06,0xa0,0x06,0xd0,0x07,0x29,0x07,0x53,
0x39,0,15,0xb5,0x07,0x53,0x07,0x53,0x07,0x53,0x07,0x53,0x07,0x53,0x07,0x53,0x07,0x53,
0x39,0,19,0xb6,0x00,0x00,0x01,0x08,0x03,0x1a,0x03,0x41,0x03,0x5d,0x03,0xb9,0x04,0x25,0x04,0x86,0x05,0x28,
0x39,0,19,0xb7,0x05,0xad,0x06,0x1e,0x06,0xd7,0x07,0x6d,0x07,0xf0,0x08,0x2c,0x08,0x68,0x08,0xd6,0x09,0x0b,
0x39,0,15,0xb8,0x09,0x0b,0x09,0x0b,0x09,0x0b,0x09,0x0b,0x09,0x0b,0x09,0x0b,0x09,0x0b,
0x39,0,2,0xBF,0x06,
0x39,0,19,0xb0,0x00,0x00,0x00,0xb1,0x02,0x13,0x02,0x61,0x02,0x77,0x02,0xe3,0x03,0x4e,0x03,0xa4,0x04,0x37,
0x39,0,19,0xb1,0x04,0xab,0x05,0x0b,0x05,0xa8,0x06,0x2b,0x06,0x9c,0x06,0xd0,0x07,0x02,0x07,0x5e,0x07,0x8d,
0x39,0,15,0xb2,0x07,0x8d,0x07,0x8d,0x07,0x8d,0x07,0x8d,0x07,0x8d,0x07,0x8d,0x07,0x8d,
0x39,0,19,0xb3,0x00,0x00,0x00,0xd1,0x02,0x74,0x02,0x99,0x02,0xac,0x02,0xf8,0x03,0x4a,0x03,0x91,0x04,0x0a,
0x39,0,19,0xb4,0x04,0x70,0x04,0xc3,0x05,0x4e,0x05,0xc2,0x06,0x26,0x06,0x54,0x06,0x80,0x06,0xd3,0x06,0xfb,
0x39,0,15,0xb5,0x06,0xfb,0x06,0xfb,0x06,0xfb,0x06,0xfb,0x06,0xfb,0x06,0xfb,0x06,0xfb,
0x39,0,19,0xb6,0x00,0x00,0x01,0x0e,0x03,0x2a,0x03,0x4d,0x03,0x65,0x03,0xb4,0x04,0x16,0x04,0x69,0x04,0xf8,
0x39,0,19,0xb7,0x05,0x73,0x05,0xdc,0x06,0x88,0x07,0x17,0x07,0x90,0x07,0xca,0x08,0x00,0x08,0x65,0x08,0x98,
0x39,0,15,0xb8,0x08,0x98,0x08,0x98,0x08,0x98,0x08,0x98,0x08,0x98,0x08,0x98,0x08,0x98,
0x39,0,2,0xBF,0x07,
0x39,0,19,0xb0,0x00,0x00,0x00,0xb9,0x01,0xdf,0x02,0x67,0x02,0x91,0x03,0x71,0x04,0x0d,0x04,0x8c,0x05,0x34,
0x39,0,19,0xb1,0x05,0xca,0x06,0x45,0x07,0x05,0x07,0xbb,0x08,0x60,0x08,0xb7,0x08,0xfd,0x09,0x92,0x09,0xd4,
0x39,0,15,0xb2,0x09,0xd4,0x09,0xd4,0x09,0xd4,0x09,0xd4,0x09,0xd4,0x09,0xd4,0x09,0xd4,
0x39,0,19,0xb3,0x00,0x00,0x01,0x4a,0x02,0x59,0x02,0x9d,0x02,0xc1,0x03,0x6a,0x03,0xe8,0x04,0x54,0x04,0xe8,
0x39,0,19,0xb4,0x05,0x6b,0x05,0xd8,0x06,0x82,0x07,0x21,0x07,0xac,0x07,0xfa,0x08,0x34,0x08,0xb3,0x08,0xe9,
0x39,0,15,0xb5,0x08,0xe9,0x08,0xe9,0x08,0xe9,0x08,0xe9,0x08,0xe9,0x08,0xe9,0x08,0xe9,
0x39,0,19,0xb6,0x00,0x00,0x01,0xc5,0x03,0x15,0x03,0x58,0x03,0x80,0x04,0x3d,0x04,0xd0,0x05,0x50,0x06,0x08,
0x39,0,19,0xb7,0x06,0xac,0x07,0x30,0x07,0xff,0x08,0xc5,0x09,0x74,0x09,0xd1,0x0a,0x1c,0x0a,0xbd,0x0b,0x05,
0x39,0,15,0xb8,0x0b,0x05,0x0b,0x05,0x0b,0x05,0x0b,0x05,0x0b,0x05,0x0b,0x05,0x0b,0x05,
0x39,0,2,0xBF,0x08,
0x39,0,19,0xb0,0x00,0x00,0x01,0x19,0x02,0x4b,0x02,0x88,0x02,0xd5,0x03,0xb2,0x04,0x60,0x04,0xe3,0x05,0xa5,
0x39,0,19,0xb1,0x06,0x3c,0x06,0xbd,0x07,0x9d,0x08,0x66,0x09,0x1e,0x09,0x77,0x09,0xd4,0x0a,0x89,0x0a,0xe6,
0x39,0,15,0xb2,0x0a,0xe6,0x0a,0xe6,0x0a,0xe6,0x0a,0xe6,0x0a,0xe6,0x0a,0xe6,0x0a,0xe6,
0x39,0,19,0xb3,0x00,0x00,0x01,0xfd,0x02,0x85,0x02,0xb8,0x02,0xf1,0x03,0x9b,0x04,0x2d,0x04,0xa0,0x05,0x4a,
0x39,0,19,0xb4,0x05,0xd0,0x06,0x42,0x07,0x08,0x07,0xb1,0x08,0x50,0x08,0x9b,0x08,0xe9,0x09,0x83,0x09,0xd1,
0x39,0,15,0xb5,0x09,0xd1,0x09,0xd1,0x09,0xd1,0x09,0xd1,0x09,0xd1,0x09,0xd1,0x09,0xd1,
0x39,0,19,0xb6,0x00,0x00,0x02,0xc0,0x03,0x3d,0x03,0x77,0x03,0xb0,0x04,0x77,0x05,0x21,0x05,0xb0,0x06,0x84,
0x39,0,19,0xb7,0x07,0x27,0x07,0xb1,0x08,0xa5,0x09,0x7b,0x0a,0x41,0x0a,0xa1,0x0b,0x04,0x0b,0xc9,0x0c,0x31,
0x39,0,15,0xb8,0x0c,0x31,0x0c,0x31,0x0c,0x31,0x0c,0x31,0x0c,0x31,0x0c,0x31,0x0c,0x31,
0x39,0,2,0xBF,0x09,
0x39,0,19,0xb0,0x00,0x00,0x00,0xc7,0x02,0x55,0x02,0xb8,0x03,0x10,0x04,0x0c,0x04,0xb8,0x05,0x3e,0x06,0x0c,
0x39,0,19,0xb1,0x06,0xb3,0x07,0x46,0x08,0x44,0x09,0x2c,0x0a,0x0f,0x0a,0x82,0x0a,0xf9,0x0b,0xeb,0x0c,0x74,
0x39,0,15,0xb2,0x0c,0x74,0x0c,0x74,0x0c,0x74,0x0c,0x74,0x0c,0x74,0x0c,0x74,0x0c,0x74,
0x39,0,19,0xb3,0x00,0x00,0x00,0xd9,0x02,0x8c,0x02,0xd3,0x03,0x13,0x03,0xe6,0x04,0x79,0x04,0xef,0x05,0xa7,
0x39,0,19,0xb4,0x06,0x3a,0x06,0xba,0x07,0x98,0x08,0x5d,0x09,0x1b,0x09,0x79,0x09,0xd7,0x0a,0x9b,0x0b,0x0f,
0x39,0,15,0xb5,0x0b,0x0f,0x0b,0x0f,0x0b,0x0f,0x0b,0x0f,0x0b,0x0f,0x0b,0x0f,0x0b,0x0f,
0x39,0,19,0xb6,0x00,0x00,0x01,0x1c,0x03,0x55,0x03,0x98,0x03,0xdf,0x04,0xcd,0x05,0x82,0x06,0x15,0x06,0xf4,
0x39,0,19,0xb7,0x07,0xa8,0x08,0x44,0x09,0x59,0x0a,0x54,0x0b,0x41,0x0b,0xbb,0x0c,0x37,0x0d,0x3a,0x0d,0xc9,
0x39,0,15,0xb8,0x0d,0xc9,0x0d,0xc9,0x0d,0xc9,0x0d,0xc9,0x0d,0xc9,0x0d,0xc9,0x0d,0xc9,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x03,
0x39,0,61,0xb0,0xf0,0x00,0xf0,0xf0,0x00,0x02,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xff,0x00,0x00,0xff,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xf0,0x00,0x00,0xff,0x00,0x00,0xff,0x00,0x00,
0x39,0,13,0xb1,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,27,0xb2,0x00,0x00,0x00,0x06,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x05,0x06,0x05,0x06,0x05,0x06,0x05,0x02,
0x39,0,2,0x6F,0x21,
0x39,0,4,0xB2,0x01,0x01,0x01,
0x39,0,27,0xb3,0x10,0x00,0x00,0x04,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x02,0x04,0x02,0x04,0x02,0x04,0x02,0x00,
0x39,0,10,0xb4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,31,0xb5,0x01,0x00,0x23,0x23,0x06,0x06,0x01,0x00,0x23,0x23,0x06,0x06,0x01,0x00,0x23,0x23,0x06,0x06,0x01,0x00,0x23,0x23,0x06,0x06,0x01,0x00,0x23,0x23,0x06,0x06,
0x39,0,60,0xb6,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0x00,0x08,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x0f,0x00,0x08,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x0f,0x00,0x08,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x0f,0x00,0x08,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,
0x39,0,34,0xb7,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x03,
0x39,0,4,0xba,0x10,0x0a,0x08,
0x39,0,17,0xbb,0x22,0x10,0x00,0x20,0x00,0x00,0x20,0x00,0x00,0x20,0x00,0x00,0x20,0x00,0x00,0x20,
0x39,0,17,0xbc,0x11,0x00,0x13,0x53,0x00,0x13,0x53,0x00,0x13,0x53,0x00,0x13,0x53,0x00,0x13,0x53,
0x39,0,17,0xbd,0x40,0x00,0x85,0x00,0x00,0x85,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x85,0x00,
0x39,0,17,0xbe,0x40,0x00,0x85,0x00,0x00,0x85,0x00,0x00,0x85,0x00,0x00,0x85,0x00,0x00,0x85,0x00,
0x39,0,17,0xbf,0x22,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,
0x39,0,16,0xc0,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,
0x39,0,16,0xc1,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,0x00,0x00,0x6b,
0x39,0,9,0xc4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,65,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,65,0xc6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x05,
0x39,0,4,0xb0,0x7f,0xf3,0x0f,
0x39,0,3,0xb1,0x06,0x20,
0x39,0,4,0xb2,0x85,0x00,0x90,
0x39,0,3,0xb3,0x05,0x00,
0x39,0,6,0xb5,0x05,0x00,0x00,0x00,0x00,
0x39,0,6,0xb6,0x86,0x83,0x00,0x00,0x00,
0x39,0,5,0xb7,0x85,0x00,0x00,0x81,
0x39,0,5,0xb8,0x85,0x00,0x00,0x81,
0x39,0,5,0xb9,0x06,0x00,0x00,0x03,
0x39,0,5,0xba,0x06,0x00,0x00,0x03,
0x39,0,5,0xbb,0x86,0x00,0x00,0x83,
0x39,0,8,0xbc,0x86,0x00,0x00,0x83,0x00,0x00,0x00,
0x39,0,8,0xbd,0x86,0x00,0x00,0x83,0x00,0x00,0x00,
0x39,0,9,0xc0,0x86,0x00,0x80,0x00,0x00,0x00,0xb0,0x00,
0x39,0,9,0xc1,0x06,0x00,0x00,0x00,0x00,0x00,0x30,0x00,
0x39,0,9,0xc2,0x06,0x00,0x00,0x00,0x00,0x30,0x00,0x00,
0x39,0,9,0xc3,0x06,0x00,0x00,0x00,0x00,0x30,0x00,0x00,
0x39,0,3,0xc7,0x03,0x01,
0x39,0,2,0xc8,0x00,
0x39,0,2,0xc9,0x11,
0x39,0,2,0xca,0x11,
0x39,0,9,0xcb,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x00,
0x39,0,4,0xd0,0x00,0x04,0x10,
0x39,0,4,0xd1,0x00,0x08,0x10,
0x39,0,4,0xd2,0x00,0x04,0x10,
0x39,0,4,0xd3,0x00,0x02,0x10,
0x39,0,4,0xd5,0x00,0x02,0x00,
0x39,0,4,0xd6,0x00,0x02,0x00,
0x39,0,5,0xd7,0x11,0x11,0x11,0x11,
0x39,0,2,0xd8,0x11,
0x39,0,2,0xd9,0x00,
0x39,0,5,0xe0,0x02,0x00,0x00,0x00,
0x39,0,5,0xe0,0x02,0x00,0x00,0x00,
0x39,0,5,0xe1,0x00,0x0a,0x60,0x00,
0x39,0,5,0xe2,0x02,0x0f,0x00,0x00,
0x39,0,5,0xe3,0x02,0x0f,0x00,0x02,
0x39,0,5,0xe4,0x02,0x0f,0x00,0x00,
0x39,0,4,0xe5,0x02,0x0f,0x00,
0x39,0,4,0xe6,0x02,0x0f,0x00,
0x39,0,5,0xe7,0x00,0x00,0x00,0x00,
0x39,0,5,0xe8,0x00,0x00,0x00,0x00,
0x39,0,5,0xe9,0x00,0x00,0x00,0x00,
0x39,0,5,0xea,0x00,0x00,0x00,0x00,
0x39,0,21,0xec,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,5,0xe8,0x00,0x00,0x00,0x00,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x06,
0x39,0,6,0xb0,0x04,0x32,0x0e,0x32,0x0f,
0x39,0,6,0xb1,0x32,0x12,0x32,0x13,0x32,
0x39,0,6,0xb2,0x00,0x32,0x31,0x31,0x31,
0x39,0,2,0xb3,0x31,
0x39,0,6,0xb6,0x04,0x32,0x0e,0x32,0x0f,
0x39,0,6,0xb7,0x32,0x12,0x32,0x13,0x32,
0x39,0,6,0xb8,0x00,0x32,0x31,0x31,0x31,
0x39,0,2,0xb9,0x31,
0x39,0,2,0xd0,0x01,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x07,
0x39,0,163,0xb2,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xf0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xcc,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,6,0xb0,0x84,0x40,0x78,0x70,0x00,
0x39,0,22,0xb1,0x0c,0x1c,0x00,0x1c,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,163,0xb2,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xf0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xcc,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,14,0xb4,0xc0,0x80,0x80,0x80,0x80,0x40,0x80,0x80,0x80,0x80,0x80,0x40,0x80,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x07,
0x39,0,2,0xC0,0x01,
0x39,0,2,0x6F,0x04,
0x39,0,2,0xC0,0x55,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC1,0x38,0x0F,0x08,0xA1,0x03,0x49,0xF5,0x5A,0x3F,0xF9,0x12,0x9E,0xFF,0xFC,0xA9,0xAA,0x00,0x00,0xD2,0x2A,0x31,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC1,0x00,0x00,0x22,0x00,0x25,0x8D,0x23,0xB0,0x0F,0x77,0x0F,0x95,0xDB,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC1,0x00,0x1E,0x1B,0x00,0x25,0x21,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC2,0x30,0x0F,0x04,0x41,0x09,0xC4,0xF3,0x1C,0x3F,0xFB,0xF2,0x0C,0x7F,0xF7,0x3F,0x18,0x00,0x00,0xF7,0x53,0x24,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC2,0x00,0x26,0x00,0x00,0xA0,0x21,0x33,0x10,0x0F,0xBA,0x0F,0xDF,0x86,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC2,0xA4,0x89,0x38,0xA4,0x90,0x3E,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC3,0x3A,0x0F,0x0F,0x04,0x05,0xA4,0xED,0x98,0x00,0x10,0x79,0x68,0xC0,0x02,0xBB,0x70,0xFF,0xFD,0x39,0x48,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC3,0x94,0x89,0xB7,0xA4,0xAF,0x37,0x33,0xCF,0xED,0x00,0x00,0x80,0x26,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC3,0xA0,0x1E,0x3A,0xA0,0x25,0x40,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC4,0x32,0x0F,0x04,0xC9,0x0C,0x40,0xF0,0xB0,0x00,0x02,0x17,0xF0,0x40,0x0E,0x57,0x2C,0x7F,0xFD,0xCF,0x76,0xBC,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC4,0xA4,0x0A,0x38,0xA4,0x88,0x5B,0x33,0x3F,0xEE,0xC6,0x00,0x23,0x7E,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC4,0x04,0x89,0x1D,0x04,0x90,0x23,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC5,0x2C,0x00,0x08,0xA1,0x03,0x49,0x0A,0xA6,0x3F,0xF4,0x9F,0x3C,0xC0,0x00,0x97,0x50,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC5,0x90,0x00,0xCE,0xA0,0x25,0x39,0x23,0xB0,0x00,0x00,0x0C,0x95,0x25,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC6,0x24,0x00,0x04,0x41,0x09,0xC4,0x0C,0xE4,0x3F,0xFA,0x48,0xA8,0x40,0x06,0x3C,0x60,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC6,0xA0,0x26,0x3A,0xA0,0xA0,0x5B,0x33,0x10,0x00,0x00,0x0C,0xDF,0x7A,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC7,0x26,0x00,0x04,0xC9,0x07,0x90,0x0C,0x08,0x00,0x00,0x00,0x00,0x7F,0xF2,0x54,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC7,0x04,0x14,0x00,0x04,0x88,0x23,0x33,0x30,0x00,0x00,0x03,0x23,0x8C,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC8,0x26,0x00,0x0F,0x04,0x05,0xA4,0x12,0x68,0x00,0x07,0x45,0x68,0x3F,0xF7,0xA0,0x90,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC8,0x04,0x89,0x24,0x04,0xAF,0xA4,0x33,0x30,0x00,0x00,0x03,0x80,0xDA,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCD,0x2D,0x00,0x05,0xA4,0x05,0x59,0x00,0x00,0x3F,0xFE,0x5E,0x98,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCD,0x02,0x32,0x4B,0x02,0x57,0x71,0x33,0xB0,0x00,0x00,0x0C,0xDA,0x25,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCE,0x2B,0x00,0x05,0xA4,0x05,0x59,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xE1,0xD5,0xFC,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCE,0x02,0x58,0x4B,0x02,0x7D,0x71,0x33,0xBF,0xFA,0x82,0x00,0x26,0x25,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCF,0x21,0x00,0x05,0x10,0x05,0xA4,0x00,0x00,0x3F,0xFE,0x7F,0x40,0x3F,0xFE,0x69,0xE0,0x00,0x00,0x1C,0x8E,0x40,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCF,0x02,0x32,0x26,0x02,0x58,0x4A,0x33,0xB0,0x05,0x58,0x0F,0xDC,0xDA,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xD0,0x27,0x00,0x05,0x10,0x05,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xFE,0x93,0x80,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xD0,0x02,0x59,0x26,0x02,0x7D,0x4A,0x33,0xA0,0x00,0x00,0x03,0x24,0xDC,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC9,0x21,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x3F,0xE5,0x00,0x00,0x3F,0xE5,0x00,0x00,0x80,0x05,0x10,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC9,0x91,0xF3,0x19,0x92,0x53,0x79,0x33,0xC0,0x24,0x00,0x0F,0xA0,0xA0,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCA,0x27,0x00,0x24,0x00,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE5,0x8F,0x40,0x80,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCA,0x92,0x54,0x19,0x92,0xB3,0x79,0x33,0xB0,0x00,0x00,0x03,0x60,0xA1,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCB,0x2D,0x00,0x23,0x41,0x24,0x00,0x00,0x00,0x3F,0xE5,0x8F,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCB,0x91,0xF3,0x7A,0x92,0x53,0xD9,0x33,0x20,0x00,0x00,0x0C,0xA1,0x60,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCC,0x2B,0x00,0x23,0x41,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x7F,0xFB,0x25,0x29,0x7F,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCC,0x92,0x54,0x7A,0x92,0xB3,0xD9,0x33,0x3F,0xDC,0xBF,0x00,0x5F,0x5F,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0xD9,0x40,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x02,
0x39,0,2,0x6F,0x08,
0x39,0,7,0xD0,0x0c,0x74,0x0b,0x0f,0x0d,0xc9,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x07,
0x39,0,163,0xb2,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xf0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xcc,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,6,0xb0,0x84,0x40,0x78,0x70,0x00,
0x39,0,22,0xb1,0x0c,0x1c,0x00,0x1c,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,163,0xb2,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xf0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xcc,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x32,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,14,0xb4,0xc0,0x80,0x80,0x80,0x80,0x40,0x80,0x80,0x80,0x80,0x80,0x40,0x80,
0x39,0,3,0xb7,0x00,0x00,
0x39,0,3,0xc0,0x01,0x01,
0x39,0,48,0xc1,0x38,0x0f,0x08,0xa1,0x03,0x49,0xf5,0x5a,0x3f,0xf9,0x12,0x9e,0xff,0xfc,0xa9,0xaa,0x00,0x00,0xd2,0x2a,0x31,0x00,0x00,0x22,0x00,0x25,0x8d,0x23,0xb0,0x0f,0x77,0x0f,0x95,0xdb,0x00,0x00,0x00,0x1e,0x1b,0x00,0x25,0x21,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc2,0x30,0x0f,0x04,0x41,0x09,0xc4,0xf3,0x1c,0x3f,0xfb,0xf2,0x0c,0x7f,0xf7,0x3f,0x18,0x00,0x00,0xf7,0x53,0x24,0x00,0x26,0x00,0x00,0xa0,0x21,0x33,0x10,0x0f,0xba,0x0f,0xdf,0x86,0x00,0x00,0xa4,0x89,0x38,0xa4,0x90,0x3e,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc3,0x3a,0x0f,0x0f,0x04,0x05,0xa4,0xed,0x98,0x00,0x10,0x79,0x68,0xc0,0x02,0xbb,0x70,0xff,0xfd,0x39,0x48,0x00,0x94,0x89,0xb7,0xa4,0xaf,0x37,0x33,0xcf,0xed,0x00,0x00,0x80,0x26,0x00,0x00,0xa0,0x1e,0x3a,0xa0,0x25,0x40,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc4,0x32,0x0f,0x04,0xc9,0x0c,0x40,0xf0,0xb0,0x00,0x02,0x17,0xf0,0x40,0x0e,0x57,0x2c,0x7f,0xfd,0xcf,0x76,0xbc,0xa4,0x0a,0x38,0xa4,0x88,0x5b,0x33,0x3f,0xee,0xc6,0x00,0x23,0x7e,0x00,0x00,0x04,0x89,0x1d,0x04,0x90,0x23,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc5,0x2c,0x00,0x08,0xa1,0x03,0x49,0x0a,0xa6,0x3f,0xf4,0x9f,0x3c,0xc0,0x00,0x97,0x50,0x00,0x00,0x00,0x00,0x00,0x90,0x00,0xce,0xa0,0x25,0x39,0x23,0xb0,0x00,0x00,0x0c,0x95,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc6,0x24,0x00,0x04,0x41,0x09,0xc4,0x0c,0xe4,0x3f,0xfa,0x48,0xa8,0x40,0x06,0x3c,0x60,0x00,0x00,0x00,0x00,0x00,0xa0,0x26,0x3a,0xa0,0xa0,0x5b,0x33,0x10,0x00,0x00,0x0c,0xdf,0x7a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc7,0x26,0x00,0x04,0xc9,0x07,0x90,0x0c,0x08,0x00,0x00,0x00,0x00,0x7f,0xf2,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x14,0x00,0x04,0x88,0x23,0x33,0x30,0x00,0x00,0x03,0x23,0x8c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc8,0x26,0x00,0x0f,0x04,0x05,0xa4,0x12,0x68,0x00,0x07,0x45,0x68,0x3f,0xf7,0xa0,0x90,0x00,0x00,0x00,0x00,0x00,0x04,0x89,0x24,0x04,0xaf,0xa4,0x33,0x30,0x00,0x00,0x03,0x80,0xda,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xc9,0x21,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x3f,0xe5,0x00,0x00,0x3f,0xe5,0x00,0x00,0x80,0x05,0x10,0x00,0x00,0x91,0xf3,0x19,0x92,0x53,0x79,0x33,0xc0,0x24,0x00,0x0f,0xa0,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xca,0x27,0x00,0x24,0x00,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x3f,0xe5,0x8f,0x40,0x80,0x00,0x00,0x00,0x00,0x92,0x54,0x19,0x92,0xb3,0x79,0x33,0xb0,0x00,0x00,0x03,0x60,0xa1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xcb,0x2d,0x00,0x23,0x41,0x24,0x00,0x00,0x00,0x3f,0xe5,0x8f,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x91,0xf3,0x7a,0x92,0x53,0xd9,0x33,0x20,0x00,0x00,0x0c,0xa1,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xcc,0x2b,0x00,0x23,0x41,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x7f,0xfb,0x25,0x29,0x7f,0x92,0x54,0x7a,0x92,0xb3,0xd9,0x33,0x3f,0xdc,0xbf,0x00,0x5f,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xcd,0x2d,0x00,0x05,0xa4,0x05,0x59,0x00,0x00,0x3f,0xfe,0x5e,0x98,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x02,0x32,0x4b,0x02,0x57,0x71,0x33,0xb0,0x00,0x00,0x0c,0xda,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xce,0x2b,0x00,0x05,0xa4,0x05,0x59,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xe1,0xd5,0xfc,0x02,0x58,0x4b,0x02,0x7d,0x71,0x33,0xbf,0xfa,0x82,0x00,0x26,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xcf,0x21,0x00,0x05,0x10,0x05,0xa4,0x00,0x00,0x3f,0xfe,0x7f,0x40,0x3f,0xfe,0x69,0xe0,0x00,0x00,0x1c,0x8e,0x40,0x02,0x32,0x26,0x02,0x58,0x4a,0x33,0xb0,0x05,0x58,0x0f,0xdc,0xda,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd0,0x27,0x00,0x05,0x10,0x05,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x3f,0xfe,0x93,0x80,0x00,0x00,0x00,0x00,0x00,0x02,0x59,0x26,0x02,0x7d,0x4a,0x33,0xa0,0x00,0x00,0x03,0x24,0xdc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,48,0xd8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,6,0xF0,0x55,0xAA,0x52,0x08,0x07,
0x39,0,2,0x6F,0x04,
0x39,0,2,0xC0,0x55,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xC9,0x21,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x3F,0xE5,0x00,0x00,0x3F,0xE5,0x00,0x00,0x80,0x05,0x10,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xC9,0x91,0xF1,0x19,0x92,0x51,0x79,0x33,0xC0,0x24,0x00,0x0F,0xA0,0xA0,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCA,0x27,0x00,0x24,0x00,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE5,0x8F,0x40,0x80,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCA,0x92,0x52,0x19,0x92,0xB1,0x79,0x33,0xB0,0x00,0x00,0x03,0x60,0xA1,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCB,0x2D,0x00,0x23,0x41,0x24,0x00,0x00,0x00,0x3F,0xE5,0x8F,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCB,0x91,0xF1,0x7A,0x92,0x51,0xD9,0x33,0x20,0x00,0x00,0x0C,0xA1,0x60,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0x6F,0x00,
0x39,0,22,0xCC,0x2B,0x00,0x23,0x41,0x23,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x7F,0xFB,0x25,0x29,0x7F,
0x39,0,2,0x6F,0x15,
0x39,0,16,0xCC,0x92,0x52,0x7A,0x92,0xB1,0xD9,0x33,0x3F,0xDC,0xBF,0x00,0x5F,0x5F,0x00,0x00,
0x39,0,2,0x6F,0x24,
0x39,0,8,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0,2,0xD9,0x40,
0x39,0,1,0x35,
0x39,0,2,0x53,0x20,
0x39,0,5,0x51,0x0D,0xBB,0x0F,0xFE,
0x39,0,5,0x2A,0x00,0x00,0x04,0xAF,
0x39,0,5,0x2B,0x00,0x00,0x0A,0x5B,
0x39,0,6,0x88,0x01,0x02,0x53,0x09,0x79,
0x39,0,2,0x6F,0x05,
0x39,0,3,0x51,0x8F,0xFF,
0x39,0,2,0x82,0xAC,
0x39,0,2,0x03,0x02,
0x39,0,2,0x90,0x00,
0x39,0,19,0x91,0x89,0x28,0x00,0x0C,0xC2,0x00,0x03,0x58,0x01,0x8A,0x00,0x10,0x08,0xBB,0x03,0xD1,0x10,0xF0,
0x39,0,1,0x2C,
0x39,0,2,0x2F,0x01,


};

#endif


static void init_panel(void)
{
    /* reset panel*/
    tx_panel_reset();

    /* enter send initial code mode*/
    hal_dsi_tx_ctrl_enter_init_panel_mode();
	
#if AMOLED_NT37701_CSOT667 
	
#if PANEL_INIT_CODE_ARRAY
	send_panel_init_code(sizeof(panel_init_code), panel_init_code);
#endif

	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0x00, 0x01);  //0FFF
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x11);	 
	hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_HIGH); //LED_ON
	delayMs(90);   //90
	Gpio_swire_output(2, 32);   //40
	delayMs(20);
//	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);	
//	delayMs(20);
#endif	

	/* exit send initial code mode*/
	hal_dsi_tx_ctrl_exit_init_panel_mode();
	TAU_LOGD("Pannel init done");
	delayMs(20);
}
static void frame_start_cb(void)
{
	if(curFrame<10)		//ϵ򿪻һ restart rx 
	curFrame++;
	if((phone_DisplayOFF_flag) && (curFrame == 3))
	{	
		s_restart_flag = true;
//		hal_dsi_rx_ctrl_restart(g_rx_ctrl_handle);

		TAU_LOGD("restart rx1");
		
	}
}

void rx_restart_exec(void)
{
	if(s_restart_flag == true)
	{
		delayMs(50);
		TAU_LOGD("restart rx2");
		s_restart_flag = false;
		hal_dsi_rx_ctrl_restart(g_rx_ctrl_handle);
	}
}

static void open_mipi_rx(void)
{
    /* TE */
    hal_gpio_set_mode(IO_PAD_AP_TE, IO_MODE_TEAR);

    if (g_rx_ctrl_handle == NULL)
    {
        /* rx   ctrl handle */
        g_rx_ctrl_handle = hal_dsi_rx_ctrl_create_handle();
    }
    /* ò */
    g_rx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
    g_rx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
    g_rx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
    g_rx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
    g_rx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
    g_rx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
    g_rx_ctrl_handle->rx_color_mode = INPUT_COLOR_MODE;
    g_rx_ctrl_handle->rx_lanes = INPUT_MIPI_LANE_NUM;
    g_rx_ctrl_handle->rx_nonburst_models = INPUT_VIDEO_MODEL; /* ɲ */
    g_rx_ctrl_handle->rx_vc = INPUT_VC;
    g_rx_ctrl_handle->compress_en = INPUT_COMPRESS;
    g_rx_ctrl_handle->rx_hsclk_rate = INPUT_MIPI_LANE_RATE;
    g_rx_ctrl_handle->cus_dcs_entry_table = g_cus_rx_dcs_execute_table; /* ע DCSб */
    g_rx_ctrl_handle->rx_dcs_read_entry = ap_dcs_read; /* עdsc read ص,ѡ,˺Ϊʱcus_dcs_entry_tableִ */
    g_rx_ctrl_handle->pps_update_entry = pps_update_handle;
	g_rx_ctrl_handle->rx_debug_cb = frame_start_cb;
    //򿪻ᵼ¿ӡϢTX
//	g_rx_ctrl_handle->pq_marginal = PQ_TYPE_2;

#if defined(ISP_568) || defined(ISP_368)
    g_rx_ctrl_handle->base_info.extra_info.rot_angle = VIDOE_ROT_ANGLE_0;
    g_rx_ctrl_handle->base_info.extra_info.mirror_en = false;
	
    g_rx_ctrl_handle->hight_performan_mode = HIGHT_PERFORMAN_L2;	
    g_rx_ctrl_handle->base_info.extra_info.ltpo = LTPO_MODE_2;	
    g_rx_ctrl_handle->pu_optimize = true;		
	
#endif	
		
    /* ǰԤPPS,  AP PPS cmdҲ */
    if (g_rx_ctrl_handle->compress_en == true)
    {
		//720*1600
//		uint8_t pps[88] = { 0x11,0x00,0x00,0x89,0x30,0x80,0x06,0x40,0x02,0xD0,0x00,0x50,0x01,0x68,0x01,0x68,
//							0x02,0x00,0x01,0xB4,0x00,0x20,0x06,0x2F,0x00,0x05,0x00,0x0C,0x01,0x38,0x01,0xE9,
//							0x18,0x00,0x10,0xF0,0x03,0x0C,0x20,0x00,0x06,0x0B,0x0B,0x33,0x0E,0x1C,0x2A,0x38,
//							0x46,0x54,0x62,0x69,0x70,0x77,0x79,0x7B,0x7D,0x7E,0x01,0x02,0x01,0x00,0x09,0x40,
//							0x09,0xBE,0x19,0xFC,0x19,0xFA,0x19,0xF8,0x1A,0x38,0x1A,0x78,0x1A,0xB6,0x2A,0xF6,
//							0x2B,0x34,0x2B,0x74,0x3B,0x74,0x6B,0xF4};
		
		
		//1080*2400
		uint8_t pps[88] = { 0x11,0x00,0x00,0x89,0x30,0x80,0x09,0x60,0x04,0x38,0x00,0x28,0x02,0x1C,0x02,0x1C,
							0x02,0x00,0x02,0x0E,0x00,0x20,0x03,0xDD,0x00,0x07,0x00,0x0C,0x02,0x77,0x02,0x8B,
							0x18,0x00,0x10,0xF0,0x03,0x0C,0x20,0x00,0x06,0x0B,0x0B,0x33,0x0E,0x1C,0x2A,0x38,
							0x46,0x54,0x62,0x69,0x70,0x77,0x79,0x7B,0x7D,0x7E,0x01,0x02,0x01,0x00,0x09,0x40,
							0x09,0xBE,0x19,0xFC,0x19,0xFA,0x19,0xF8,0x1A,0x38,0x1A,0x78,0x1A,0xB6,0x2A,0xF6,
							0x2B,0x34,0x2B,0x74,0x3B,0x74,0x6B,0xF4};
 
		//1440*3200
//		uint8_t pps[88] = { 0x11,0x00,0x00,0x89,0x30,0x80,0x0C,0x80,0x05,0xA0,0x00,0x28,0x02,0xD0,0x02,0xD0,
//							0x02,0x00,0x02,0x68,0x00,0x20,0x04,0x6C,0x00,0x0A,0x00,0x0C,0x02,0x77,0x01,0xE9,
//							0x18,0x00,0x10,0xF0,0x03,0x0C,0x20,0x00,0x06,0x0B,0x0B,0x33,0x0E,0x1C,0x2A,0x38,
//							0x46,0x54,0x62,0x69,0x70,0x77,0x79,0x7B,0x7D,0x7E,0x01,0x02,0x01,0x00,0x09,0x40,
//							0x09,0xBE,0x19,0xFC,0x19,0xFA,0x19,0xF8,0x1A,0x38,0x1A,0x78,0x1A,0xB6,0x2A,0xF6,
//							0x2B,0x34,0x2B,0x74,0x3B,0x74,0x6B,0xF4};
	
//        uint8_t pps[128] =
//        {
//            0x11, 0x00, 0x00, 0x89, 0x30, 0x80, 0x0C, 0x80,
//            0x05, 0xA0, 0x00, 0x28, 0x02, 0xD0, 0x02, 0xD0,
//            0x02, 0x00, 0x02, 0x0E, 0x00, 0x20, 0x03, 0xDD,
//            0x00, 0x07, 0x00, 0x0C, 0x02, 0x77, 0x02, 0x8B,
//            0x18, 0x00, 0x10, 0xF0, 0x03, 0x0C, 0x20, 0x00,
//            0x06, 0x0B, 0x0B, 0x33, 0x0E, 0x1C, 0x2A, 0x38,
//            0x46, 0x54, 0x62, 0x69, 0x70, 0x77, 0x79, 0x7B,
//            0x7D, 0x7E, 0x01, 0x02, 0x01, 0x00, 0x09, 0x40,
//            0x09, 0xBE, 0x19, 0xFC, 0x19, 0xFA, 0x19, 0xF8,
//            0x1A, 0x38, 0x1A, 0x78, 0x1A, 0xB6, 0x2A, 0xF6,
//            0x2B, 0x34, 0x2B, 0x74, 0x3B, 0x74, 0x6B, 0xF4,
//            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//        };

		hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps, 88);
    }

    /* ʼrx ctrl */
    hal_dsi_rx_ctrl_init(g_rx_ctrl_handle);

	hal_dsi_rx_ctrl_set_cus_sync_line(g_rx_ctrl_handle, g_rx_ctrl_handle->base_info.src_h);  // lss add, ˺1600
//    hal_dsi_rx_ctrl_hight_performan_mode(g_rx_ctrl_handle); 
    /* rx ctrl */
	//hal_dsi_rx_ctrl_set_cus_esc_clk(g_rx_ctrl_handle,20000000);
	
    //hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,256, 256, 211);
    
    //hal_dsi_rx_ctrl_set_hw_cmd_filter(g_rx_ctrl_handle, HAL_RX_DCS_FILTER_0, 0x4C, 0x4C);
    //hal_dsi_rx_ctrl_set_hw_cmd_filter(g_rx_ctrl_handle, HAL_RX_DCS_FILTER_1, 0x5C, 0x5C);
#if CUS_SCLD_FILTER
    hal_dsi_rx_ctrl_set_cus_scld_filter( g_rx_ctrl_handle, rx_filter_1440_h_4_72, rx_filter_3200_v_4_59 ); 
#endif
	 hal_dsi_rx_ctrl_start(g_rx_ctrl_handle);
}


static void init_mipi_tx(void)
{
    if (g_tx_ctrl_handle == NULL)
    {
        g_tx_ctrl_handle = hal_dsi_tx_ctrl_create_handle();
    }
    g_tx_ctrl_handle->channel_id = OUTPUT_VC;
    g_tx_ctrl_handle->lane_num = OUTPUT_LANE_NUMBER;
    g_tx_ctrl_handle->vid_mode = OUTPUT_VIDEO_MODEL;
    g_tx_ctrl_handle->cmd_tx_type = _CMD_TYPE;
    g_tx_ctrl_handle->dpi_vsa = OUTPUT_VSA;
    g_tx_ctrl_handle->dpi_vbp = OUTPUT_VBP;
    g_tx_ctrl_handle->dpi_vfp = OUTPUT_VFP;
    g_tx_ctrl_handle->dpi_hsa = OUTPUT_HSA;
    g_tx_ctrl_handle->dpi_hbp = OUTPUT_HBP;
    g_tx_ctrl_handle->dpi_hfp = OUTPUT_HFP;
    g_tx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
    g_tx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
    g_tx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
    g_tx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
    g_tx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
    g_tx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
//	g_tx_ctrl_handle->tx_clkawayshs = true;
//	g_tx_ctrl_handle->tx_line_delay = 400;  //45;  
	g_tx_ctrl_handle->tx_frame_rate = OUTPUT_FRAME_RATE;

    hal_dsi_tx_ctrl_init(g_tx_ctrl_handle);
    /* AP ûзʱĬϵʾɫ, Ϊ0 0 0(ɫ), ɫΪdebugʹ */
    hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00);
}

static void tx_display_on(void)
{
    init_panel();
	hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
	
	delayMs(100);
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);	
}

static void swire_timer_callback(void *data)
{
#if 0 //def USE_FOR_SUMSUNG_S21U
	if(Flag_blacklight_EN)
	{
	  hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM);
	}
	else if(s20_power_on_flag)
	{
	  hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM);
	}
	else
#endif		
	{
    hal_swire_start(12, 12, 12, 12, swire_num);
	}
}

static void swire_callback(void *data)
{
    /* swire ǷҪһֱҪֻֻͬͬ */
    //if(start_display_on == false)
    {
        hal_timer_start(SWIRE_TIMER, 17, swire_timer_callback, NULL);
    }
}

/* swire ʼ,ͨ hal_swire_start , ѭһֱ */
static void swire_init()
{
    hal_swire_open(DISABLE);
    hal_swire_init();
    /* swire ηɺص */
    hal_swire_register_callback(swire_callback);
    hal_swire_open(ENABLE);
    //hal_swire_start(12, 12, 12, 12, 43);
    hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM); //3~27,~,9.45V~7.43V
    hal_timer_init(SWIRE_TIMER);
    hal_timer_start(SWIRE_TIMER, 17, swire_timer_callback, NULL);
}

static void soft_te_timer_cb(void *data)
{
    /*
        S8 ӵTP1.8V, AC ҪȵTP1.8 ٳʼ, TP ǰҪͨTEֻֻ
    */
    if (panel_display_done == false)
    {
        hal_dsi_rx_ctrl_gen_a_tear_signal(g_rx_ctrl_handle);
        hal_timer_start(TE_TIMER, 17, soft_te_timer_cb, NULL);
    }
    else
    {
        hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
    }
}

static void soft_te_timer_init()
{
  //  //TAU_LOGD("soft_te_timer_init");
    hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
    hal_timer_init(TE_TIMER);
    hal_timer_start(TE_TIMER, 1, soft_te_timer_cb, NULL);
}

#ifdef ADD_TIMER3_FUNCTION
static void soft_timer3_cb(void *data)
{
	hal_timer_start(TIMER_NUM3, 10, soft_timer3_cb, NULL);
	g_tp_sleep_delay_count++;
	tp_sleep_count++;
	if(phone_DisplayOFF_count>0)
	{
		phone_DisplayOFF_count++;
	}

#if AUTO_CAL_TP
	if (g_exit_sleep_mode)
	{
		if (g_cal_cnt > 0)
		{
			g_cal_cnt--;
			if (g_cal_cnt == 0){
				g_calibration_flag = true;
				//TAU_LOGD("Start cal tp!\n");
			}
		}
	}
#endif
}
#endif

void tp_heartbeat_exec(void)
{
	if (s_screen_init_complate)
	{
		if(hal_gpio_get_input_data(IO_PAD_TD_INT))
		{
			s_heartbeat = 0;
		}
		else
		{
			if(s_heartbeat < (65536/50))  // 65536*3 = 900ms  65536/50 = 6ms
			{
		        s_heartbeat ++;
		    }else
			{
		        TAU_LOGD("hb...");
		        s_heartbeat = 0;
				//		ap_tp_st_touch_software_reset();
						ap_tp_st_touch_hardware_reset();
		    }
		}
	}
}

void pps_updata_exec(void)
{
	if( true == s_pps_updata_allpixeloff_flag) // PPS ????
	{
        if( hal_system_get_tick() -  BaseTime > 80 ) 
        {
            hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x13);
            s_pps_updata_allpixeloff_flag = false;
        }
	}
}


void ap_demo(void)
{
//	hal_gpio_init_output(IO_PAD_TD_LEDPWM, IO_LVL_LOW);// C2  MOS 
//	hal_gpio_init_output(IO_PAD_TD_TPRSTN, IO_LVL_HIGH);	
//	hal_gpio_init_output(IO_PAD_AP_SWIRE, IO_LVL_LOW);	
//	hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_LOW);  // LED_ON
    
    hal_gpio_init_output(AP_SWIRE, IO_LVL_LOW);
	hal_gpio_init_output(AVDD_SWIRE, IO_LVL_LOW);
    hal_gpio_init_output(IO_PAD_TD_TPRSTN, IO_LVL_HIGH);	
	
	open_mipi_rx();
	TAU_LOGD("S21U V100 20230914");
	
	app_tp_I2C_init();
//	soft_te_timer_init();
	init_mipi_tx();
	
	app_tp_transfer_screen_start_init();
	app_tp_init();
#ifdef ADD_TIMER3_FUNCTION
	tp_sleep_count=0;
	phone_DisplayOFF_count=1;
	g_tp_sleep_delay_count = 0;
	hal_timer_init(TIMER_NUM3);
	hal_timer_start(TIMER_NUM3, 10, soft_timer3_cb, NULL);
#endif		

	swire_init();  
	
	while (1)
    {
        if (start_display_on == true )
        {
            tx_display_on();
            start_display_on = false;
            panel_display_done = true;			
					
		#if ENABLE_TP_WAKE_UP
			hal_gpio_set_ap_reset_int(ENABLE, ap_reset_cb, DETECT_RISING_EDGE);
		#endif	
        }
	#ifndef DISABLE_TDDI_I2C_FUNCTION
		/* TP ģͨѶʼ */
		app_tp_transfer_screen_start();
	#endif

		if(phone_DisplayOFF_flag==1)
		{	
			if(phone_DisplayOFF_count>1600)
			{
				phone_DisplayOFF_count=0;
				phone_start_flag=1;
			}
		}
		else
		{
			if(phone_DisplayOFF_count>30)
			{
				phone_DisplayOFF_count=0;
				phone_start_flag=1;
				hal_gpio_set_output_data(IO_PAD_AP_INT, IO_LVL_LOW);//ͣ˫2~3s޴.jason_su
			}			
		}
		
		pps_updata_exec();	// pps

	#if ADD_TP_CALIBRATION
        tp_heartbeat_exec();
		app_tp_calibration_exec();
        ap_tp_st_touch_scan_point_record_event_exec();
	#endif	
		
	#ifndef DISABLE_TDDI_I2C_FUNCTION
		/* ȴ TP жϱTP Эת */ 
		app_tp_transfer_screen_int();
	#endif
		rx_restart_exec();
        while (hal_dsi_rx_ctrl_dsc_async_handler(g_rx_ctrl_handle)); 
			
	#if ENABLE_TP_WAKE_UP			
		if (g_need_enter_sleep_mode)
		{
			tp_sleep_in=1;
			hal_gpio_set_output_data(IO_PAD_TD_LEDPWM, IO_LVL_HIGH); 
 
			/* FIXME stop more model */
			hal_dsi_tx_ctrl_stop(g_tx_ctrl_handle);
			hal_dsi_tx_ctrl_deinit(g_tx_ctrl_handle);
			hal_dsi_rx_ctrl_stop(g_rx_ctrl_handle);
			hal_dsi_rx_ctrl_deinit(g_rx_ctrl_handle);
			
			hal_swire_open(DISABLE);
			hal_swire_deinit();
			hal_timer_stop(SWIRE_TIMER);
			hal_timer_deinit(SWIRE_TIMER);
			g_tp_sleep_in = true;
			hal_system_set_vcc(false);
			TAU_LOGD("disable video path\n"); 
			g_need_enter_sleep_mode = false;
		}
	#endif

        /* enter idle mode*/
        //hal_system_idle_mode(true);
    }
		
}
